"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var http_1 = require("@angular/http");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../models/sharedService");
var sbm_http_client_service_1 = require("../../services/sbm-http-client.service");
var AutocompleteComponent = /** @class */ (function (_super) {
    __extends(AutocompleteComponent, _super);
    function AutocompleteComponent(_req, _translateService, _http, _sharedService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._req = _req;
        _this._translateService = _translateService;
        _this._http = _http;
        _this._sharedService = _sharedService;
        _this._dataSource = [];
        _this.dataAutocomplete = [];
        _this.labelWidth = '';
        _this.datasource = [];
        sbmAutocompleteComponent.push(_this);
        return _this;
    }
    Object.defineProperty(AutocompleteComponent.prototype, "dataSource", {
        get: function () {
            return this.datasource;
        },
        set: function (val) {
            if (typeof val == 'string') {
                this.reqService(val);
            }
            else if (typeof val == 'object') {
                this._dataSource = val;
                this.dataAutocomplete = val;
            }
        },
        enumerable: true,
        configurable: true
    });
    AutocompleteComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
    };
    AutocompleteComponent.prototype.ngAfterViewInit = function () {
        var me = this;
        $(this.input.nativeElement).attr('style', this.styleCss);
        this.css += ' sbm-input';
        this._columns += ' ' + this.css;
    };
    AutocompleteComponent.prototype.reqService = function (val) {
        var _this = this;
        if (this._dataSource.length == 0) {
            this._req.get("/" + _projectCodigo + "/api/" + val).subscribe(function (ret) {
                if (ret[_this.reqIndexKey]) {
                    _this._dataSource = ret[_this.reqIndexKey];
                    _this.dataAutocomplete = ret[_this.reqIndexKey];
                }
                else {
                    _this._dataSource = ret;
                    _this.dataAutocomplete = ret;
                }
            });
        }
    };
    AutocompleteComponent.prototype.itemClicado = function (event) {
        this._onClick.emit(event);
        if (this.onClick != '') {
            window[this.onClick](event);
        }
        this.value = event[this.text[0]];
    };
    AutocompleteComponent.prototype.blur = function ($event) {
        this._onBlur.emit($event);
    };
    AutocompleteComponent.prototype.keyup = function ($event) {
        var _this = this;
        var me = this;
        var value = $event.target.value;
        this.dataAutocomplete = [];
        if (value != '') {
            this._dataSource.filter(function (v, i, a) {
                for (var _i = 0, _a = _this.text; _i < _a.length; _i++) {
                    var item = _a[_i];
                    if (v[item]) {
                        if (v[item].toString().toLowerCase().indexOf(value.toLowerCase()) > -1) {
                            me.dataAutocomplete.push(v);
                        }
                    }
                }
            });
        }
        this._onKeyup.emit($event);
    };
    AutocompleteComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'sbm-autocomplete',
                    template: require('./autocomplete.component.html'),

                    host: {
                        '[class]': 'columns'
                    },
                    providers: [
                        abstract_ngmodel_1.MakeProvider(AutocompleteComponent),
                        { provide: abstract_ngmodel_1.AbstractNgModel, useExisting: core_1.forwardRef(function () { return AutocompleteComponent; }) }
                    ]
                },] },
    ];
    /** @nocollapse */
    AutocompleteComponent.ctorParameters = function () { return [
        { type: sbm_http_client_service_1.SbmHttpClientService, },
        { type: core_2.TranslateService, },
        { type: http_1.Http, },
        { type: sharedService_1.SharedService, },
    ]; };
    AutocompleteComponent.propDecorators = {
        "input": [{ type: core_1.ViewChild, args: ['autocomplete',] },],
        "listautocomplete": [{ type: core_1.ViewChild, args: ['listautocomplete',] },],
        "component2": [{ type: core_1.ViewChild, args: ['component2',] },],
        "dataSource": [{ type: core_1.Input, args: ['datasource',] },],
    };
    return AutocompleteComponent;
}(abstract_ngmodel_1.AbstractNgModel));
exports.AutocompleteComponent = AutocompleteComponent;
