"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var BreadcrumbCrudComponent = /** @class */ (function () {
    function BreadcrumbCrudComponent(_router) {
        this._router = _router;
        this.breadcrumbs = [];
        this.css = 'sbm-breadcrumb';
    }
    BreadcrumbCrudComponent.prototype.navegar = function (breadcrumb) {
        BreadcrumbCrudComponent.breadcrumbAlterado.emit(breadcrumb);
        this._router.navigate([breadcrumb.url]);
    };
    BreadcrumbCrudComponent.prototype.ngOnInit = function () {
        var _this = this;
        this._router.events.subscribe(function (ret) {
            _this.breadcrumbs = [];
            _this.parseRoute(_this._router.routerState.snapshot.root);
        });
    };
    BreadcrumbCrudComponent.prototype.parseRoute = function (node) {
        var me = this;
        if (node.data['breadcrumbCrud']) {
            node.data['breadcrumbCrud'].map(function (o) {
                var bc = {
                    localStogare: window.location.href,
                    name: o['name'],
                    url: o['url']
                };
                me.breadcrumbs.push(bc);
            });
        }
        if (node.firstChild) {
            this.parseRoute(node.firstChild);
        }
    };
    BreadcrumbCrudComponent.breadcrumbAlterado = new core_1.EventEmitter();
    BreadcrumbCrudComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'sbm-breadcrumb-crud',
                    template: require('./breadcrumb-crud.component.html'),

                    host: {
                        'class': 'col s12'
                    }
                },] },
    ];
    /** @nocollapse */
    BreadcrumbCrudComponent.ctorParameters = function () { return [
        { type: router_1.Router, },
    ]; };
    BreadcrumbCrudComponent.propDecorators = {
        "css": [{ type: core_1.Input },],
    };
    return BreadcrumbCrudComponent;
}());
exports.BreadcrumbCrudComponent = BreadcrumbCrudComponent;
