"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var CalcComponent = /** @class */ (function () {
    function CalcComponent() {
        this.screen = '0';
        this.eraseAfterResult = false;
        this.results = [];
        this.modalVisible = false;
    }
    CalcComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        this.resultsListItem.changes.subscribe(function (newItem) {
            _this.resultsList.nativeElement.scrollTop += 500;
        });
    };
    CalcComponent.prototype.onKeyUp = function (ev) {
        if ((ev.keyCode >= 97 && ev.keyCode <= 105) || (ev.keyCode >= 49 && ev.keyCode <= 57 && ev.shiftKey == false)) {
            this.printNumber(ev.key);
        }
        if (ev.keyCode == 190 || ev.keyCode == 110 || ev.keyCode == 188 || ev.keyCode == 108) {
            this.printDot();
        }
        if (ev.keyCode == 96 || ev.keyCode == 48) {
            this.printZero();
        }
        if (ev.keyCode == 13) {
            this.calc();
        }
        if (ev.keyCode == 8) {
            this.clearOperation();
        }
        if (ev.keyCode == 46) {
            this.clearAll();
        }
        if (ev.keyCode == 107 || ev.keyCode == 187) {
            this.setOperation('+');
        }
        if (ev.keyCode == 109 || ev.keyCode == 189) {
            this.setOperation('-');
        }
        if (ev.keyCode == 106 || (ev.keyCode == 56 && ev.shiftKey == true)) {
            this.setOperation('*');
        }
        if (ev.keyCode == 111 || ev.keyCode == 191) {
            this.setOperation('/');
        }
        if (ev.keyCode == 53 && ev.shiftKey) {
            this.setPercent();
        }
    };
    CalcComponent.prototype.printNumber = function (n) {
        if (this.screen !== '0') {
            if (this.eraseAfterResult) {
                this.screen = n;
            }
            else {
                if (/[\+\-\*\/\%]0$/.test(this.screen)) {
                    this.screen = this.screen.replace(/0$/, n);
                }
                else {
                    this.screen += n;
                }
            }
        }
        else {
            this.screen = n;
        }
        this.eraseAfterResult = false;
    };
    CalcComponent.prototype.setScreen = function (v) {
        this.screen = v;
        this.eraseAfterResult = false;
    };
    CalcComponent.prototype.printZero = function () {
        if (/(([\+\-\*\/\%])|(\.)|([1-9])|([1-9\.]0+))$/.test(this.screen)) {
            if (this.eraseAfterResult) {
                this.screen = '0';
            }
            else {
                this.screen += '0';
            }
        }
        this.eraseAfterResult = false;
    };
    CalcComponent.prototype.setOperation = function (op) {
        if (/[^\+\-\*\/\%\.]$/.test(this.screen)) {
            this.screen += op;
        }
        this.eraseAfterResult = false;
    };
    CalcComponent.prototype.setPercent = function () {
        var matchs = this.screen.match(/(.*[0-9]([\+\-\*\/]))(([0-9]+\.)?[0-9]+)$/);
        if (matchs !== null) {
            var preResult = eval(matchs[1].slice(0, -1));
            var percent = Number(matchs[3]) / 100;
            var finalResult = 0;
            switch (matchs[2]) {
                case '+':
                case '-':
                    finalResult = eval(preResult + matchs[2] + (preResult * percent));
                    break;
                case '/':
                    finalResult = eval(matchs[1].slice(0, -1) + '*' + 100 / Number(matchs[3]));
                    break;
                case '*':
                    finalResult = eval(preResult + matchs[2] + (preResult * percent));
                    break;
            }
            var calc = { calc: this.screen + '%', result: finalResult };
            this.results.push(calc);
            this.eraseAfterResult = true;
            this.screen = '' + calc.result;
            CalcComponent.onCalc.emit(this.screen);
        }
        this.eraseAfterResult = false;
    };
    CalcComponent.prototype.printDot = function () {
        if (/(^$)|(^[0-9]*$)|([\/\+\-\*\%][^\.][0-9]*$)/.test(this.screen)) {
            this.screen += '.';
            this.eraseAfterResult = false;
        }
    };
    CalcComponent.prototype.calc = function () {
        if (/[0-9][\+\-\*\/](([0-9]+\.)?[0-9]+)$/.test(this.screen)) {
            var calc = { calc: this.screen, result: eval(this.screen) };
            this.results.push(calc);
            this.eraseAfterResult = true;
            this.screen = '' + calc.result;
            CalcComponent.onCalc.emit(this.screen);
        }
        else {
            if (/%$/.test(this.screen)) {
                this.screen = this.screen.slice(0, -1);
                this.setPercent();
            }
            this.eraseAfterResult = false;
        }
    };
    CalcComponent.prototype.erase = function () {
        this.screen = this.screen.slice(0, -1);
        this.eraseAfterResult = false;
        if (this.screen.length == 0) {
            this.screen = '0';
        }
    };
    CalcComponent.prototype.clearAll = function () {
        this.screen = '0';
        this.eraseAfterResult = false;
    };
    CalcComponent.prototype.clearOperation = function () {
        this.screen = this.screen.replace(/((?![\+\*\/\%])|(^-))(([0-9]*\.)?[0-9]*)$/, '');
        if (this.screen.length == 0) {
            this.screen = '0';
        }
        this.eraseAfterResult = false;
    };
    CalcComponent.onCalc = new core_1.EventEmitter();
    CalcComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'sbm-calc',
                    template: require('./calc.component.html'),

                    styles: [require('./calc.component.css')],
               },] },
    ];
    /** @nocollapse */
    CalcComponent.ctorParameters = function () { return []; };
    CalcComponent.propDecorators = {
        "resultsList": [{ type: core_1.ViewChild, args: ['resultsList',] },],
        "resultsListItem": [{ type: core_1.ViewChildren, args: ['resultsListItem',] },],
        "onKeyUp": [{ type: core_1.HostListener, args: ['document:keyup', ['$event'],] },],
    };
    return CalcComponent;
}());
exports.CalcComponent = CalcComponent;
