"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var core_2 = require("@ngx-translate/core");
var http_1 = require("@angular/http");
var sharedService_1 = require("../../models/sharedService");
var ColorPickerComponent = /** @class */ (function (_super) {
    __extends(ColorPickerComponent, _super);
    function ColorPickerComponent(_translateService, _http, _sharedService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._translateService = _translateService;
        _this._http = _http;
        _this._sharedService = _sharedService;
        _this.open = false;
        _this._color = "";
        sbmColorPickComponent.push(_this);
        return _this;
    }
    Object.defineProperty(ColorPickerComponent.prototype, "color", {
        get: function () {
            return this._color;
        },
        set: function (val) {
            // this.value = val;
            this._color = val;
        },
        enumerable: true,
        configurable: true
    });
    ColorPickerComponent.prototype.change = function (color) {
        this.value = color;
    };
    ColorPickerComponent.prototype.openColor = function () {
        this.open = true;
    };
    ColorPickerComponent.prototype.ngOnInit = function () {
        var _this = this;
        _super.prototype.validar.call(this, this.securityId);
        this.subscription = this.onChangeValue.subscribe(function (ret) {
            if (ret) {
                _this.color = ret;
            }
        });
        this.css += " sbm-input";
        this.classCss += " " + this.css;
    };
    ColorPickerComponent.prototype.ngOnDestroy = function () {
        this.subscription.unsubscribe();
    };
    ColorPickerComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: "sbm-color-picker",
                    template: require('./color-picker.component.html'),

                    host: {
                        "[class]": "classCss"
                    },
                    providers: [
                        abstract_ngmodel_1.MakeProvider(ColorPickerComponent),
                        {
                            provide: abstract_ngmodel_1.AbstractNgModel,
                            useExisting: core_1.forwardRef(function () { return ColorPickerComponent; })
                        }
                    ]
                },] },
    ];
    /** @nocollapse */
    ColorPickerComponent.ctorParameters = function () { return [
        { type: core_2.TranslateService, },
        { type: http_1.Http, },
        { type: sharedService_1.SharedService, },
    ]; };
    ColorPickerComponent.propDecorators = {
        "input": [{ type: core_1.ViewChild, args: ["inputColor",] },],
    };
    return ColorPickerComponent;
}(abstract_ngmodel_1.AbstractNgModel));
exports.ColorPickerComponent = ColorPickerComponent;
