"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var funcoes_component_1 = require("../../../models/funcoes.component");
var abstract_ngmodel_1 = require("../../../models/abstract.ngmodel");
var core_1 = require("@angular/core");
var http_1 = require("@angular/common/http");
var upload_component_1 = require("../../upload/upload.component");
var master_detail_component_1 = require("../../master-detail/master-detail.component");
var material_1 = require("@angular/material");
var dialog_audit_component_1 = require("../dialog-audit/dialog-audit.component");
var notification_component_1 = require("../../notification/notification.component");
var forms_1 = require("@angular/forms");
var AbstractCrud = /** @class */ (function () {
    function AbstractCrud(sbmHttpClient, dialog) {
        this.sbmHttpClient = sbmHttpClient;
        this.dialog = dialog;
        this.reqServiceStatus = [];
        this.update = { update: false };
        this.parametersKeyService = new http_1.HttpParams();
    }
    AbstractCrud.prototype.audit = function (entity, id) {
        var _this = this;
        this.sbmHttpClient.get("/sabium/api/auditoria/aplicacao/" + _projectCodigo + "/entidade/" + entity + "/registro/" + id.selectedRowsData[0].id).subscribe(function (ret) {
            if (ret) {
                var audit = ret.data;
                audit.forEach(function (ret) {
                    ret['data'] = funcoes_component_1.FuncoesComponent.formatarData(ret.dataHora);
                    switch (ret["operacao"]) {
                        case "INCLUSAO":
                            ret["operacao"] = "Inclusão";
                            break;
                        case "ATUALIZACAO":
                            ret["operacao"] = "Atualização";
                            break;
                        case "REMOCAO":
                            ret["operacao"] = "Remoção";
                            break;
                    }
                    var details = JSON.parse(ret.detalhes);
                    details.forEach(function (element) {
                        var keys = Object.keys(element);
                        element['lista'] = [];
                        keys.forEach(function (key) {
                            element['lista'].push({ chave: key, valor: element[key] });
                            // lista.push({'item': element, lista: element['lista']})
                        });
                    });
                    ret['detalhesLista'] = details;
                });
                if (ret.data.length > 0) {
                    var configDialog = Object.assign(new material_1.MatDialogConfig(), {
                        height: '600px',
                        data: audit
                    });
                    _this.dialog.open(dialog_audit_component_1.DialogAuditDetail, configDialog);
                }
            }
            else {
                var notification = new notification_component_1.NotificationComponent;
                notification.show('Não existem alterações para este registro!');
            }
        });
    };
    AbstractCrud.makeId = function () {
        var text = '';
        var possibleGenerate = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
        for (var i = 0; i < 14; i++) {
            text += possibleGenerate.charAt(Math.floor(Math.random() * possibleGenerate.length));
        }
        return "sbm-" + text;
    };
    AbstractCrud.prototype.verificaSeTemPropriedadeObjectNosComponentesEdicao2 = function (data) {
        var ret = {};
        if (this.abstractComp2 && this.abstractComp2.length > 0) {
            this.abstractComp2.forEach(function (item, index) {
                if (!(item instanceof upload_component_1.UploadComponent)) {
                    if (item['isNotMasterDetail']) {
                        if (item['object']) {
                            ret[item['attribute']] = data[item['object']][item['attribute']];
                        }
                        else {
                            ret[item['attribute']] = data[item['attribute']];
                        }
                    }
                }
            });
        }
        if (this.masterDetailComp2 && this.masterDetailComp2.length > 0) {
            this.masterDetailComp2.forEach(function (item, index) {
                ret[item['attribute']] = data[item['attribute']];
            });
        }
        return ret;
    };
    AbstractCrud.prototype.crudSetValue = function (data) {
        var controls = Object.keys(data);
        if (controls.length) {
            for (var control in controls) {
                if (this.form.controls[controls[control]] !== undefined) {
                    this.form.controls[controls[control]].setValue(data[controls[control]]);
                    this.form.controls[controls[control]].markAsDirty();
                }
            }
        }
        else {
            for (var i in this.form.controls) {
                this.form.controls[i].setValue('');
            }
        }
    };
    AbstractCrud.prototype.callServiceKey = function () {
        var _this = this;
        var urlRest = '/sabium/api/' + ((this.abstractDinamic) ? 'entidade/' : '') + this.abstractEntity;
        var callService = true;
        this.reqServiceStatus.forEach(function (itm) {
            callService = !(!itm.valor || itm.valor == '');
        });
        if (callService) {
            var me_1 = this;
            this.sbmHttpClient.get(urlRest, this.parametersKeyService).subscribe(function (ret) {
                if (ret) {
                    var result = _this.verificaSeTemPropriedadeObjectNosComponentesEdicao2(ret.data[0]);
                    _this.update = {
                        update: true,
                        id: ret.data[0].id,
                        version: ret.data[0].version,
                        versionConstrain: null,
                        idConstrain: null
                    };
                    me_1.crudSetValue(result);
                }
            });
        }
    };
    AbstractCrud.prototype.verifNaturalKey = function (abstractComp, dinamic, entity) {
        var _this = this;
        this.abstractDinamic = dinamic;
        this.abstractEntity = entity;
        abstractComp.forEach(function (item) {
            if (item.naturalKey != '') {
                if (item['_onBlur']) {
                    item._onBlur.subscribe(function (ret) {
                        _this.parametersKeyService = _this.parametersKeyService.delete(item.naturalKey);
                        _this.parametersKeyService = _this.parametersKeyService.append(item.naturalKey, item.value);
                        _this.reqServiceStatus.push({ valor: item.value });
                        _this.callServiceKey();
                    });
                }
            }
        });
    };
    // gera form dinamico do crud
    // gera form dinamico do crud
    AbstractCrud.prototype.createFormDinamic = 
    // gera form dinamico do crud
    function (abstractComp) {
        var _this = this;
        abstractComp.forEach(function (item) {
            if (item.isNotMasterDetail) {
                _this.form.addControl(item.component);
            }
        });
    };
    AbstractCrud.propDecorators = {
        "abstractComp2": [{ type: core_1.ContentChildren, args: [abstract_ngmodel_1.AbstractNgModel, { descendants: true },] },],
        "masterDetailComp2": [{ type: core_1.ContentChildren, args: [master_detail_component_1.MasterDetailComponent, { descendants: true },] },],
        "_crudFrom2": [{ type: core_1.ViewChild, args: ['crudForm',] },],
        "form": [{ type: core_1.ViewChild, args: [forms_1.NgForm,] },],
    };
    return AbstractCrud;
}());
exports.AbstractCrud = AbstractCrud;
