"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var core_2 = require("@ngx-translate/core");
var devextreme_angular_1 = require("devextreme-angular");
var http_1 = require("@angular/http");
var ngx_webstorage_1 = require("ngx-webstorage");
var common_1 = require("@angular/common");
var sbm_module_1 = require("../../sbm-module/sbm.module");
var ng2_currency_mask_1 = require("ng2-currency-mask");
var crud_component_1 = require("./crud.component");
var CrudContainerComponent = /** @class */ (function () {
    function CrudContainerComponent(compiler, _el) {
        this.compiler = compiler;
        this._el = _el;
        this.modules = [
            common_1.CommonModule,
            forms_1.FormsModule,
            forms_1.ReactiveFormsModule,
            http_1.HttpModule,
            devextreme_angular_1.DevExtremeModule,
            sbm_module_1.SbmModule.forRoot(),
            ng2_currency_mask_1.CurrencyMaskModule,
            ngx_webstorage_1.Ng2Webstorage.forRoot({ prefix: '__SBM-SHARED__', separator: '/' }),
            core_2.TranslateModule.forRoot()
        ];
        this.compDinamic = [];
    }
    CrudContainerComponent.prototype.createComponentFactorySync = function (compiler, metadata) {
        var me = this;
        var decoratedCmp = core_1.Component(metadata)(/** @class */ (function () {
            function RuntimeComponent() {
                this.crudInit = new core_1.EventEmitter();
            }
            RuntimeComponent.prototype.ngAfterViewInit = function () {
                this.crudInit.emit(this.viewChildren.first);
            };
            return RuntimeComponent;
        }()));
        if (me.compDinamic.indexOf(decoratedCmp) === -1) {
            me.compDinamic.push(decoratedCmp);
            var RuntimeCrudComponentModule = /** @class */ (function () {
                function RuntimeCrudComponentModule() {
                }
                RuntimeCrudComponentModule.decorators = [
                    { type: core_1.NgModule, args: [{
                                imports: me.modules,
                                declarations: me.compDinamic,
                                schemas: [core_1.CUSTOM_ELEMENTS_SCHEMA, core_1.NO_ERRORS_SCHEMA]
                            },] },
                ];
                /** @nocollapse */
                RuntimeCrudComponentModule.ctorParameters = function () { return []; };
                return RuntimeCrudComponentModule;
            }());
            var module_1 = compiler.compileModuleAndAllComponentsSync(RuntimeCrudComponentModule);
            return module_1.componentFactories.find(function (f) { return f.componentType === decoratedCmp; });
        }
    };
    CrudContainerComponent.prototype.compileTemplateHtml = function (template) {
        var _this = this;
        var jsFilesUrls = [];
        var regex = /src=(["'])(.+\.js)\1/g;
        var matchJsUrls = regex.exec(template);
        while (matchJsUrls !== null) {
            jsFilesUrls.push(matchJsUrls[2]);
            matchJsUrls = regex.exec(template);
        }
        if (jsFilesUrls.length) {
            for (var i in jsFilesUrls) {
                var s = document.createElement('script');
                s.src = jsFilesUrls[i];
                document.getElementsByTagName('head')[0].appendChild(s);
            }
        }
        var metadata = {
            selector: "runtime-crud-component",
            template: template,
            queries: {
                viewChildren: new core_1.ViewChildren(core_1.forwardRef(function () { return crud_component_1.CrudComponent; }))
            },
        };
        var factory = this.createComponentFactorySync(this.compiler, metadata);
        if (this.componentRef) {
            this.componentRef.destroy();
            this.componentRef = null;
        }
        this.componentRef = this.container.createComponent(factory);
        this.componentRef.instance['crudInit'].subscribe(function (crud) {
            _this.crudFilho = crud;
        });
    };
    CrudContainerComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'sbm-crud-container',
                    template: "<div #container></div>"
                },] },
    ];
    /** @nocollapse */
    CrudContainerComponent.ctorParameters = function () { return [
        { type: core_1.Compiler, },
        { type: core_1.ElementRef, },
    ]; };
    CrudContainerComponent.propDecorators = {
        "container": [{ type: core_1.ViewChild, args: ['container', { read: core_1.ViewContainerRef },] },],
    };
    return CrudContainerComponent;
}());
exports.CrudContainerComponent = CrudContainerComponent;
