import { TabsErrorService } from './../tabs-error/tabs-error.service';
import { FiltersComponent } from './../filters/filters.component';
import { AfterViewInit, Compiler, ComponentFactoryResolver, ElementRef, EventEmitter, OnInit, QueryList, ViewContainerRef } from '@angular/core';
import { ReqHttpService } from '../../services/req-http.service';
import { ActivatedRoute, Router } from '@angular/router';
import { IBreadcrumbs } from '../../interfaces/IBreadcrumbs';
import { Subscription } from 'rxjs';
import { NotificationComponent } from '../notification/notification.component';
import { SelectComponent } from '../select/select.component';
import { MasterDetailComponent } from '../master-detail/master-detail.component';
import { InputTextComponent } from '../input/input-text/input-text.component';
import { InputTelefoneComponent } from '../input/input-telefone/input-telefone.component';
import { InputPasswordComponent } from '../input/input-password/input-password.component';
import { InputNumberComponent } from '../input/input-number/input-number.component';
import { InputMaskComponent } from '../input/input-mask/input-mask.component';
import { InputCepComponent } from '../input/input-cep/input-cep.component';
import { InputCnpjComponent } from '../input/input-cnpj/input-cnpj.component';
import { InputCpfComponent } from '../input/input-cpf/input-cpf.component';
import { InputEmailComponent } from '../input/input-email/input-email.component';
import { RadioComponent } from '../radio/radio.component';
import { ListViewComponent } from '../list-view/list-view.component';
import { DateboxComponent } from '../datebox/datebox.component';
import { UploadComponent } from '../upload/upload.component';
import { AutocompleteComponent } from '../autocomplete/autocomplete.component';
import { CheckboxComponent } from '../checkbox/checkbox.component';
import { MoneyComponent } from '../input/money/money.component';
import { TextareaComponent } from '../input/textarea/textarea.component';
import { MultiselectComponent } from '../multiselect/multiselect.component';
import { TranslateService } from '@ngx-translate/core';
import { DxDataGridComponent, DxPivotGridComponent } from 'devextreme-angular';
import { SharedService } from '../../models/sharedService';
import { Http } from '@angular/http';
import { AbstractNgModel } from '../../models/abstract.ngmodel';
import { AbstractCrud } from './abstract-crud/abstract-crud';
import { MatDialog } from '@angular/material';
import { SbmHttpClientService } from '../../services/sbm-http-client.service';
export declare class CrudActionButtonComponent {
}
export declare class CrudFormComponent implements OnInit {
    elementRef: string;
    elementHidden: boolean;
    ngOnInit(): void;
}
export declare class CrudComponent extends AbstractCrud implements OnInit, AfterViewInit {
    private _reqHttpService;
    private _sharedService;
    private componentFactoryResolver;
    private _translateService;
    _http: Http;
    private compiler;
    private _vcRef;
    _sbmHttpClient: SbmHttpClientService;
    private _router;
    dialog: MatDialog;
    private _activatedRoute;
    private _tabsError;
    private _el;
    constructor(_reqHttpService: ReqHttpService, _sharedService: SharedService, componentFactoryResolver: ComponentFactoryResolver, _translateService: TranslateService, _http: Http, compiler: Compiler, _vcRef: ViewContainerRef, _sbmHttpClient: SbmHttpClientService, _router: Router, dialog: MatDialog, _activatedRoute: ActivatedRoute, _tabsError: TabsErrorService, _el: ElementRef);
    hash: string;
    crudErrors: any;
    traducao: any;
    translateService: any;
    modulesDinamic: any[];
    crudFormComponent: QueryList<CrudFormComponent>;
    masterDetailComp: QueryList<MasterDetailComponent>;
    inputTextComp: QueryList<InputTextComponent>;
    inputTelefoneComp: QueryList<InputTelefoneComponent>;
    inputPasswordComp: QueryList<InputPasswordComponent>;
    inputNumberComp: QueryList<InputNumberComponent>;
    inputMaskComp: QueryList<InputMaskComponent>;
    inputCepComp: QueryList<InputCepComponent>;
    inputCnpjComp: QueryList<InputCnpjComponent>;
    inputCpfComp: QueryList<InputCpfComponent>;
    inputEmailComp: QueryList<InputEmailComponent>;
    radioComp: QueryList<RadioComponent>;
    listViewComp: QueryList<ListViewComponent>;
    dateBoxComp: QueryList<DateboxComponent>;
    uploadComp: QueryList<UploadComponent>;
    autoCompleteComp: QueryList<AutocompleteComponent>;
    checkBoxComp: QueryList<CheckboxComponent>;
    moneyComp: QueryList<MoneyComponent>;
    textareaComp: QueryList<TextareaComponent>;
    multiSelectComp: QueryList<MultiselectComponent>;
    selectComp: QueryList<SelectComponent>;
    abstractComp: QueryList<AbstractNgModel>;
    sbmCrudContent: ElementRef;
    _crudFrom: ElementRef;
    _buttonNext: ElementRef;
    _buttonAll: ElementRef;
    _loader: ElementRef;
    parametersEl: ElementRef;
    formCurdEl: ElementRef;
    _inputPerspec: ElementRef;
    gridResultCrud: DxDataGridComponent;
    sbmLayout: SelectComponent;
    sbmFiltroTabela: SelectComponent;
    sbmPivotGridChooser: any;
    pivotGridEl: DxPivotGridComponent;
    sbmFilter: FiltersComponent;
    sbmListview: ListViewComponent;
    inputSaveLayout: InputTextComponent;
    tabErrorsContainer: ViewContainerRef;
    filtroTabelaList: any;
    layoutCurrent: any;
    _onSelectGrid: EventEmitter<{}>;
    id: string;
    onSelectGrid: string;
    onClickEdit: string;
    onClickAdd: string;
    beforeSend: string;
    afterSend: string;
    onClickEditAfterRequest: string;
    onInit: string;
    disablebuttonadd: any;
    disablebuttonedit: any;
    disablebuttonremove: any;
    hidebuttonremove: any;
    entity: string;
    securityId: any;
    dynamic: string;
    entityEdit: string;
    urlBase: string;
    pathFilter: string;
    table: string;
    _label: string;
    label: string;
    masterDetail: boolean;
    perspective: boolean;
    _bpmn: boolean;
    bpmn: any;
    bpmnId: any;
    static resetarUploadFile: EventEmitter<{}>;
    selectItems: EventEmitter<{}>;
    clickedNew: EventEmitter<{}>;
    clickedEdit: EventEmitter<{}>;
    clickedCancel: EventEmitter<{}>;
    onModels: EventEmitter<{}>;
    onSave: EventEmitter<{}>;
    clickedEditAfterRequest: EventEmitter<{}>;
    _layout: any;
    layout: any;
    static emitChangeFilter: EventEmitter<{}>;
    static numero_registro_pagina: number;
    private _layoutDinamic;
    filterModel: any;
    name_search: any;
    default_search: any;
    crudContainer: any;
    masterDetailContainer: any;
    modelsForm: any;
    selectItem: any;
    parametersModels: any;
    models: any;
    dataSource: any;
    url: string;
    retornoParametros: any;
    setGrid: any;
    colunas: any;
    showHideColumnValue: any;
    crudLayoutGrid: any;
    crudFormAtive: boolean;
    addFormControl: boolean;
    formControlHidden: boolean;
    saveButton: boolean;
    buttonDisable: boolean;
    executedParameters: boolean;
    noErrosForm: boolean;
    servicePending: boolean;
    iBreadcrumbActive: any;
    bc: IBreadcrumbs;
    breadCrumbs: any[];
    breadC: Subscription;
    ActionButtons: Subscription;
    notification: NotificationComponent;
    countRegister: number;
    pageCurrent: number;
    valuePerspective: boolean;
    pivotGrid: any;
    showPivotConf: boolean;
    searchPanelColumn: boolean;
    buttonsActions: any;
    operationDescriptions: any;
    reloadBreadCrumb(): void;
    newBreadcrumb(): void;
    clickNew(): void;
    verificaSeTemPropriedadeObjectNosComponentesEdicao(data: any): {};
    clickEdit($data: any): void;
    clickDelete($data: any): void;
    cancel(): void;
    childrenCrud(data: any): void;
    verificaSeTemPropriedadeObjectNosComponentes(data: any): {
        custom: {};
    };
    selectFilter(event: any): void;
    onContextMenuPreparing($event: any): void;
    selectCell(e: any): void;
    changeGrid($event: any): void;
    layoutDinamic(): {
        'linhasTabelaDinamica': any[];
        'colunasTabelaDinamica': any[];
        'filtrosTabelaDinamica': any[];
        'funcoesTabelaDinamica': any[];
    };
    saveLayout(form?: any, $event?: any): void;
    removeLayout($el: any): void;
    selectLayout($event: any): void;
    ClickShowColumn($event: any): void;
    ClickHideColumn($event: any): void;
    changePerspective($data: any, pivotGridEl?: any): void;
    exportExcell(): void;
    exportButtonGrid(): void;
    getAll(parameters?: any): void;
    pageNext(): void;
    defineFilterModel(event: any): any;
    encontraFilterModel(nomeCampo: any, valor: string): string;
    executarFiltro(parameters: any, savedSearch?: boolean): void;
    changeSearchPanelColumn(): void;
    selectionData(event: any): void;
    resetModels(): void;
    loadModels(): {};
    validModels(attr: any, error: any): boolean;
    reloadModel(): void;
    returnEdit(): void;
    ngOnInit(): void;
    formMarkAsTouched(): void;
    submitFormDinamic(f: any): void;
    submitSaveContinue(): void;
    sendRequest(action?: any): void;
    showTabErrors(label: string, error: string, visible?: boolean): void;
    createComponenteDynamic(html: any, event: any): void;
    createDynamicMasterDetail(): void;
    removeBreadCrumb(b: any): void;
    removeBreadcrumbMasterDetail(item: any): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
}
