"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var material_1 = require("@angular/material");
var DialogAuditDetail = /** @class */ (function () {
    function DialogAuditDetail(dialog, data) {
        this.dialog = dialog;
        this.data = data;
        this.alteracoes = [];
    }
    DialogAuditDetail.prototype.selectRow = function ($event) {
        if ($event.selectedRowsData.length > 0 &&
            $event.selectedRowsData[0].hasOwnProperty("detalhesLista")) {
            this.alteracoes = $event.selectedRowsData[0].detalhesLista.filter(function (i) { return i.valorAtual !== i.valorAnterior; });
        }
    };
    DialogAuditDetail.prototype.onNoClick = function () {
        this.dialog.close();
    };
    DialogAuditDetail.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'sbm-dialog-master-detail',
                    template: "\n\n    <sbm-label>#{{data[0].rotulo}}</sbm-label> - <sbm-label>registro {{data[0].registroId}}</sbm-label>\n    <hr>\n\n    <sbm-timeline>\n        <sbm-timeline-container *ngFor=\"let item of data\">\n            <sbm-timeline-event>{{item.data}} - {{item.operacao}} <br> Por: {{item.usuario}}</sbm-timeline-event>\n            <sbm-timeline-content>\n                <div class=\"row\" [hidden]=\"item.detalhesLista == 0\">\n                    <ng-container *ngFor=\"let alteracao of item.detalhesLista\">\n                    <!--div class=\"field\"><b><sbm-label>#{{alteracao.rotulo}}</sbm-label></b></div>\n                    <hr>\n                     <div class=\"col l4 s4 m4\">\n                        <ng-container *ngIf=\"alteracao.valorAnterior\">\n                            <span><b>De</b>:</span><br>\n                        </ng-container>\n                        <span><b>Para</b>:</span><br>\n                     </div>\n                     <div class=\"col l6 s6 m6\">\n                        <ng-container *ngIf=\"alteracao.valorAnterior\">\n                            <span>{{alteracao.valorAnterior}}</span><br>\n                        </ng-container>\n                        <span>{{alteracao.valorAtual}}</span><br>\n                     </div> -->\n\n                    <ng-container *ngIf=\"alteracao.valorAnterior != alteracao.valorAtual\">\n                        <div class=\"field\">\n                            <div><b><sbm-label columns=\"auto\">#{{alteracao.rotulo}}</sbm-label></b></div>\n                            <ng-container *ngIf=\"alteracao.valorAnterior\">\n                                <div [sbmTooltip]=\"alteracao.valorAnterior\" [ngClass]=\"{'slice-text': alteracao.valorAnterior.length>28}\"><b>De</b>:{{alteracao.valorAnterior}}</div>\n                            </ng-container>\n                            <ng-container *ngIf=\"alteracao.valorAtual\">\n                                <div [sbmTooltip]=\"alteracao.valorAtual\" [ngClass]=\"{'slice-text': alteracao.valorAtual.length>20}\"><b>Para</b>:{{alteracao.valorAtual}}</div><br>\n                            </ng-container>\n                            <hr>\n                        </div>\n                    </ng-container>\n\n                    </ng-container>\n                </div>\n            </sbm-timeline-content>\n        </sbm-timeline-container>\n    </sbm-timeline>\n  ",
                    styles: [
                        "\n    .field {\n        color: #555 !important;\n        margin: 0px !important;\n        border: 2px solid transparent !important;\n        padding: 0px !important;\n        font-size: 14px !important;\n        font-style: normal !important;\n        font-family: \"roboto\" !important;\n        border-radius: 0px !important;\n        background-color: transparent !important;\n    }\n\n    .field div {\n        display: inline-block;\n        overflow: hidden;\n    }\n\n    .slice-text {\n        width: 250px;\n        white-space: nowrap;\n        overflow: hidden;\n        text-overflow: ellipsis;\n    }\n  "
                    ]
                },] },
    ];
    /** @nocollapse */
    DialogAuditDetail.ctorParameters = function () { return [
        { type: material_1.MatDialogRef, },
        { type: undefined, decorators: [{ type: core_1.Inject, args: [material_1.MAT_DIALOG_DATA,] },] },
    ]; };
    return DialogAuditDetail;
}());
exports.DialogAuditDetail = DialogAuditDetail;
