"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var moment = require("moment");
var sharedService_1 = require("../../models/sharedService");
var core_2 = require("@ngx-translate/core");
var http_1 = require("@angular/http");
var material_1 = require("@angular/material");
var core_3 = require("@mat-datetimepicker/core");
var material_moment_adapter_1 = require("@angular/material-moment-adapter");
var picker_component_1 = require("ng-pick-datetime/picker.component");
var MY_DATE_FORMATS = {
    parse: {
        dateInput: "YYYY-MM-DDTHH:mm:ssZ"
    },
    display: {
        dateInput: "DD/MM/YYYY",
        datetimeInput: "DD/MM/YYYY HH:mm",
        timeInput: "HH:mm",
        monthYearLabel: "MM YYYY",
        dateA11yLabel: "DD MM, YYYY HH:mm",
        monthYearA11yLabel: "DD MM, YYYY"
    }
};
var ɵ0 = material_moment_adapter_1.MAT_MOMENT_DATE_FORMATS, ɵ1 = MY_DATE_FORMATS;
exports.ɵ0 = ɵ0;
exports.ɵ1 = ɵ1;
var DateboxComponent = /** @class */ (function (_super) {
    __extends(DateboxComponent, _super);
    function DateboxComponent(_sharedService, _http, _translateService, adapter) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._sharedService = _sharedService;
        _this._http = _http;
        _this._translateService = _translateService;
        _this.adapter = adapter;
        _this.currentDay = false;
        _this.minValueCompl = null;
        _this.maxValueCompl = null;
        _this.defaultValueCompl = null;
        _this.defaultValue = null;
        _this.notnull2 = false;
        _this.hiddenDate2Range = false;
        _this._selectionMode = "single";
        _this._min = null;
        _this._max = null;
        _this.displayFormat = exports.DateboxConstDisplayFormat.datetime;
        _this.isNotMasterDetail = true;
        _this.inputValid = true;
        _this.disabled2 = true;
        _this.textDateBox = {
            dateMin: "",
            dateMax: ""
        };
        _this.blur = function (date) {
            if (typeof date == "string") {
                if (_this.selectionMode == "single") {
                    if (date && date != "") {
                        var newDate = new Date(date);
                        _this.dateComp = newDate;
                        _this._onChange.emit(newDate);
                        if (_this.onChange != "") {
                            window[_this.onChange](newDate);
                        }
                    }
                    else {
                        _this.value = null;
                    }
                }
                else if (_this.selectionMode == "range") {
                    _this.disabled2 = false;
                    var newDate_1 = [];
                    var _splitDateRange = date.split(" - ");
                    _splitDateRange.map(function (item) {
                        newDate_1.push(item);
                    });
                    _this.dateComp1 = new Date(newDate_1[0]);
                    _this.dateComp2 = new Date(newDate_1[1]);
                    _this._onChange.emit(newDate_1);
                    if (_this.onChange != "") {
                        window[_this.onChange](newDate_1);
                    }
                }
            }
        };
        sbmDateboxComponent.push(_this);
        _this._translateService.onLangChange.subscribe(function () {
            var retTraducao = _this._sharedService.getTraducao("sabium-framework")[0];
            _this.validationsMsg["dateMax"] = retTraducao["validation.dateMax"].replace("%", moment(_this._max).format("DD/MM/YYYY"));
            _this.validationsMsg["dateMin"] = retTraducao["validation.dateMin"].replace("%", moment(_this._min).format("DD/MM/YYYY"));
        });
        return _this;
    }
    Object.defineProperty(DateboxComponent.prototype, "selectionMode", {
        get: function () {
            return this._selectionMode;
        },
        set: function (val) {
            if (val == "single" || val == "range") {
                this._selectionMode = val;
            }
            else {
                this._selectionMode = "single";
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DateboxComponent.prototype, "min", {
        get: function () {
            return this._min;
        },
        set: function (val) {
            if (!isNaN(parseInt(val))) {
                var minDate = moment()
                    .subtract(parseInt(val), "days")
                    .format("YYYY-MM-DD HH:mm:ss");
                this._min = new Date(minDate);
            }
            else {
                var minDate = moment()
                    .subtract(parseInt(this.minValueCompl), "days")
                    .format("YYYY-MM-DD HH:mm:ss");
                this._min = new Date(minDate);
            }
        },
        enumerable: true,
        configurable: true
    });
    DateboxComponent.prototype.itemClicadoClear = function ($event) {
        // this.searchValue = '';
        // this.value = undefined;
        // this._onClickClear.emit($event);
        // if (this.onclickclear != '') {
        //     window[this.onclickclear]($event);
        // }
    };
    Object.defineProperty(DateboxComponent.prototype, "max", {
        get: function () {
            return this._max;
        },
        set: function (val) {
            if (!isNaN(parseInt(val))) {
                var maxDate = moment()
                    .add(parseInt(val), "days")
                    .format("YYYY-MM-DD HH:mm:ss");
                this._max = new Date(maxDate);
            }
            else {
                if (this.max == "today") {
                    var minDate = moment().format("YYYY-MM-DD HH:mm:ss");
                    this._max = new Date(minDate);
                }
                else {
                    var minDate = moment()
                        .add(parseInt(this.maxValueCompl), "days")
                        .format("YYYY-MM-DD HH:mm:ss");
                    this._max = new Date(minDate);
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DateboxComponent.prototype, "type", {
        get: function () {
            return this._type;
        },
        set: function (value) {
            this.typeDisplay = value;
            if (value == "datetime") {
                this.displayFormat = exports.DateboxConstDisplayFormat.datetime;
            }
            if (value == "date") {
                this.displayFormat = exports.DateboxConstDisplayFormat.date;
            }
            if (value == "time") {
                this.displayFormat = exports.DateboxConstDisplayFormat.time;
            }
        },
        enumerable: true,
        configurable: true
    });
    DateboxComponent.prototype.abrirPicker = function () {
        if (!this.readonly) {
            this.datetimePicker.open();
        }
    };
    DateboxComponent.prototype.abrirPicker2 = function () {
        if (!this.readonly) {
            this.picker2.open();
        }
    };
    DateboxComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
    };
    DateboxComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        $(this.input.nativeElement).attr("style", this.styleCss);
        this.css += " sbm-input";
        this.classCss += " " + this.css;
        this.valueChangeSubscription = this.onChangeValue.subscribe(function (ret) {
            if (typeof ret == "string") {
                if (ret) {
                    _this.blur(ret);
                }
                else {
                    _this.dateComp = null;
                    _this.dateComp1 = null;
                    _this.dateComp2 = null;
                }
            }
            else if (typeof ret == "number") {
                _this.value = new Date(ret).toISOString();
            }
        });
        if (this.currentDay) {
            if (this.selectionMode == "single") {
                this.value = new Date().toISOString();
            }
            else if (this.selectionMode == "range") {
                var a = moment().format("YYYY-MM-DD HH:mm"); //.format("DD/MM/YYYY");
                var b = moment()
                    .add(1, "days")
                    .format("YYYY-MM-DD HH:mm"); //.format("DD/MM/YYYY");
                this.value = new Date(a).toISOString() + " - " + new Date(b).toISOString();
                this.init = new Date(a);
                this.end = new Date(b);
            }
        }
        if (this.defaultValue == "d_minus_x") {
            var minDate = moment()
                .subtract(parseInt(this.defaultValueCompl), "days")
                .format("YYYY-MM-DD HH:mm:ss");
            this.value = new Date(minDate).toISOString();
        }
        else if (this.defaultValue == "d_add_x") {
            var maxDate = moment()
                .add(parseInt(this.defaultValueCompl), "days")
                .format("YYYY-MM-DD HH:mm:ss");
            this.value = new Date(maxDate).toISOString();
        }
        $(this.input.nativeElement).mask("00/00/0000");
        if (this.selectionMode == "range") {
            $(this.input2.nativeElement).mask("00/00/0000");
        }
    };
    DateboxComponent.prototype.changeDate = function (date, type) {
        if (this.selectionMode == "range") {
            if (type == "initial") {
                this.init = date.value;
                this.disabled2 = false;
                var minDate = moment(date.value)
                    .add(1, "days")
                    .format("YYYY-MM-DD HH:mm");
                this.min2 = new Date(minDate);
            }
            else if (type == "end") {
                this.end = date.value;
            }
            if (this.init && this.end) {
                this.value =
                    new Date(this.init).toISOString() /*.format("DD/MM/YYYY")*/ +
                        " - " +
                        new Date(this.end).toISOString() /*.format("DD/MM/YYYY")*/;
            }
        }
        else {
            if (date.value && date.value != "") {
                this.value = new Date(date.value).toISOString(); //.format("DD/MM/YYYY");
            }
            else {
                this.value = null;
            }
        }
    };
    DateboxComponent.prototype.regex = function (value) {
        var regexTime = /^([0-9]|0[0-9]|1[0-9]|2[0-3]):[0-5][0-9]$/;
        var regexData = /^([0-2]\d|[3][0-1])\/([0]\d|[1][0-2])\/([1-2]\d{3})$/;
        var regexDataTime = /^([0-2]\d|[3][0-1])\/([0]\d|[1][0-2])\/([1-2]\d{3})\s([0-1]\d|[2][0-3])\:([0-5]\d)$/;
        return regexData.test(value) || regexDataTime.test(value);
    };
    DateboxComponent.prototype.ngOnDestroy = function () {
        this.valueChangeSubscription.unsubscribe();
    };
    DateboxComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: "sbm-datebox",
                    template: require('./datebox.component.html'),

                    styles: [require('./datebox.component.css')],
                    host: {
                        "[class]": "classCss",
                        "[ngClass]": 'options ? options.className : ""'
                    },
                    providers: [
                        abstract_ngmodel_1.MakeProvider(DateboxComponent),
                        {
                            provide: abstract_ngmodel_1.AbstractNgModel,
                            useExisting: core_1.forwardRef(function () { return DateboxComponent; })
                        },
                        { provide: material_1.MAT_DATE_FORMATS, useValue: ɵ0 },
                        {
                            provide: material_1.DateAdapter,
                            useClass: material_moment_adapter_1.MomentDateAdapter,
                            deps: [material_1.MAT_DATE_LOCALE]
                        },
                        { provide: core_3.MAT_DATETIME_FORMATS, useValue: ɵ1 }
                    ]
                },] },
    ];
    /** @nocollapse */
    DateboxComponent.ctorParameters = function () { return [
        { type: sharedService_1.SharedService, },
        { type: http_1.Http, },
        { type: core_2.TranslateService, },
        { type: material_1.DateAdapter, },
    ]; };
    DateboxComponent.propDecorators = {
        "input": [{ type: core_1.ViewChild, args: ["datebox",] },],
        "picker": [{ type: core_1.ViewChild, args: ["picker",] },],
        "picker2": [{ type: core_1.ViewChild, args: ["picker2",] },],
        "input2": [{ type: core_1.ViewChild, args: ["datebox2",] },],
        "datetimePicker": [{ type: core_1.ViewChild, args: ["datetimePicker",] },],
        "mydatepicker": [{ type: core_1.ViewChild, args: ["mydatepicker",] },],
        "currentDay": [{ type: core_1.Input, args: ["currentday",] },],
        "minValueCompl": [{ type: core_1.Input, args: ["minValueCompl",] },],
        "maxValueCompl": [{ type: core_1.Input, args: ["maxValueCompl",] },],
        "defaultValueCompl": [{ type: core_1.Input, args: ["defaultvaluecompl",] },],
        "defaultValue": [{ type: core_1.Input, args: ["defaultvalue",] },],
        "notnull2": [{ type: core_1.Input, args: ["require2",] },],
        "hiddenDate2Range": [{ type: core_1.Input },],
        "selectionMode": [{ type: core_1.Input, args: ["selectionmode",] },],
        "min": [{ type: core_1.Input },],
        "max": [{ type: core_1.Input },],
        "type": [{ type: core_1.Input },],
    };
    return DateboxComponent;
}(abstract_ngmodel_1.AbstractNgModel));
exports.DateboxComponent = DateboxComponent;
exports.DateboxConstDisplayFormat = {
    date: 'DD/MM/YYYY',
    time: 'HH:mm',
    datetime: 'DD/MM/YYYY HH:mm',
};
var DateboxEnumType;
(function (DateboxEnumType) {
    DateboxEnumType[DateboxEnumType["date"] = 0] = "date";
    DateboxEnumType[DateboxEnumType["time"] = 1] = "time";
    DateboxEnumType[DateboxEnumType["datetime"] = 2] = "datetime";
})(DateboxEnumType = exports.DateboxEnumType || (exports.DateboxEnumType = {}));
