"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var numberfixedlen_pipe_1 = require("./numberfixedlen.pipe");
var core_1 = require("@angular/core");
var animations_1 = require("@angular/animations");
var forms_1 = require("@angular/forms");
var date_fns_1 = require("date-fns");
var sharedService_1 = require("../../models/sharedService");
var http_1 = require("@angular/http");
var core_2 = require("@ngx-translate/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var DialogType;
(function (DialogType) {
    DialogType[DialogType["Time"] = 0] = "Time";
    DialogType[DialogType["Date"] = 1] = "Date";
    DialogType[DialogType["Month"] = 2] = "Month";
    DialogType[DialogType["Year"] = 3] = "Year";
})(DialogType = exports.DialogType || (exports.DialogType = {}));
exports.DATETIMEPICKER_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(function () { return DatetimeNativeComponent; }),
    multi: true
};
var DatetimeNativeComponent = /** @class */ (function (_super) {
    __extends(DatetimeNativeComponent, _super);
    function DatetimeNativeComponent(renderer, ngZone, numFixedLenPipe, _sharedService, _http, _translateService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this.renderer = renderer;
        _this.ngZone = ngZone;
        _this.numFixedLenPipe = numFixedLenPipe;
        _this._sharedService = _sharedService;
        _this._http = _http;
        _this._translateService = _translateService;
        _this.dataType = 'date';
        _this.dateFormat = 'DD/MM/YYYY HH:mm';
        _this.disabled = false;
        _this.disabledDates = [];
        _this.hideClearButton = false;
        _this.placeHolder = 'dd/mm/aaaa hh:mm';
        _this.readonlyInput = false;
        _this.selectionMode = 'single';
        _this.showButtons = false;
        _this.showHeader = false;
        _this.showSecondsTimer = false;
        _this.tabIndex = 0;
        _this.type = 'both';
        _this.hourFormat = '24';
        _this.showOtherMonths = true;
        _this.onClear = new core_1.EventEmitter();
        _this.onClose = new core_1.EventEmitter();
        _this.onConfirm = new core_1.EventEmitter();
        _this.onInvalid = new core_1.EventEmitter();
        _this.onSelect = new core_1.EventEmitter();
        _this.calendarYears = [];
        _this.dialogType = DialogType.Date;
        //public focus: boolean;
        _this.formattedValue = '';
        _this.hourString = "hh";
        _this.minString = "mm";
        _this.disabledTimer = true;
        _this.hourValue = 0;
        _this.minValue = 0;
        _this.meridianValue = 'AM';
        _this._locale = {
            firstDayOfWeek: 0,
            dayNames: ["Domingo", "Segunda", "Terça", "Quarta", "Quinta", "Sexta", "Sábado"],
            dayNamesShort: ["Dom", "Seg", "Ter", "Qua", "Qui", "Sex", "Sáb"],
            monthNames: ["Janeiro", "Fevereiro", "Março", "Abril", "Maio", "Junho", "Julho", "Agosto", "Setembro", "Outubro", "Novembro", "Dezembro"],
            monthNamesShort: ["Jan", "Fev", "Mar", "Abr", "Mai", "Jun", "Jul", "Ago", "Set", "Out", "Nov", "Dez"],
            dateFns: null
        };
        _this.valueIndex = 0;
        _this.inputValueChanged = false;
        _this.onModelChange = function () {
        };
        _this.onModelTouched = function () {
        };
        return _this;
    }
    Object.defineProperty(DatetimeNativeComponent.prototype, "max", {
        get: function () {
            return this._max;
        },
        set: function (val) {
            this._max = this.parseToDate(val);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DatetimeNativeComponent.prototype, "min", {
        get: function () {
            return this._min;
        },
        set: function (val) {
            this._min = this.parseToDate(val);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DatetimeNativeComponent.prototype, "locale", {
        get: function () {
            return this._locale;
        },
        set: function (val) {
            this._locale = Object.assign({}, this._locale, val);
        },
        enumerable: true,
        configurable: true
    });
    DatetimeNativeComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
        this.now = new Date();
        this.pickerMoment = this.defaultMoment ? this.parseToDate(this.defaultMoment) : this.now;
        this.generateWeekDays();
        this.generateMonthList();
        this.generateCalendar();
        this.updateTimer(null);
    };
    DatetimeNativeComponent.prototype.ngOnDestroy = function () {
        this.unbindDocumentClickListener();
        this.valueChangeSubscription.unsubscribe();
    };
    DatetimeNativeComponent.prototype.registerOnChange = function (fn) {
        this.onModelChange = fn;
    };
    DatetimeNativeComponent.prototype.registerOnTouched = function (fn) {
        this.onModelTouched = fn;
    };
    DatetimeNativeComponent.prototype.setDisabledState = function (isDisabled) {
        this.disabled = isDisabled;
    };
    /**
     * Handle input value change event on the text input
     * @param {any} event
     * @return {void}
     * */
    /**
         * Handle input value change event on the text input
         * @param {any} event
         * @return {void}
         * */
    DatetimeNativeComponent.prototype.onInputUpdate = /**
         * Handle input value change event on the text input
         * @param {any} event
         * @return {void}
         * */
    function (event) {
        this.inputValueChanged = true;
        var value = this.parseValueFromString(event.target.value);
        if (!value) {
            this.value = null;
        }
        else if (this.isSingleSelection()) {
            if (!this.isValidValue(value)) {
                value = null;
            }
            this.value = value;
            this.updateCalendar(this.value);
            this.updateTimer(this.value);
        }
        else if (this.isMultiSelection()) {
            for (var i = 0; i < value.length; i++) {
                if (!this.isValidValue(value[i])) {
                    value[i] = null;
                }
            }
            this.value = value;
            this.updateCalendar(this.value[0]);
            this.updateTimer(this.value[0]);
        }
        else if (this.isRangeSelection()) {
            for (var i = 0; i < value.length; i++) {
                if (!this.isValidValue(value[i])) {
                    value[i] = null;
                }
            }
            // check if the first date time is after the second one
            if (value[0] && value[1] && date_fns_1.isAfter(value[0], value[1])) {
                value[1] = null;
            }
            this.value = value;
            this.updateCalendar(this.value[0]);
            this.updateTimer(this.value[0]);
        }
        this.updateModel(this.value);
    };
    DatetimeNativeComponent.prototype.onInputClick = function (event) {
        if (this.disabled) {
            //event.preventDefault();
            return;
        }
        if (!this.value) {
            //se não tem data selecionada, abre calendario no mes e ano atual
            var dataAtual = new Date();
            this.selectMonth(dataAtual.getMonth());
            this.selectYear(dataAtual.getFullYear());
        }
        this.dialogClick = true;
        if (!this.dialogVisible) {
            this.show(event);
        }
        // event.preventDefault();
        return;
    };
    DatetimeNativeComponent.prototype.onInputFocus = function (event) {
        //this.focus = true;
        //event.preventDefault();
        //return;
    };
    DatetimeNativeComponent.prototype.onInputBlur = function (event) {
        if (this.inputValueChanged) {
            this.updateFormattedValue();
            this.inputValueChanged = false;
        }
        this.onModelTouched();
        this._onBlur.emit(event);
        //event.preventDefault();
        return;
    };
    DatetimeNativeComponent.prototype.onDialogClick = function (event) {
        this.dialogClick = true;
    };
    DatetimeNativeComponent.prototype.onConfirmClick = function (event) {
        this.updateModel(this.value);
        this.updateFormattedValue();
        this.onConfirm.next({
            originalEvent: event,
            value: this.value
        });
        this.hide(event);
        event.stopPropagation();
        // event.preventDefault();
        return;
    };
    DatetimeNativeComponent.prototype.onCloseClick = function (event) {
        this.hide(event);
        event.stopPropagation();
        //event.preventDefault();
        return;
    };
    DatetimeNativeComponent.prototype.onSelectDate = function (event, date) {
        this.valueFormatDate = null;
        this.hourValue = 0;
        this.minValue = 0;
        if (this.disabled || !date) {
            // event.preventDefault();
            return;
        }
        // handle set date based on the current selection mode
        var selected;
        if (this.isSingleSelection()) {
            selected = this.setDateOnSingleSelection(date);
        }
        else if (this.isRangeSelection()) {
            selected = this.setDateOnRangeSelection(date);
        }
        else if (this.isMultiSelection()) {
            selected = this.setDateOnMultiSelection(date);
        }
        if (selected) {
            if (!this.showButtons) {
                //selected = Wed Dec 06 2017 00:00:00 GMT-0200 (-02)
                this.valueFormatDate = selected;
                var dataenviar = new Date(Date.UTC(selected.getFullYear(), selected.getMonth(), selected.getDate(), selected.getHours(), selected.getMinutes())).toISOString();
                //dataenviar = 2017-12-05T00:00:00.000Z
                this.updateModel(dataenviar);
                this.updateFormattedValue();
            }
            else {
                this.value = selected;
            }
            if (this.value instanceof Array) {
                this.updateCalendar(this.value[this.valueIndex]);
                this.updateTimer(this.value[this.valueIndex]);
                this.onSelect.emit({ event: event, value: this.value[this.valueIndex] });
            }
            else {
                this.updateCalendar(this.valueFormatDate);
                this.updateTimer(this.valueFormatDate);
                this.onSelect.emit({ event: event, value: this.value });
            }
            //this.hoursInput.nativeElement.focus();
            /*if (this.hoursInput) {
                            this.runTimeoutOutsideZone(() => {
                                this.hoursInput.nativeElement.focus();
                            }, 0)
                        }*/
        }
        // hide the dialog if the autoClose is set to true
        if (this.autoClose) {
            this.hide(event);
        }
        this.disabledTimer = false;
        this.hourString = 0;
        this.minString = 0;
    };
    DatetimeNativeComponent.prototype.focusInput = function (input) {
        /*if (input) {
                    this.runTimeoutOutsideZone(() => {
                        input.focus();
                    }, 0)
                }*/
    };
    /**
     * Go to previous month
     * @param {any} event
     * @return {void}
     * */
    /**
         * Go to previous month
         * @param {any} event
         * @return {void}
         * */
    DatetimeNativeComponent.prototype.prevMonth = /**
         * Go to previous month
         * @param {any} event
         * @return {void}
         * */
    function (event) {
        if (this.disabled) {
            //event.preventDefault();
            return;
        }
        this.pickerMoment = date_fns_1.addMonths(this.pickerMoment, -1);
        this.generateCalendar();
        //event.preventDefault();
        return;
    };
    /**
     * Go to next month
     * @param {any} event
     * @return {void}
     * */
    /**
         * Go to next month
         * @param {any} event
         * @return {void}
         * */
    DatetimeNativeComponent.prototype.nextMonth = /**
         * Go to next month
         * @param {any} event
         * @return {void}
         * */
    function (event) {
        if (this.disabled) {
            //event.preventDefault();
            return;
        }
        this.pickerMoment = date_fns_1.addMonths(this.pickerMoment, 1);
        this.generateCalendar();
        // event.preventDefault();
        return;
    };
    /**
     * Set a pickerMoment's month
     * @param {Number} monthNum
     * @return {void}
     * */
    /**
         * Set a pickerMoment's month
         * @param {Number} monthNum
         * @return {void}
         * */
    DatetimeNativeComponent.prototype.selectMonth = /**
         * Set a pickerMoment's month
         * @param {Number} monthNum
         * @return {void}
         * */
    function (monthNum) {
        this.pickerMoment = date_fns_1.setMonth(this.pickerMoment, monthNum);
        this.generateCalendar();
        this.changeDialogType(DialogType.Month);
    };
    /**
     * Set a pickerMoment's year
     * @param {Number} yearNum
     * @return {void}
     * */
    /**
         * Set a pickerMoment's year
         * @param {Number} yearNum
         * @return {void}
         * */
    DatetimeNativeComponent.prototype.selectYear = /**
         * Set a pickerMoment's year
         * @param {Number} yearNum
         * @return {void}
         * */
    function (yearNum) {
        this.pickerMoment = date_fns_1.setYear(this.pickerMoment, yearNum);
        this.generateCalendar();
        this.changeDialogType(DialogType.Year);
    };
    /**
     * Set the selected moment's meridian
     * @param {any} event
     * @return {void}
     * */
    /**
         * Set the selected moment's meridian
         * @param {any} event
         * @return {void}
         * */
    DatetimeNativeComponent.prototype.toggleMeridian = /**
         * Set the selected moment's meridian
         * @param {any} event
         * @return {void}
         * */
    function (event) {
        var value = this.value ? (this.value.length ? this.value[this.valueIndex] : this.value) : null;
        if (this.disabled) {
            //event.preventDefault();
            return;
        }
        if (!value) {
            this.meridianValue = this.meridianValue === 'AM' ? 'PM' : 'AM';
            return;
        }
        var hours = date_fns_1.getHours(value);
        if (this.meridianValue === 'AM') {
            hours += 12;
        }
        else if (this.meridianValue === 'PM') {
            hours -= 12;
        }
        var selectedTime = date_fns_1.setHours(value, hours);
        this.setSelectedTime(event, selectedTime);
        //event.preventDefault();
        return;
    };
    /**
     * Set the selected moment's hour
     * @param {any} event
     * @param {'increase' | 'decrease' | number} val
     *      'increase' -- increase hour value by 1
     *      'decrease' -- decrease hour value by 1
     *      number -- set hour value to val
     * @param {HTMLInputElement} input -- optional
     * @return {boolean}
     * */
    /**
         * Set the selected moment's hour
         * @param {any} event
         * @param {'increase' | 'decrease' | number} val
         *      'increase' -- increase hour value by 1
         *      'decrease' -- decrease hour value by 1
         *      number -- set hour value to val
         * @param {HTMLInputElement} input -- optional
         * @return {boolean}
         * */
    DatetimeNativeComponent.prototype.setHours = /**
         * Set the selected moment's hour
         * @param {any} event
         * @param {'increase' | 'decrease' | number} val
         *      'increase' -- increase hour value by 1
         *      'decrease' -- decrease hour value by 1
         *      number -- set hour value to val
         * @param {HTMLInputElement} input -- optional
         * @return {boolean}
         * */
    function (event, val, input) {
        //console.log('setHours');
        var value;
        if (this.value) {
            if (this.valueFormatDate) {
                value = this.valueFormatDate;
            }
            else if (this.value.length) {
                value = this.value[this.valueIndex];
            }
            else {
                value = this.value;
            }
        }
        else {
            if (this.type === 'timer') {
                value = new Date();
            }
            else {
                value = null;
            }
        }
        //console.log('setHours', value);
        if (this.disabled || !value) {
            //event.preventDefault();
            return false;
        }
        var hours = date_fns_1.getHours(value);
        if (val === 'increase') {
            hours += 1;
        }
        else if (val === 'decrease') {
            hours -= 1;
        }
        else {
            hours = val;
        }
        if (hours > 23) {
            hours = 0;
        }
        else if (hours < 0) {
            hours = 23;
        }
        //console.log('hours', hours);
        var selectedTime = date_fns_1.setHours(value, hours);
        var done = this.setSelectedTime(event, selectedTime);
        // Focus the input and select its value when model updated
        /*if (input) {
                    this.runTimeoutOutsideZone(() => {
                        input.focus();
                    }, 0)
                }
        
                event.preventDefault();*/
        return done;
    };
    /**
     * Set the selected moment's minute
     * @param {any} event
     * @param {'increase' | 'decrease' | number} val
     *      'increase' -- increase minute value by 1
     *      'decrease' -- decrease minute value by 1
     *      number -- set minute value to val
     * @param {HTMLInputElement} input -- optional
     * @return {boolean}
     * */
    /**
         * Set the selected moment's minute
         * @param {any} event
         * @param {'increase' | 'decrease' | number} val
         *      'increase' -- increase minute value by 1
         *      'decrease' -- decrease minute value by 1
         *      number -- set minute value to val
         * @param {HTMLInputElement} input -- optional
         * @return {boolean}
         * */
    DatetimeNativeComponent.prototype.setMinutes = /**
         * Set the selected moment's minute
         * @param {any} event
         * @param {'increase' | 'decrease' | number} val
         *      'increase' -- increase minute value by 1
         *      'decrease' -- decrease minute value by 1
         *      number -- set minute value to val
         * @param {HTMLInputElement} input -- optional
         * @return {boolean}
         * */
    function (event, val, input) {
        var value;
        if (this.value) {
            if (this.valueFormatDate) {
                value = this.valueFormatDate;
            }
            else if (this.value.length) {
                value = this.value[this.valueIndex];
            }
            else {
                value = this.value;
            }
        }
        else {
            if (this.type === 'timer') {
                value = new Date();
            }
            else {
                value = null;
            }
        }
        if (this.disabled || !value) {
            // event.preventDefault();
            return false;
        }
        var minutes = date_fns_1.getMinutes(value);
        if (val === 'increase') {
            minutes += 1;
        }
        else if (val === 'decrease') {
            minutes -= 1;
        }
        else {
            minutes = val;
        }
        if (minutes > 59) {
            minutes = 0;
        }
        else if (minutes < 0) {
            minutes = 59;
        }
        var selectedTime = date_fns_1.setMinutes(value, minutes);
        var done = this.setSelectedTime(event, selectedTime);
        // Focus the input and select its value when model updated
        /*if (input) {
                    this.runTimeoutOutsideZone(() => {
                        input.focus();
                    }, 0)
                }
        
                event.preventDefault();*/
        return done;
    };
    /**
     * Set the selected moment's second
     * @param {any} event
     * @param {'increase' | 'decrease' | number} val
     *      'increase' -- increase second value by 1
     *      'decrease' -- decrease second value by 1
     *      number -- set second value to val
     * @param {HTMLInputElement} input -- optional
     * @return {boolean}
     * */
    /**
         * Set the selected moment's second
         * @param {any} event
         * @param {'increase' | 'decrease' | number} val
         *      'increase' -- increase second value by 1
         *      'decrease' -- decrease second value by 1
         *      number -- set second value to val
         * @param {HTMLInputElement} input -- optional
         * @return {boolean}
         * */
    DatetimeNativeComponent.prototype.setSeconds = /**
         * Set the selected moment's second
         * @param {any} event
         * @param {'increase' | 'decrease' | number} val
         *      'increase' -- increase second value by 1
         *      'decrease' -- decrease second value by 1
         *      number -- set second value to val
         * @param {HTMLInputElement} input -- optional
         * @return {boolean}
         * */
    function (event, val, input) {
        var value;
        if (this.value) {
            if (this.value.length) {
                value = this.value[this.valueIndex];
            }
            else {
                value = this.value;
            }
        }
        else {
            if (this.type === 'timer') {
                value = new Date();
            }
            else {
                value = null;
            }
        }
        if (this.disabled || !value) {
            // event.preventDefault();
            return false;
        }
        var seconds = date_fns_1.getSeconds(value);
        if (val === 'increase') {
            seconds = this.secValue + 1;
        }
        else if (val === 'decrease') {
            seconds = this.secValue - 1;
        }
        else {
            seconds = val;
        }
        if (seconds > 59) {
            seconds = 0;
        }
        else if (seconds < 0) {
            seconds = 59;
        }
        var selectedTime = date_fns_1.setSeconds(value, seconds);
        var done = this.setSelectedTime(event, selectedTime);
        // Focus the input and select its value when model updated
        /*if (input) {
                    this.runTimeoutOutsideZone(() => {
                        input.focus();
                    }, 0)
                }
        
                event.preventDefault();*/
        return done;
    };
    /**
     * Check if the date is selected
     * @param {Date} date
     * @return {Boolean}
     * */
    /**
         * Check if the date is selected
         * @param {Date} date
         * @return {Boolean}
         * */
    DatetimeNativeComponent.prototype.isSelectedDay = /**
         * Check if the date is selected
         * @param {Date} date
         * @return {Boolean}
         * */
    function (date) {
        //console.log('valueFormatDate', this.valueFormatDate);
        //console.log('isSelectedDay', date);
        if (this.isSingleSelection()) {
            return this.valueFormatDate && date_fns_1.isSameDay(this.valueFormatDate, date);
        }
        else if (this.isRangeSelection() && this.value && this.value.length) {
            if (this.value[1]) {
                return (date_fns_1.isSameDay(this.value[0], date) || date_fns_1.isSameDay(this.value[1], date) ||
                    this.isDayBetween(this.value[0], this.value[1], date)) && this.isValidDay(date);
            }
            else {
                return date_fns_1.isSameDay(this.value[0], date);
            }
        }
        else if (this.isMultiSelection() && this.value && this.value.length) {
            var selected = void 0;
            for (var _i = 0, _a = this.value; _i < _a.length; _i++) {
                var d = _a[_i];
                selected = date_fns_1.isSameDay(d, date);
                if (selected) {
                    break;
                }
            }
            return selected;
        }
        return false;
    };
    /**
     * Check if a day is between two specific days
     * @param {Date} start
     * @param {Date} end
     * @param {Date} day
     * @return {boolean}
     * */
    /**
         * Check if a day is between two specific days
         * @param {Date} start
         * @param {Date} end
         * @param {Date} day
         * @return {boolean}
         * */
    DatetimeNativeComponent.prototype.isDayBetween = /**
         * Check if a day is between two specific days
         * @param {Date} start
         * @param {Date} end
         * @param {Date} day
         * @return {boolean}
         * */
    function (start, end, day) {
        if (start && end) {
            return date_fns_1.isAfter(day, start) && date_fns_1.isBefore(day, end);
        }
        else {
            return false;
        }
    };
    /**
     * Check if the calendar day is a valid day
     * @param {Date}  date
     * @return {Boolean}
     * */
    /**
         * Check if the calendar day is a valid day
         * @param {Date}  date
         * @return {Boolean}
         * */
    DatetimeNativeComponent.prototype.isValidDay = /**
         * Check if the calendar day is a valid day
         * @param {Date}  date
         * @return {Boolean}
         * */
    function (date) {
        var isValid = true;
        if (this.disabledDates && this.disabledDates.length) {
            for (var _i = 0, _a = this.disabledDates; _i < _a.length; _i++) {
                var disabledDate = _a[_i];
                if (date_fns_1.isSameDay(disabledDate, date)) {
                    return false;
                }
            }
        }
        if (isValid && this.disabledDays && this.disabledDays.length) {
            var weekdayNum = date_fns_1.getDay(date);
            isValid = this.disabledDays.indexOf(weekdayNum) === -1;
        }
        if (isValid && this.min) {
            isValid = isValid && !date_fns_1.isBefore(date, date_fns_1.startOfDay(this.min));
        }
        if (isValid && this.max) {
            isValid = isValid && !date_fns_1.isAfter(date, date_fns_1.startOfDay(this.max));
        }
        return isValid;
    };
    /**
     * Check if the month is current pickerMoment's month
     * @param {Number} monthNum
     * @return {Boolean}
     * */
    /**
         * Check if the month is current pickerMoment's month
         * @param {Number} monthNum
         * @return {Boolean}
         * */
    DatetimeNativeComponent.prototype.isCurrentMonth = /**
         * Check if the month is current pickerMoment's month
         * @param {Number} monthNum
         * @return {Boolean}
         * */
    function (monthNum) {
        return date_fns_1.getMonth(this.pickerMoment) == monthNum;
    };
    /**
     * Check if the year is current pickerMoment's year
     * @param {Number} yearNum
     * @return {Boolean}
     * */
    /**
         * Check if the year is current pickerMoment's year
         * @param {Number} yearNum
         * @return {Boolean}
         * */
    DatetimeNativeComponent.prototype.isCurrentYear = /**
         * Check if the year is current pickerMoment's year
         * @param {Number} yearNum
         * @return {Boolean}
         * */
    function (yearNum) {
        return date_fns_1.getYear(this.pickerMoment) == yearNum;
    };
    /**
     * Change the dialog type
     * @param {DialogType} type
     * @return {void}
     * */
    /**
         * Change the dialog type
         * @param {DialogType} type
         * @return {void}
         * */
    DatetimeNativeComponent.prototype.changeDialogType = /**
         * Change the dialog type
         * @param {DialogType} type
         * @return {void}
         * */
    function (type) {
        if (this.dialogType === type) {
            this.dialogType = DialogType.Date;
            return;
        }
        else {
            this.dialogType = type;
        }
        if (this.dialogType === DialogType.Year) {
            this.generateYearList();
        }
    };
    /**
     * Handle blur event on timer input
     * @param {any} event
     * @param {HTMLInputElement} input
     * @param {string} type
     * @param {number} modelValue
     * @return {void}
     * */
    /**
         * Handle blur event on timer input
         * @param {any} event
         * @param {HTMLInputElement} input
         * @param {string} type
         * @param {number} modelValue
         * @return {void}
         * */
    DatetimeNativeComponent.prototype.onTimerInputBlur = /**
         * Handle blur event on timer input
         * @param {any} event
         * @param {HTMLInputElement} input
         * @param {string} type
         * @param {number} modelValue
         * @return {void}
         * */
    function (event, input, type, modelValue) {
        var val = +input.value;
        if (this.disabled) {
            // || val === modelValue
            // event.preventDefault();
            return;
        }
        var done;
        if (!isNaN(val)) {
            switch (type) {
                case 'hours':
                    if (this.hourFormat === '24' &&
                        val >= 0 && val <= 23) {
                        done = this.setHours(event, val);
                    }
                    else if (this.hourFormat === '12'
                        && val >= 1 && val <= 12) {
                        if (this.meridianValue === 'AM' && val === 12) {
                            val = 0;
                        }
                        else if (this.meridianValue === 'PM' && val < 12) {
                            val = val + 12;
                        }
                        done = this.setHours(event, val);
                    }
                    break;
                case 'minutes':
                    if (val >= 0 && val <= 59) {
                        done = this.setMinutes(event, val);
                    }
                    break;
                case 'seconds':
                    if (val >= 0 && val <= 59) {
                        done = this.setSeconds(event, val);
                    }
                    break;
            }
        }
        if (!done) {
            input.value = this.numFixedLenPipe.transform(modelValue, 2);
            //return;
        }
        //event.preventDefault();
        //return;
    };
    /**
     * Set value to null
     * @param {any} event
     * @return {void}
     * */
    /**
         * Set value to null
         * @param {any} event
         * @return {void}
         * */
    DatetimeNativeComponent.prototype.clearValue = /**
         * Set value to null
         * @param {any} event
         * @return {void}
         * */
    function (event) {
        this.dialogClick = true;
        this.valueFormatDate = null;
        this.hourValue = 0;
        this.minValue = 0;
        this.hourString = "hh";
        this.minString = "mm";
        this.updateModel(null);
        this.updateTimer(this.value);
        this.updateFormattedValue();
        this.onClear.emit({ originalEvent: event, value: this.value });
        // event.preventDefault();
    };
    /**
     * Show the dialog
     * @param {any} event
     * @return {void}
     * */
    /**
         * Show the dialog
         * @param {any} event
         * @return {void}
         * */
    DatetimeNativeComponent.prototype.show = /**
         * Show the dialog
         * @param {any} event
         * @return {void}
         * */
    function (event) {
        this.alignDialog();
        this.dialogVisible = true;
        this.dialogType = DialogType.Date;
        this.bindDocumentClickListener();
        return;
    };
    /**
     * Hide the dialog
     * @param {any} event
     * @return {void}
     * */
    /**
         * Hide the dialog
         * @param {any} event
         * @return {void}
         * */
    DatetimeNativeComponent.prototype.hide = /**
         * Hide the dialog
         * @param {any} event
         * @return {void}
         * */
    function (event) {
        this.dialogVisible = false;
        this.onClose.emit({ event: event });
        this.unbindDocumentClickListener();
        return;
    };
    /**
     * Set the dialog position
     * @return {void}
     * */
    /**
         * Set the dialog position
         * @return {void}
         * */
    DatetimeNativeComponent.prototype.alignDialog = /**
         * Set the dialog position
         * @return {void}
         * */
    function () {
        var element = this.dialogElm.nativeElement;
        var target = this.containerElm.nativeElement;
        var elementDimensions = element.offsetParent ? {
            width: element.offsetWidth,
            height: element.offsetHeight
        } : this.getHiddenElementDimensions(element);
        var targetHeight = target.offsetHeight;
        var targetWidth = target.offsetWidth;
        var targetOffset = target.getBoundingClientRect();
        var viewport = this.getViewport();
        var top, left;
        if ((targetOffset.top + targetHeight + elementDimensions.height) > viewport.height) {
            top = -1 * (elementDimensions.height);
            if (targetOffset.top + top < 0) {
                top = 0;
            }
        }
        else {
            top = targetHeight;
        }
        if ((targetOffset.left + elementDimensions.width) > viewport.width)
            left = targetWidth - elementDimensions.width;
        else
            left = 0;
        element.style.top = top + 'px';
        element.style.left = left + 'px';
    };
    /**
     * Bind click event on document
     * @return {void}
     * */
    /**
         * Bind click event on document
         * @return {void}
         * */
    DatetimeNativeComponent.prototype.bindDocumentClickListener = /**
         * Bind click event on document
         * @return {void}
         * */
    function () {
        var _this = this;
        var firstClick = true;
        //console.log('this.documentClickListener', this.documentClickListener);
        if (!this.documentClickListener) {
            this.documentClickListener = this.renderer.listen('document', 'click', function (event) {
                if (!firstClick && !_this.dialogClick) {
                    _this.hide(event);
                }
                firstClick = false;
                _this.dialogClick = false;
            });
        }
        return;
    };
    /**
     * Unbind click event on document
     * @return {void}
     * */
    /**
         * Unbind click event on document
         * @return {void}
         * */
    DatetimeNativeComponent.prototype.unbindDocumentClickListener = /**
         * Unbind click event on document
         * @return {void}
         * */
    function () {
        if (this.documentClickListener) {
            this.documentClickListener();
            this.documentClickListener = null;
        }
        return;
    };
    /**
     * Parse a object to Date object
     * @param {any} val
     * @return {Date}
     * */
    /**
         * Parse a object to Date object
         * @param {any} val
         * @return {Date}
         * */
    DatetimeNativeComponent.prototype.parseToDate = /**
         * Parse a object to Date object
         * @param {any} val
         * @return {Date}
         * */
    function (val) {
        //console.log('parseToDate', val);
        if (!val) {
            return;
        }
        var parsedVal;
        if (typeof val === 'string') {
            // parsedVal = parse(val, this.dateFormat, this.now);
            parsedVal = date_fns_1.parse(val, null);
        }
        else {
            parsedVal = val;
        }
        return date_fns_1.isValid(parsedVal) ? parsedVal : null;
    };
    /**
     * Generate the calendar days array
     * @return {void}
     * */
    /**
         * Generate the calendar days array
         * @return {void}
         * */
    DatetimeNativeComponent.prototype.generateCalendar = /**
         * Generate the calendar days array
         * @return {void}
         * */
    function () {
        if (!this.pickerMoment) {
            return;
        }
        this.calendarDays = [];
        var startDateOfMonth = date_fns_1.startOfMonth(this.pickerMoment);
        var startWeekdayOfMonth = date_fns_1.getDay(startDateOfMonth);
        var dayDiff = 0 - (startWeekdayOfMonth + (7 - this.locale.firstDayOfWeek)) % 7;
        for (var i = 1; i < 7; i++) {
            var week = [];
            for (var j = 0; j < 7; j++) {
                var date = date_fns_1.addDays(startDateOfMonth, dayDiff);
                var inOtherMonth = !date_fns_1.isSameMonth(date, this.pickerMoment);
                week.push({
                    date: date,
                    num: date_fns_1.getDate(date),
                    today: date_fns_1.isSameDay(this.now, date),
                    otherMonth: inOtherMonth,
                    hide: !this.showOtherMonths && inOtherMonth,
                });
                dayDiff += 1;
            }
            this.calendarDays.push(week);
        }
        this.pickerMonth = this.locale.monthNames[date_fns_1.getMonth(this.pickerMoment)];
        this.pickerYear = date_fns_1.getYear(this.pickerMoment).toString();
    };
    /**
     * Generate the calendar weekdays array
     * */
    /**
         * Generate the calendar weekdays array
         * */
    DatetimeNativeComponent.prototype.generateWeekDays = /**
         * Generate the calendar weekdays array
         * */
    function () {
        if (this.type === 'timer') {
            return;
        }
        this.calendarWeekdays = [];
        var dayIndex = this.locale.firstDayOfWeek;
        for (var i = 0; i < 7; i++) {
            this.calendarWeekdays.push(this.locale.dayNamesShort[dayIndex]);
            dayIndex = (dayIndex == 6) ? 0 : ++dayIndex;
        }
        return;
    };
    /**
     * Generate the calendar month array
     * @return {void}
     * */
    /**
         * Generate the calendar month array
         * @return {void}
         * */
    DatetimeNativeComponent.prototype.generateMonthList = /**
         * Generate the calendar month array
         * @return {void}
         * */
    function () {
        if (this.type === 'timer') {
            return;
        }
        this.calendarMonths = [];
        var monthIndex = 0;
        for (var i = 0; i < 4; i++) {
            var months = [];
            for (var j = 0; j < 3; j++) {
                months.push(this.locale.monthNamesShort[monthIndex]);
                monthIndex += 1;
            }
            this.calendarMonths.push(months);
        }
        return;
    };
    /**
     * Generate the calendar year array
     * @return {void}
     * */
    /**
         * Generate the calendar year array
         * @return {void}
         * */
    DatetimeNativeComponent.prototype.generateYearList = /**
         * Generate the calendar year array
         * @return {void}
         * */
    function (dir) {
        if (!this.pickerMoment) {
            return;
        }
        var start;
        if (dir === 'prev') {
            start = +this.calendarYears[0][0] - 12;
        }
        else if (dir === 'next') {
            start = +this.calendarYears[3][2] + 1;
        }
        else {
            start = date_fns_1.getYear(date_fns_1.addYears(this.pickerMoment, -4));
        }
        for (var i = 0; i < 4; i++) {
            var years = [];
            for (var j = 0; j < 3; j++) {
                var year = (start + i * 3 + j).toString();
                years.push(year);
            }
            this.calendarYears[i] = years;
        }
        return;
    };
    /**
     * Update the calendar
     * @param {Date} value
     * @return {void}
     * */
    /**
         * Update the calendar
         * @param {Date} value
         * @return {void}
         * */
    DatetimeNativeComponent.prototype.updateCalendar = /**
         * Update the calendar
         * @param {Date} value
         * @return {void}
         * */
    function (value) {
        // if the dateTime picker is only the timer,
        // no need to update the update Calendar.
        if (this.type === 'timer') {
            return;
        }
        if (value && (!this.calendarDays || !date_fns_1.isSameMonth(value, this.pickerMoment))) {
            this.pickerMoment = date_fns_1.setMonth(this.pickerMoment, date_fns_1.getMonth(value));
            this.pickerMoment = date_fns_1.setYear(this.pickerMoment, date_fns_1.getYear(value));
            this.generateCalendar();
        }
        else if (!value && !this.calendarDays) {
            this.generateCalendar();
        }
        return;
    };
    /**
     * Update the timer
     * @param {Date} value
     * @return {boolean}
     * */
    /**
         * Update the timer
         * @param {Date} value
         * @return {boolean}
         * */
    DatetimeNativeComponent.prototype.updateTimer = /**
         * Update the timer
         * @param {Date} value
         * @return {boolean}
         * */
    function (value) {
        // if the dateTime picker is only the calendar,
        // no need to update the timer
        if (this.type === 'calendar') {
            return false;
        }
        if (!value && !this.defaultMoment) {
            this.hourValue = null;
            this.minValue = null;
            this.secValue = null;
            return true;
        }
        var time = value || this.parseToDate(this.defaultMoment);
        var hours = date_fns_1.getHours(time);
        if (this.hourFormat === '12') {
            if (hours < 12 && hours > 0) {
                this.hourValue = hours;
                this.meridianValue = 'AM';
            }
            else if (hours > 12) {
                this.hourValue = hours - 12;
                this.meridianValue = 'PM';
            }
            else if (hours === 12) {
                this.hourValue = 12;
                this.meridianValue = 'PM';
            }
            else if (hours === 0) {
                this.hourValue = 12;
                this.meridianValue = 'AM';
            }
        }
        else if (this.hourFormat === '24') {
            this.hourValue = hours;
            //console.log(this.hourValue);
        }
        this.minValue = date_fns_1.getMinutes(time);
        this.secValue = date_fns_1.getSeconds(time);
        return true;
    };
    /**
     * Update ngModel
     * @param {Date} value
     * @return {Boolean}
     * */
    /**
         * Update ngModel
         * @param {Date} value
         * @return {Boolean}
         * */
    DatetimeNativeComponent.prototype.updateModel = /**
         * Update ngModel
         * @param {Date} value
         * @return {Boolean}
         * */
    function (value) {
        this.value = value;
        if (this.dataType === 'date') {
            this.onModelChange(this.value);
        }
        else if (this.dataType === 'string') {
            if (this.value && this.value.length) {
                var formatted = [];
                for (var _i = 0, _a = this.value; _i < _a.length; _i++) {
                    var v = _a[_i];
                    if (v) {
                        formatted.push(date_fns_1.format(v, this.dateFormat, { locale: this.locale.dateFns }));
                    }
                    else {
                        formatted.push(null);
                    }
                }
                this.onModelChange(formatted);
            }
            else {
                this.onModelChange(date_fns_1.format(this.value, this.dateFormat, { locale: this.locale.dateFns }));
            }
        }
        return true;
    };
    /**
     * Update variable formattedValue
     * @return {void}
     * */
    /**
         * Update variable formattedValue
         * @return {void}
         * */
    DatetimeNativeComponent.prototype.updateFormattedValue = /**
         * Update variable formattedValue
         * @return {void}
         * */
    function () {
        var formattedValue = '';
        if (this.value) {
            if (this.isSingleSelection()) {
                //this.value = 2017-12-29T15:24:00.000Z
                if (this.valueFormatDate) {
                    formattedValue = date_fns_1.format(this.valueFormatDate, this.dateFormat, { locale: this.locale.dateFns });
                }
                else {
                    formattedValue = date_fns_1.format(this.value, this.dateFormat, { locale: this.locale.dateFns });
                }
            }
            else if (this.isRangeSelection()) {
                var startDate = this.value[0];
                var endDate = this.value[1];
                formattedValue = date_fns_1.format(startDate, this.dateFormat, { locale: this.locale.dateFns });
                if (endDate) {
                    formattedValue += ' - ' + date_fns_1.format(endDate, this.dateFormat, { locale: this.locale.dateFns });
                }
                else {
                    formattedValue += ' - ' + this.dateFormat;
                }
            }
            else if (this.isMultiSelection()) {
                for (var i = 0; i < this.value.length; i++) {
                    var dateAsString = date_fns_1.format(this.value[i], this.dateFormat, { locale: this.locale.dateFns });
                    formattedValue += dateAsString;
                    if (i !== (this.value.length - 1)) {
                        formattedValue += ', ';
                    }
                }
            }
        }
        this.formattedValue = formattedValue;
        return;
    };
    /**
     * Set the time
     * @param {any} event
     * @param {Date} val
     * @return {boolean}
     * */
    /**
         * Set the time
         * @param {any} event
         * @param {Date} val
         * @return {boolean}
         * */
    DatetimeNativeComponent.prototype.setSelectedTime = /**
         * Set the time
         * @param {any} event
         * @param {Date} val
         * @return {boolean}
         * */
    function (event, val) {
        //console.log('setSelectedTime');
        var done;
        var selected;
        if (this.isSingleSelection()) {
            selected = this.setTimeOnSingleSelection(val);
        }
        else if (this.isRangeSelection()) {
            selected = this.setTimeOnRangeSelection(val);
        }
        else if (this.isMultiSelection()) {
            selected = this.setTimeOnMultiSelection(val);
        }
        if (selected) {
            //console.log(selected)
            //this.value = selected;
            this.valueFormatDate = selected;
            if (!this.showButtons) {
                var newdate2 = new Date(Date.UTC(selected.getFullYear(), selected.getMonth(), selected.getDate(), selected.getHours(), selected.getMinutes())).toISOString();
                //console.log('newdate2', newdate2);
                done = this.updateModel(newdate2);
                this.updateFormattedValue();
            }
            else {
                done = true;
            }
            if (this.value instanceof Array) {
                done = done && this.updateTimer(this.value[this.valueIndex]);
            }
            else {
                done = done && this.updateTimer(this.valueFormatDate);
            }
            this.onSelect.emit({ event: event, value: this.value });
        }
        else {
            this.onInvalid.emit({ originalEvent: event, value: val });
            done = false;
        }
        return done;
    };
    /**
     * set date value on single selection mode
     * @param {Date} moment
     * @return {Date}
     * */
    /**
         * set date value on single selection mode
         * @param {Date} moment
         * @return {Date}
         * */
    DatetimeNativeComponent.prototype.setDateOnSingleSelection = /**
         * set date value on single selection mode
         * @param {Date} moment
         * @return {Date}
         * */
    function (moment) {
        if (!moment || date_fns_1.isSameDay(this.value, moment)) {
            return null;
        }
        var temp;
        /*if (this.value) {
                    let date = getDate(moment);
                    let month = getMonth(moment);
                    let year = getYear(moment);
        
                    temp = setYear(this.value, year);
                    temp = setMonth(temp, month);
                    temp = setDate(temp, date);
                } */
        //else {
        temp = moment;
        //}
        if (this.isValidValue(temp)) {
            return temp;
        }
        else {
            if (date_fns_1.isSameDay(temp, this._min)) {
                return this._min;
            }
            else if (date_fns_1.isSameDay(temp, this._max)) {
                return this._max;
            }
            else {
                this.onInvalid.emit({ originalEvent: event, value: moment });
                return null;
            }
        }
    };
    /**
     * Set time value on single selection mode
     * @param {Date} moment
     * @return {Date}
     * */
    /**
         * Set time value on single selection mode
         * @param {Date} moment
         * @return {Date}
         * */
    DatetimeNativeComponent.prototype.setTimeOnSingleSelection = /**
         * Set time value on single selection mode
         * @param {Date} moment
         * @return {Date}
         * */
    function (moment) {
        if (!moment) {
            return null;
        }
        return this.isValidValue(moment) ? moment : null;
    };
    /**
     * set date value on range selection mode
     * @param {Date} moment
     * @return {Date[]} -- range selection value
     * */
    /**
         * set date value on range selection mode
         * @param {Date} moment
         * @return {Date[]} -- range selection value
         * */
    DatetimeNativeComponent.prototype.setDateOnRangeSelection = /**
         * set date value on range selection mode
         * @param {Date} moment
         * @return {Date[]} -- range selection value
         * */
    function (moment) {
        if (!moment) {
            return null;
        }
        var temp;
        // the the param moment is valid
        if (this.isValidValue(moment)) {
            temp = moment;
        }
        else {
            if (date_fns_1.isSameDay(moment, this._min)) {
                temp = this._min;
            }
            else if (date_fns_1.isSameDay(moment, this._max)) {
                temp = this._max;
            }
            else {
                this.onInvalid.emit({ originalEvent: event, value: moment });
                return null;
            }
        }
        // check if the current value has value
        if (this.value && this.value.length) {
            var startMoment = this.value[0];
            var endMoment = this.value[1];
            // check if there is endMoment value
            if (!endMoment && date_fns_1.differenceInCalendarDays(temp, startMoment) > 0) {
                // if the param moment calendar day is after startMoment calendar day,
                // set the endMoment as moment.
                endMoment = temp;
                this.valueIndex = 1;
            }
            else if (!endMoment && date_fns_1.differenceInCalendarDays(temp, startMoment) === 0) {
                // if the param moment calendar day is the same as startMoment calendar day,
                // set the endMoment as 1 minute(or 1 second) after current startMoment
                temp = this.showSecondsTimer ? date_fns_1.addSeconds(startMoment, 1) : date_fns_1.addMinutes(startMoment, 1);
                // check if the temp value is valid
                endMoment = this.isValidValue(temp) ? temp : null;
                this.valueIndex = 1;
            }
            else {
                startMoment = temp;
                endMoment = null;
                this.valueIndex = 0;
            }
            return [startMoment, endMoment];
        }
        else {
            this.valueIndex = 0;
            return [temp, null];
        }
    };
    /**
     * Set time value on range selection
     * @param {Date} moment
     * @return {Date[]}
     * */
    /**
         * Set time value on range selection
         * @param {Date} moment
         * @return {Date[]}
         * */
    DatetimeNativeComponent.prototype.setTimeOnRangeSelection = /**
         * Set time value on range selection
         * @param {Date} moment
         * @return {Date[]}
         * */
    function (moment) {
        if (!moment) {
            return null;
        }
        if (this.isValidValue(moment)) {
            // check if the param moment value is after the start moment of the range
            if (this.valueIndex > 0 && date_fns_1.isAfter(moment, this.value[0])) {
                return [this.value[0], moment];
            }
            else {
                // if the param moment value is before the start moment of the range,
                // we reset the start moment of the range to the param moment value
                // and the the end moment of the range to null
                return [moment, null];
            }
        }
        else {
            return null;
        }
    };
    /**
     * Set date value on multiple selection mode
     * @param {Date} moment
     * @return {Date[]}
     * */
    /**
         * Set date value on multiple selection mode
         * @param {Date} moment
         * @return {Date[]}
         * */
    DatetimeNativeComponent.prototype.setDateOnMultiSelection = /**
         * Set date value on multiple selection mode
         * @param {Date} moment
         * @return {Date[]}
         * */
    function (moment) {
        if (!moment) {
            return null;
        }
        // check if it exceeds the maxDateCount limit
        if (this.maxDateCount && this.value &&
            this.value.length && this.value.length >= this.maxDateCount) {
            this.onInvalid.emit({ originalEvent: event, value: 'Exceed max date count.' });
            return null;
        }
        // if the param moment's date has been selected,
        // we deselect that date.
        if (this.isSelectedDay(moment)) {
            return this.value.filter(function (d) {
                return !date_fns_1.isSameDay(d, moment);
            });
        }
        var temp;
        // check if the selected date is valid
        if (this.isValidValue(moment)) {
            temp = moment;
        }
        else {
            if (date_fns_1.isSameDay(moment, this._min)) {
                temp = this._min;
            }
            else if (date_fns_1.isSameDay(moment, this._max)) {
                temp = this._max;
            }
            else {
                this.onInvalid.emit({ originalEvent: event, value: moment });
                return null;
            }
        }
        var selected = this.value ? this.value.concat([temp]) : [temp];
        this.valueIndex = selected.length - 1;
        return selected;
    };
    /**
     * Set time value on multiple selection mode
     * @param {Date} moment
     * @return {Date[]}
     * */
    /**
         * Set time value on multiple selection mode
         * @param {Date} moment
         * @return {Date[]}
         * */
    DatetimeNativeComponent.prototype.setTimeOnMultiSelection = /**
         * Set time value on multiple selection mode
         * @param {Date} moment
         * @return {Date[]}
         * */
    function (moment) {
        var _this = this;
        if (!moment) {
            return null;
        }
        if (this.isValidValue(moment)) {
            var selected = this.value.map(function (m, index) {
                if (index === _this.valueIndex) {
                    return moment;
                }
                else {
                    return m;
                }
            });
            return selected;
        }
        else {
            return null;
        }
    };
    DatetimeNativeComponent.prototype.isValidValue = function (value) {
        var isValid = true;
        if (this.disabledDates && this.disabledDates.length) {
            for (var _i = 0, _a = this.disabledDates; _i < _a.length; _i++) {
                var disabledDate = _a[_i];
                if (date_fns_1.isSameDay(disabledDate, value)) {
                    return false;
                }
            }
        }
        if (isValid && this.disabledDays && this.disabledDays.length) {
            var weekdayNum = date_fns_1.getDay(value);
            isValid = this.disabledDays.indexOf(weekdayNum) === -1;
        }
        if (isValid && this.min) {
            isValid = isValid && !date_fns_1.isBefore(value, this.min);
        }
        if (isValid && this.max) {
            isValid = isValid && !date_fns_1.isAfter(value, this.max);
        }
        return isValid;
    };
    /**
     * Check if the selection mode is 'single'
     * @return {boolean}
     * */
    /**
         * Check if the selection mode is 'single'
         * @return {boolean}
         * */
    DatetimeNativeComponent.prototype.isSingleSelection = /**
         * Check if the selection mode is 'single'
         * @return {boolean}
         * */
    function () {
        return this.selectionMode === 'single';
    };
    /**
     * Check if the selection mode is 'range'
     * @return {boolean}
     * */
    /**
         * Check if the selection mode is 'range'
         * @return {boolean}
         * */
    DatetimeNativeComponent.prototype.isRangeSelection = /**
         * Check if the selection mode is 'range'
         * @return {boolean}
         * */
    function () {
        return this.selectionMode === 'range';
    };
    /**
     * Check if the selection mode is 'multiple'
     * @return {boolean}
     * */
    /**
         * Check if the selection mode is 'multiple'
         * @return {boolean}
         * */
    DatetimeNativeComponent.prototype.isMultiSelection = /**
         * Check if the selection mode is 'multiple'
         * @return {boolean}
         * */
    function () {
        return this.selectionMode === 'multiple';
    };
    /**
     * Parse a string to date value
     * @param text {string}
     * @return Date | Date[]
     * */
    /**
         * Parse a string to date value
         * @param text {string}
         * @return Date | Date[]
         * */
    DatetimeNativeComponent.prototype.parseValueFromString = /**
         * Parse a string to date value
         * @param text {string}
         * @return Date | Date[]
         * */
    function (text) {
        //  console.log('parseValueFromString');
        if (!text || text.trim().length === 0) {
            return null;
        }
        var value;
        if (this.isSingleSelection()) {
            value = this.parseToDate(text);
        }
        else if (this.isMultiSelection()) {
            var tokens = text.split(',');
            value = [];
            for (var _i = 0, tokens_1 = tokens; _i < tokens_1.length; _i++) {
                var token = tokens_1[_i];
                value.push(this.parseToDate(token.trim()));
            }
        }
        else if (this.isRangeSelection()) {
            var tokens = text.split(' - ');
            value = [];
            for (var i = 0; i < tokens.length; i++) {
                value[i] = this.parseToDate(tokens[i].trim());
            }
        }
        return value;
    };
    /**
     * Runs a timeout outside of the Angular zone to avoid triggering the change detection.
     * @param {Function} fn
     * @param {number} delay -- optional
     * @return {void}
     */
    /**
         * Runs a timeout outside of the Angular zone to avoid triggering the change detection.
         * @param {Function} fn
         * @param {number} delay -- optional
         * @return {void}
         */
    DatetimeNativeComponent.prototype.runTimeoutOutsideZone = /**
         * Runs a timeout outside of the Angular zone to avoid triggering the change detection.
         * @param {Function} fn
         * @param {number} delay -- optional
         * @return {void}
         */
    function (fn, delay) {
        if (!delay) {
            delay = 0;
        }
        this.ngZone.runOutsideAngular(function () {
            return setTimeout(fn, delay);
        });
    };
    DatetimeNativeComponent.prototype.getHiddenElementDimensions = function (element) {
        var dimensions = {};
        element.style.visibility = 'hidden';
        element.style.display = 'block';
        dimensions.width = element.offsetWidth;
        dimensions.height = element.offsetHeight;
        element.style.display = 'none';
        element.style.visibility = 'visible';
        return dimensions;
    };
    DatetimeNativeComponent.prototype.getViewport = function () {
        var win = window, d = document, e = d.documentElement, g = d.getElementsByTagName('body')[0], w = win.innerWidth || e.clientWidth || g.clientWidth, h = win.innerHeight || e.clientHeight || g.clientHeight;
        return { width: w, height: h };
    };
    DatetimeNativeComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        $(this.textInputElm.nativeElement).mask('00/00/0000 00:00');
        this.valueChangeSubscription = this.onChangeValue.subscribe(function (ret) {
            //console.log('datetime native componente:', ret);
            if (typeof ret == 'number') {
                //recebe essa data: Fri Dec 29 2017 15:24:00 GMT-0200 (-02)
                //e está transformando errado a hora: 2017-12-29T17:24:00.000Z
                var data = new Date(ret);
                _this.valueFormatDate = data;
                _this.value = new Date(Date.UTC(data.getFullYear(), data.getMonth(), data.getDate(), data.getHours(), data.getMinutes())).toISOString();
                _this.updateModel(_this.value);
                _this.updateFormattedValue();
            }
            /*
                        if (typeof ret == 'string') {
                            if (ret) {
                                this.blur(ret);
                            } else {
                                this.dateComp = null;
                                this.dateComp1 = null;
                                this.dateComp2 = null;
                            }
                        } else if (typeof ret == 'number') {
                            this.value = new Date(ret).toISOString();
                        }*/
        });
    };
    DatetimeNativeComponent.prototype.modelChanged = function (date) {
        if (this.component.value != "") {
            var data = this.component.value;
            //29/12/2017 15:24
            var ano = data.slice(6, 10);
            var mes = data.slice(3, 5);
            var dia = data.slice(0, 2);
            var hora = data.slice(11, 13);
            var min = data.slice(14, 16);
            var mesAlterado = parseInt(mes);
            mesAlterado--;
            var datahora = new Date(ano, mesAlterado, dia, hora, min);
            this.valueFormatDate = datahora;
            var newdate2 = new Date(Date.UTC(ano, mesAlterado, dia, hora, min)).toISOString();
            this.updateModel(newdate2);
            this.updateFormattedValue();
        }
        else {
            this.updateModel(null);
            this.updateFormattedValue();
        }
    };
    DatetimeNativeComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'sbm-datetime-native',
                    template: require('./datetime-native.component.html'),

                    styles: [require('./datetime-native.component.css')],
                    providers: [numberfixedlen_pipe_1.NumberfixedlenPipe, exports.DATETIMEPICKER_VALUE_ACCESSOR],
                    animations: [
                        animations_1.trigger('fadeInOut', [
                            animations_1.state('hidden', animations_1.style({
                                opacity: 0,
                                display: 'none'
                            })),
                            animations_1.state('visible', animations_1.style({
                                opacity: 1,
                                display: 'block'
                            })),
                            animations_1.transition('visible => hidden', animations_1.animate('200ms ease-in')),
                            animations_1.transition('hidden => visible', animations_1.animate('400ms ease-out'))
                        ])
                    ],
                },] },
    ];
    /** @nocollapse */
    DatetimeNativeComponent.ctorParameters = function () { return [
        { type: core_1.Renderer2, },
        { type: core_1.NgZone, },
        { type: numberfixedlen_pipe_1.NumberfixedlenPipe, },
        { type: sharedService_1.SharedService, },
        { type: http_1.Http, },
        { type: core_2.TranslateService, },
    ]; };
    DatetimeNativeComponent.propDecorators = {
        "autoClose": [{ type: core_1.Input },],
        "dataType": [{ type: core_1.Input },],
        "dateFormat": [{ type: core_1.Input },],
        "defaultMoment": [{ type: core_1.Input },],
        "disabled": [{ type: core_1.Input },],
        "disabledDates": [{ type: core_1.Input },],
        "disabledDays": [{ type: core_1.Input },],
        "hideClearButton": [{ type: core_1.Input },],
        "inline": [{ type: core_1.Input },],
        "inputId": [{ type: core_1.Input },],
        "inputStyle": [{ type: core_1.Input },],
        "inputStyleClass": [{ type: core_1.Input },],
        "maxDateCount": [{ type: core_1.Input },],
        "max": [{ type: core_1.Input },],
        "min": [{ type: core_1.Input },],
        "placeHolder": [{ type: core_1.Input },],
        "readonlyInput": [{ type: core_1.Input },],
        "required": [{ type: core_1.Input },],
        "selectionMode": [{ type: core_1.Input },],
        "showButtons": [{ type: core_1.Input },],
        "showHeader": [{ type: core_1.Input },],
        "showSecondsTimer": [{ type: core_1.Input },],
        "style": [{ type: core_1.Input },],
        "styleClass": [{ type: core_1.Input },],
        "tabIndex": [{ type: core_1.Input },],
        "type": [{ type: core_1.Input },],
        "locale": [{ type: core_1.Input },],
        "hourFormat": [{ type: core_1.Input },],
        "showOtherMonths": [{ type: core_1.Input },],
        "onClear": [{ type: core_1.Output },],
        "onClose": [{ type: core_1.Output },],
        "onConfirm": [{ type: core_1.Output },],
        "onInvalid": [{ type: core_1.Output },],
        "onSelect": [{ type: core_1.Output },],
        "containerElm": [{ type: core_1.ViewChild, args: ['container',] },],
        "textInputElm": [{ type: core_1.ViewChild, args: ['textInput',] },],
        "dialogElm": [{ type: core_1.ViewChild, args: ['dialog',] },],
        "hoursInput": [{ type: core_1.ViewChild, args: ['hoursInput',] },],
        "minutesInput": [{ type: core_1.ViewChild, args: ['minutesInput',] },],
    };
    return DatetimeNativeComponent;
}(abstract_ngmodel_1.AbstractNgModel));
exports.DatetimeNativeComponent = DatetimeNativeComponent;
