"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var req_http_service_1 = require("../../services/req-http.service");
var sharedService_1 = require("../../models/sharedService");
var core_2 = require("@ngx-translate/core");
var http_1 = require("@angular/http");
var filter_pipe_1 = require("../../pipes/filter.pipe");
var DragComponent = /** @class */ (function (_super) {
    __extends(DragComponent, _super);
    function DragComponent(_reqHttpService, _sharedService, _translateService, _http, _pipeFilter) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._reqHttpService = _reqHttpService;
        _this._sharedService = _sharedService;
        _this._translateService = _translateService;
        _this._http = _http;
        _this._pipeFilter = _pipeFilter;
        _this.droppedItems = [];
        _this.items = [];
        _this.itemsHide = [];
        _this.filterList = [];
        _this.onDropFromDrop = new core_1.EventEmitter();
        _this.callBackDrag = new core_1.EventEmitter();
        _this.securityId = '';
        _this.id = '';
        _this.title = '';
        _this.emptyMessage = 'Vazio';
        _this.textdrag = 'Drag';
        _this.keepItems = false;
        _this._design = 'simple';
        _this.itemSrc = 'assets';
        _this.itemLink = 'principal';
        _this.itemIcon = 'null';
        _this.itemTitle = 'title';
        _this.itemDesc = 'title';
        _this.reqIndex = 'data';
        _this.itemDisable = 'visible';
        _this.itemTextButton = 'title';
        _this.iconItems = 'more_horiz';
        _this.iconItems2 = 'more_horiz';
        _this.itemButtonHidden = false;
        _this.itemButtonHidden2 = false;
        _this.itemButtonDisabled = false;
        _this.itemButtonDisabled2 = false;
        _this.itemKey = '';
        _this.itemDisabled = false;
        _this.dropScope = ['drop1'];
        _this.dragScope = 'drag1';
        _this.disabled = false;
        _this.onDragEnd = new core_1.EventEmitter();
        _this.onButtonSelect = new core_1.EventEmitter();
        _this.onButtonSelectTwo = new core_1.EventEmitter();
        _this.onDrop = new core_1.EventEmitter();
        _this._columns = 'col l12 s12 m12';
        _this.onDropFromDrop.subscribe(function (e) {
            e.drag_visible = true;
            _this.itemsHide = $.grep(_this.items, function (item, index) { return item['drag_visible'] == true; });
            _this.filterItems();
        });
        return _this;
    }
    Object.defineProperty(DragComponent.prototype, "design", {
        get: function () {
            return this._design;
        },
        set: function (val) {
            if (val == 'avatar' || val == 'blocks' || val == 'actionButton') {
                this._design = val;
            }
            else {
                this._design = 'simple';
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DragComponent.prototype, "dataSource", {
        get: function () {
            return this._dataSource;
        },
        set: function (val) {
            this._dataSource = val;
            this.changeDataSorce(val);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DragComponent.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = "col l" + value + " s12 m12";
        },
        enumerable: true,
        configurable: true
    });
    DragComponent.prototype.buttonItemSelect = function (item) {
        this.onButtonSelect.emit(item);
    };
    DragComponent.prototype.buttonItemSelect2 = function (item) {
        this.onButtonSelectTwo.emit(item);
    };
    DragComponent.prototype.reqService = function (url) {
        var _this = this;
        this._reqHttpService.xhrGet(url).subscribe(function (ret) {
            _this.dataSource = ret.res[_this.reqIndex];
        });
    };
    DragComponent.prototype.changeDataSorce = function (val) {
        var _this = this;
        if (typeof val == 'object') {
            val.map(function (item, index) {
                item['dragScope'] = _this.dragScope;
                item['index'] = index;
                item['drag_visible'] = true;
                item['parent_drop_emitter'] = _this.onDropFromDrop;
                // item['instanceDrag'] = this;
            });
            this.itemsHide = val.filter(function (itm) { return (itm['drag_visible']); });
            this.items = val;
            this.filterItems();
        }
        else {
            this.reqService(val);
        }
    };
    DragComponent.prototype.filterItems = function () {
        this.filterList = this._pipeFilter.transform(Object.assign([], this.items).filter(function (item) { return item.drag_visible; }), this.filterSearch);
    };
    DragComponent.prototype.dragEndStart = function (e) {
        this.currentDrag = e;
    };
    DragComponent.prototype.dragEnd = function (e) {
        this.filterItems();
        if (this.filterList.length == 0) {
            this.filterSearch = '';
            this.filterItems();
        }
        this.onDragEnd.emit(e);
    };
    DragComponent.prototype.onItemDrop = function (e) {
        // if (e['dragData']['item'].onDropBack) { e['dragData']['item'].onDropBack.emit(e['dragData']['item']); }
        // e['dragData']['item'].drag_visible = true;
        // this.itemsHide = $.grep(this.items, (item, index) => item['drag_visible'] == true);
        // this.filterItems();
        // if (e['dragData']['item'].dragScope == this.currentDrag.dragScope && e['dragData']['item'].id != this.currentDrag.id) {
        //     this.onDrop.emit(e);
        // }
    };
    DragComponent.prototype.onItemDropInstance = function (e, dropInstance) {
        var _this = this;
        var verif;
        if (this.itemKey == '') {
            verif = dropInstance.droppedItems.filter(function (item) { return JSON.stringify(item) == JSON.stringify(e); });
        }
        else {
            verif = dropInstance.droppedItems.filter(function (item) { return item[_this.itemKey] == e[_this.itemKey]; });
        }
        if (verif.length > 0) {
            var items = this.items;
            dropInstance.isDropped = true;
            items.forEach(function (item, index) {
                if (_this.itemKey == '') {
                    if (JSON.stringify(item) == JSON.stringify(e)) {
                        _this.items[item['index'] ? item['index'] : index]['drag_visible'] = true;
                    }
                }
                else {
                    if (item[_this.itemKey] == e[_this.itemKey]) {
                        _this.items[item['index'] ? item['index'] : index]['drag_visible'] = true;
                    }
                }
            });
            this.itemsHide = this.items.filter(function (itm) { return (itm['drag_visible']); });
            dropInstance.droppedItems.forEach(function (item, index) {
                if (dropInstance.itemKey == '') {
                    if (JSON.stringify(item) == JSON.stringify(e)) {
                        dropInstance.droppedItems.splice(index, 1);
                        dropInstance.instanceDrag.splice(index, 1);
                    }
                }
                else {
                    if (item[_this.itemKey] == e[_this.itemKey]) {
                        dropInstance.droppedItems.splice(index, 1);
                        dropInstance.instanceDrag.splice(index, 1);
                    }
                }
            });
            dropInstance.value = dropInstance.removeIndexes(dropInstance.droppedItems);
            dropInstance.onDragItem.emit(e);
            dropInstance.onDragItem.subscribe(function (e) { });
        }
    };
    DragComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
    };
    DragComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'sbm-drag',
                    template: require('./drag.component.html'),

                    styles: [require('./drag.component.css')],
                    host: {
                        '[class]': 'columns',
                        '[ngClass]': "{'dragDisabled': disabled}"
                    },
                    providers: [abstract_ngmodel_1.MakeProvider(DragComponent)]
                },] },
    ];
    /** @nocollapse */
    DragComponent.ctorParameters = function () { return [
        { type: req_http_service_1.ReqHttpService, },
        { type: sharedService_1.SharedService, },
        { type: core_2.TranslateService, },
        { type: http_1.Http, },
        { type: filter_pipe_1.FilterAllPipe, },
    ]; };
    DragComponent.propDecorators = {
        "securityId": [{ type: core_1.Input },],
        "id": [{ type: core_1.Input },],
        "title": [{ type: core_1.Input },],
        "emptyMessage": [{ type: core_1.Input },],
        "textdrag": [{ type: core_1.Input },],
        "keepItems": [{ type: core_1.Input },],
        "design": [{ type: core_1.Input },],
        "itemSrc": [{ type: core_1.Input },],
        "itemLink": [{ type: core_1.Input },],
        "itemIcon": [{ type: core_1.Input },],
        "itemTitle": [{ type: core_1.Input },],
        "itemDesc": [{ type: core_1.Input },],
        "reqIndex": [{ type: core_1.Input },],
        "itemDisable": [{ type: core_1.Input },],
        "itemTextButton": [{ type: core_1.Input },],
        "iconItems": [{ type: core_1.Input },],
        "iconItems2": [{ type: core_1.Input },],
        "itemButtonHidden": [{ type: core_1.Input },],
        "itemButtonHidden2": [{ type: core_1.Input },],
        "itemButtonDisabled": [{ type: core_1.Input },],
        "itemButtonDisabled2": [{ type: core_1.Input },],
        "itemKey": [{ type: core_1.Input },],
        "itemDisabled": [{ type: core_1.Input },],
        "dropScope": [{ type: core_1.Input },],
        "dragScope": [{ type: core_1.Input },],
        "disabled": [{ type: core_1.Input },],
        "onDragEnd": [{ type: core_1.Output },],
        "onButtonSelect": [{ type: core_1.Output },],
        "onButtonSelectTwo": [{ type: core_1.Output },],
        "onDrop": [{ type: core_1.Output },],
        "dataSource": [{ type: core_1.Input },],
        "columns": [{ type: core_1.Input },],
    };
    return DragComponent;
}(abstract_ngmodel_1.AbstractNgModel));
exports.DragComponent = DragComponent;
