"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var sharedService_1 = require("../../models/sharedService");
var core_2 = require("@ngx-translate/core");
var http_1 = require("@angular/http");
var filter_pipe_1 = require("../../pipes/filter.pipe");
var DropComponent = /** @class */ (function (_super) {
    __extends(DropComponent, _super);
    function DropComponent(_sharedService, _translateService, _http, _pipeFilter) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._sharedService = _sharedService;
        _this._translateService = _translateService;
        _this._http = _http;
        _this._pipeFilter = _pipeFilter;
        _this._droppedItems = [];
        _this.items = [];
        _this.instanceDrag = [];
        _this.filterList = [];
        _this.dropCircular = false;
        _this.callDrop = new core_1.EventEmitter();
        _this.callBackRemove = new core_1.EventEmitter();
        _this.onDropBack = new core_1.EventEmitter();
        _this.isDropped = false;
        _this.emptyMessage = 'Vazio';
        _this.keepItems = false;
        _this._design = 'simple';
        _this.itemSrc = 'assets';
        _this.itemLink = 'principal';
        _this.itemIcon = 'grade';
        _this.itemTitle = 'title';
        _this.itemTextButton = 'title';
        _this.itemButtonHidden = false;
        _this.itemButtonHidden2 = false;
        _this.itemButtonDisabled = false;
        _this.itemButtonDisabled2 = false;
        _this.iconItems = 'more_horiz';
        _this.iconItems2 = 'more_horiz';
        _this.itemDisabled = false;
        _this.itemDesc = 'title';
        _this.itemKey = '';
        _this.dropScope = ['drop1'];
        _this.dropEnabled = true;
        _this.labelInstalled = '';
        _this.onDropItem = new core_1.EventEmitter();
        _this.onDragItem = new core_1.EventEmitter();
        _this.onButtonSelect = new core_1.EventEmitter();
        _this.onButtonSelectTwo = new core_1.EventEmitter();
        _this.dragMoveVars = {
            offsetY: 0,
            targetIndex: 0,
            targetHash: null,
            siblings: {
                prev: null,
                next: null,
            },
            changesToDo: [],
        };
        // this.onDropBack.subscribe((e) => {
        //     for (let index in this.droppedItems) {
        //         if (e.id === this.droppedItems[index].id && e.dragScope === this.droppedItems[index].dragScope) {
        //             this.droppedItems.splice(index, 1);
        //         };
        //     }
        //     this.value = this.removeIndexes(this.droppedItems);
        //     this.filterItems();
        //     if (this.filterList.length == 0) {
        //         this.filterSearch = '';
        //         this.filterItems();
        //     }
        // });
        return _this;
    }
    Object.defineProperty(DropComponent.prototype, "droppedItems", {
        get: function () {
            return this._droppedItems;
        },
        set: function (val) {
            this._droppedItems = val;
            // this.value = this._droppedItems;
        },
        enumerable: true,
        configurable: true
    });
    ;
    ;
    Object.defineProperty(DropComponent.prototype, "design", {
        get: function () {
            return this._design;
        },
        set: function (val) {
            if (val == 'avatar' || val == 'blocks' || val == 'actionButton') {
                this._design = val;
            }
            else {
                this._design = 'simple';
            }
        },
        enumerable: true,
        configurable: true
    });
    DropComponent.prototype.buttonItemSelect = function (item) {
        this.onButtonSelect.emit(item);
    };
    DropComponent.prototype.buttonItemSelect2 = function (item) {
        this.onButtonSelectTwo.emit(item);
    };
    DropComponent.prototype.removeIndexes = function (array) {
        var newValue = [];
        array.forEach(function (item) {
            var keys = Object.keys(item);
            var object = {};
            keys.forEach(function (key) {
                if ((key != "dragScope" && key != "index" && key != "drag_visible" && key != "onDropBack" && key != "parent_drop_emitter" && key != "dropOrder")) {
                    object[key] = item[key];
                }
            });
            newValue.push(object);
        });
        this.filterItems();
        return newValue;
    };
    DropComponent.prototype.filterItems = function () {
        this.filterList = this._pipeFilter.transform(Object.assign([], this.droppedItems), this.filterSearch);
    };
    DropComponent.prototype.dragEndStart = function (e, instanceDrag) {
        e['onDropBack'] = this.onDropBack;
        /*instanceDrag['instance'].onDrop.subscribe(ret => {
                    instanceDrag['instance'].onItemthis(e, this);
                    // this.onDragItem.emit(e);
                });*/
        this.elementDrop = e;
    };
    DropComponent.prototype.dragMove = function (e, event) {
        var element = event.target;
        var element$ = $(element).closest('mat-list-item');
        var element$parent = $(element).closest('mat-list-item').parent();
        if (!element$.attr('data-hash')) {
            element$.attr('data-hash', (new Date()).getTime());
        }
        if (this.dragMoveVars.targetHash != element$.attr('data-hash')) {
            for (var index in this.droppedItems) {
                if (e.id == this.droppedItems[index].id && e.dragScope === this.droppedItems[index].dragScope) {
                    this.dragMoveVars.targetIndex = parseInt(index);
                    break;
                }
            }
            this.dragMoveVars.offsetY = 0;
            this.dragMoveVars.targetHash = element$.attr('data-hash');
            if (this.dragMoveVars.offsetY === 0) {
                this.dragMoveVars.offsetY = event.offsetY;
            }
        }
        var offsetY = event.offsetY - this.dragMoveVars.offsetY;
        var distance = element$.outerHeight();
        var indexOffset = 0;
        $('> mat-list-item', element$parent).removeClass('drop-after drop-before');
        if (!this.dragMoveVars.changesToDo[0]) {
            this.dragMoveVars.changesToDo.push({
                element: e,
                newIndex: null,
            });
        }
        if (Math.ceil(offsetY / distance) <= -1) {
            indexOffset = Math.ceil(offsetY / distance);
            if ((element$.index() + indexOffset >= 0) &&
                $('> mat-list-item:eq(' + (element$.index() + indexOffset) + ')', element$parent).length > 0) {
                $('> mat-list-item:eq(' + (element$.index() + indexOffset) + ')', element$parent).addClass('drop-before');
                this.dragMoveVars.changesToDo[0].newIndex = (element$.index() + indexOffset);
            }
            else {
                $('> mat-list-item:eq(0)', element$parent).addClass('drop-before');
                this.dragMoveVars.changesToDo[0].newIndex = 0;
            }
        }
        else if (Math.floor(offsetY / distance) >= 2) {
            indexOffset = Math.floor(offsetY / distance) - 1;
            if ((element$.index() + indexOffset <= ($('> mat-list-item', element$parent).length - 1)) &&
                $('> mat-list-item:eq(' + (element$.index() + indexOffset) + ')', element$parent).length > 0) {
                $('> mat-list-item:eq(' + (element$.index() + indexOffset) + ')', element$parent).addClass('drop-after');
                this.dragMoveVars.changesToDo[0].newIndex = (element$.index() + indexOffset);
            }
            else {
                $('> mat-list-item:eq(' + ($('> mat-list-item', element$parent).length - 1) + ')', element$parent).addClass('drop-after');
                this.dragMoveVars.changesToDo[0].newIndex = ($('> mat-list-item', element$parent).length - 1);
            }
        }
        else {
            this.dragMoveVars.changesToDo.splice(0, 1);
        }
    };
    DropComponent.prototype.dragEnd = function (e, event) {
        $(event.target).closest('mat-list').find('mat-list-item').removeClass('drop-after drop-before');
        if (!this.dropCircular) {
            for (var index in this.droppedItems) {
                if (e.id === this.droppedItems[index].id && e.dragScope === this.droppedItems[index].dragScope) {
                    this.droppedItems.splice(index, 1);
                }
                ;
            }
            this.value = this.removeIndexes(this.droppedItems);
            this.filterItems();
            if (this.filterList.length == 0) {
                this.filterSearch = '';
                this.filterItems();
            }
            e.parent_drop_emitter.emit(e);
        }
        else {
            var reorderIndex = null;
            for (var index in this.droppedItems) {
                if (this.droppedItems[index].id == this.dragMoveVars.changesToDo[0].element.id &&
                    this.droppedItems[index].dragScope == this.dragMoveVars.changesToDo[0].element.dragScope) {
                    reorderIndex = index;
                    break;
                }
            }
            this.droppedItems.splice(reorderIndex, 1);
            this.droppedItems.splice(this.dragMoveVars.changesToDo[0].newIndex, 0, this.dragMoveVars.changesToDo[0].element);
            this.filterItems();
            this.dragMoveVars.changesToDo = [];
        }
        this.dropCircular = false;
    };
    DropComponent.prototype.onItemDrop = function (e) {
        if (!e['dragData']['instance']) {
            this.dropCircular = true;
        }
        var eventItem = e['dragData']['item'];
        if ($.grep(this.droppedItems, function (item, index) { return item['id'] == eventItem.id && item['dragScope'] == eventItem.dragScope; }).length == 0) {
            eventItem['dropOrder'] = this.droppedItems.length;
            this.droppedItems.push(eventItem);
            this.value = this.removeIndexes(this.droppedItems);
            if (e['dragData']['instance']) {
                if (!e['dragData']['instance']['keepItems']) {
                    e['dragData']['instance'].items[e['dragData']['item']['index']].drag_visible = false;
                    e['dragData']['instance'].itemsHide = e['dragData']['instance'].items.filter(function (item) { return (item['drag_visible']); });
                }
            }
        }
    };
    DropComponent.prototype.clearItems = function () {
        for (var index in this.droppedItems) {
            this.droppedItems[index].parent_drop_emitter.emit(this.droppedItems[index]);
        }
        this.droppedItems = [];
        this.value = this.removeIndexes(this.droppedItems);
        this.filterSearch = '';
        this.filterItems();
    };
    DropComponent.prototype.removeItem = function ($item) {
        this.callBackRemove.emit($item);
    };
    DropComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
    };
    DropComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        this.onChangeValue.subscribe(function (val) {
            if (typeof val === 'object') {
                if (val.length === 0) {
                    if (_this.instanceDrag.length > 0) {
                        _this.instanceDrag.forEach(function (drag) {
                            if (drag['instance'].items.length > 0) {
                                drag['instance'].items.forEach(function (item, index) {
                                    item['drag_visible'] = true;
                                });
                                drag['instance'].itemsHide = drag['instance'].items.filter(function (itm) { return (itm['drag_visible']); });
                            }
                        });
                    }
                    _this.droppedItems = [];
                }
            }
        });
    };
    DropComponent.decorators = [
        { type: core_1.Injectable },
        { type: core_1.Component, args: [{
                    selector: 'sbm-drop',
                    template: require('./drop.component.html'),

                    styles: [require('./drop.component.css')],
                    host: {
                        '[class]': 'columns'
                    },
                    providers: [abstract_ngmodel_1.MakeProvider(DropComponent)]
                },] },
    ];
    /** @nocollapse */
    DropComponent.ctorParameters = function () { return [
        { type: sharedService_1.SharedService, },
        { type: core_2.TranslateService, },
        { type: http_1.Http, },
        { type: filter_pipe_1.FilterAllPipe, },
    ]; };
    DropComponent.propDecorators = {
        "emptyMessage": [{ type: core_1.Input },],
        "keepItems": [{ type: core_1.Input },],
        "design": [{ type: core_1.Input },],
        "itemSrc": [{ type: core_1.Input },],
        "itemLink": [{ type: core_1.Input },],
        "itemIcon": [{ type: core_1.Input },],
        "itemTitle": [{ type: core_1.Input },],
        "itemTextButton": [{ type: core_1.Input },],
        "itemButtonHidden": [{ type: core_1.Input },],
        "itemButtonHidden2": [{ type: core_1.Input },],
        "itemButtonDisabled": [{ type: core_1.Input },],
        "itemButtonDisabled2": [{ type: core_1.Input },],
        "iconItems": [{ type: core_1.Input },],
        "iconItems2": [{ type: core_1.Input },],
        "itemDisabled": [{ type: core_1.Input },],
        "itemDesc": [{ type: core_1.Input },],
        "itemKey": [{ type: core_1.Input },],
        "dropScope": [{ type: core_1.Input },],
        "dropEnabled": [{ type: core_1.Input },],
        "labelInstalled": [{ type: core_1.Input },],
        "onDropItem": [{ type: core_1.Output },],
        "onDragItem": [{ type: core_1.Output },],
        "onButtonSelect": [{ type: core_1.Output },],
        "onButtonSelectTwo": [{ type: core_1.Output },],
    };
    return DropComponent;
}(abstract_ngmodel_1.AbstractNgModel));
exports.DropComponent = DropComponent;
