"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@ngx-translate/core");
var http_1 = require("@angular/http");
var core_2 = require("@angular/core");
var sharedService_1 = require("../../models/sharedService");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var EditorComponent = /** @class */ (function (_super) {
    __extends(EditorComponent, _super);
    function EditorComponent(_translateService, _http, _sharedService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._translateService = _translateService;
        _this._http = _http;
        _this._sharedService = _sharedService;
        _this._row = 5;
        _this.isCreated = false;
        _this.options = [
            ["bold", "italic", "underline", "strike"],
            // toggled buttons
            ["blockquote", "image", "link"],
            [{ header: 1 }, { header: 2 }],
            // custom button values
            [{ list: "ordered" }, { list: "bullet" }],
            [{ script: "sub" }, { script: "super" }],
            // superscript/subscript
            [{ indent: "-1" }, { indent: "+1" }],
            // outdent/indent
            [{ direction: "rtl" }],
            // text direction
            [{ size: ["small", false, "large", "huge"] }],
            // custom dropdown
            [{ header: [1, 2, 3, 4, 5, 6, false] }],
            [{ color: [] }, { background: [] }],
            // dropdown with defaults from theme
            [{ font: [] }],
            [{ align: [] }],
            ["clean"] // remove formatting button
        ];
        sbmEditorComponent.push(_this);
        return _this;
    }
    Object.defineProperty(EditorComponent.prototype, "row", {
        get: function () {
            return this._row;
        },
        set: function (vlr) {
            if (vlr < 3) {
                vlr = (vlr < 1) ? 1 : vlr;
                this.alturaHeight = (vlr * 40) + 'px';
            }
            else {
                this.alturaHeight = (vlr * 25) + 'px';
            }
            this._row = vlr;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(EditorComponent.prototype, "html", {
        get: function () {
            return this._html;
        },
        set: function (html) {
            if (html) {
                this._html = html;
                this.value = html;
            }
        },
        enumerable: true,
        configurable: true
    });
    EditorComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
        this.classCss += " " + this.css;
        this.value = { text: "", html: "" };
    };
    EditorComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        this.quill = new Quill("#editor", {
            theme: "snow",
            modules: {
                toolbar: this.options
            }
        });
        var subscription = this.onChangeValue.subscribe(function (ret) {
            $(_this.quill.root).html(ret);
            subscription.unsubscribe();
        });
        this.isCreated = true;
        this.quill.on("text-change", function (delta, oldDelta, source) {
            if (_this.maxLength != "") {
                if ($(_this.quill.root).text().length <= _this.maxLength) {
                    _this.value = {
                        text: $(_this.quill.root).text(),
                        html: $(_this.quill.root).html()
                    };
                }
                else {
                    $(_this.quill.root).attr("contenteditable", false);
                }
            }
            else {
                _this.value = {
                    texto: $(_this.quill.root).text(),
                    html: $(_this.quill.root).html()
                };
            }
        });
    };
    EditorComponent.decorators = [
        { type: core_2.Component, args: [{
                    selector: "sbm-editor",
                    template: require('./editor.component.html'),

                    host: {
                        "[class]": "classCss"
                    },
                    providers: [
                        abstract_ngmodel_1.MakeProvider(EditorComponent),
                        {
                            provide: abstract_ngmodel_1.AbstractNgModel,
                            useExisting: core_2.forwardRef(function () { return EditorComponent; })
                        }
                    ]
                },] },
    ];
    /** @nocollapse */
    EditorComponent.ctorParameters = function () { return [
        { type: core_1.TranslateService, },
        { type: http_1.Http, },
        { type: sharedService_1.SharedService, },
    ]; };
    EditorComponent.propDecorators = {
        "editor": [{ type: core_2.ViewChild, args: ["editor",] },],
        "row": [{ type: core_2.Input },],
        "html": [{ type: core_2.Input },],
    };
    return EditorComponent;
}(abstract_ngmodel_1.AbstractNgModel));
exports.EditorComponent = EditorComponent;
