"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var notification_component_1 = require("../notification/notification.component");
var alert_component_1 = require("../alert/alert.component");
var req_http_service_1 = require("../../services/req-http.service");
var core_2 = require("@ngx-translate/core");
var http_1 = require("@angular/http");
var parameters_component_1 = require("../parameters/parameters.component");
var devextreme_angular_1 = require("devextreme-angular");
var funcoes_component_1 = require("../../models/funcoes.component");
var material_1 = require("@angular/material");
var dialog_filter_component_1 = require("./dialog-filter/dialog-filter.component");
var material_2 = require("@angular/material");
var sharedService_1 = require("../../models/sharedService");
var FiltersComponent = /** @class */ (function () {
    function FiltersComponent(_reqHttpService, _translateService, _http, dialog, _sharedService) {
        this._reqHttpService = _reqHttpService;
        this._translateService = _translateService;
        this._http = _http;
        this.dialog = dialog;
        this._sharedService = _sharedService;
        this.identificadorRecursoSegurancaFiltro = "";
        this.entity = "";
        this.table = "";
        this.securityId = "";
        this.code = "";
        this.buttonExport = false;
        this.onFilter = "";
        this.onSelectFilter = "";
        this.searchSaved = false;
        this.grid = true;
        this.type = "Filtro";
        this._onFilter = new core_1.EventEmitter();
        this._search = new core_1.EventEmitter();
        this._onSelectFilter = new core_1.EventEmitter();
        this.filterModel = [];
        this.btnDetail = "false";
        this._columns = "col l12 s12 m12 z-depth-1";
        this.parametersVisible = true;
        this.selectedRow = [];
        this.selectedFilter = false;
        this.filtroTabela = [];
        this.crudLayoutGrid = [];
        this._showHideParameters = false;
        this.setGrid = [];
        this._filterModel = [];
        this.showParameters = {
            icon: "keyboard_arrow_left"
        };
        this.comboDisabled = false;
        this.colunas = [];
        this.buttonExecute = false;
        this.url = "";
        this.operationDescriptions = {
            between: "Entre",
            contains: "Contém",
            endsWiht: "Terminar Com",
            equals: "Igual",
            greaterThan: "Maior que",
            greaterThanOrEqual: "Maior ou igual a",
            lessThan: "Menor que",
            lessThanOrEqual: "Menor ou igual a",
            notContains: "Não contém",
            notEqual: "Diferente",
            startWith: "começar com"
        };
        this.translateService = _translateService;
    }
    Object.defineProperty(FiltersComponent.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = "col l" + value + " s12 m12 z-depth-1";
        },
        enumerable: true,
        configurable: true
    });
    FiltersComponent.prototype.verifPermission = function () {
        var _this = this;
        var _permissoes = this._sharedService.getLocalStorage(_projectName, "/permissoes", true);
        // let permissoes: any = JSON.parse(_permissoes);
        if (_permissoes) {
            // Encontra as permissões do componente atual
            this.buttonExport = false;
            this.buttonExecute = false;
            _permissoes.permissoes.forEach(function (ret) {
                if (ret.recursoSeguranca.identificador == _this.securityId) {
                    ret.tiposAcesso.forEach(function (e) {
                        if (e == "EXIBICAO") {
                            _this.buttonExecute = true;
                        }
                        if (e == "EXPORTAO") {
                            _this.buttonExport = true;
                        }
                    });
                }
            });
        }
    };
    FiltersComponent.prototype.ngOnChanges = function (changes) {
        this.setGrid = [];
        if (this.gridResultCrud) {
            // limpar colunas header
            var countColumn = this.gridResultCrud.instance.columnCount();
            for (var i = 0; i < countColumn; i++) {
                this.gridResultCrud.instance.columnOption(i, "visible", false);
            }
            this.gridResultCrud = null;
        }
        if (changes && changes.code && changes.code.currentValue) {
            this.verifPermission();
            if (this.buttonExecute) {
                this.getFiltroCodigo(changes.code.currentValue);
            }
        }
    };
    FiltersComponent.prototype.showHideParameters = function () {
        this.parametersVisible = !this.parametersVisible;
    };
    FiltersComponent.prototype.exportExcell = function () {
        var _this = this;
        var _notification = new notification_component_1.NotificationComponent();
        if (_projectPermissoes.length &&
            _projectPermissoes.hasOwnProperty("FILTRO") &&
            _projectPermissoes.FILTRO.hasOwnProperty(this.identificadorRecursoSegurancaFiltro) &&
            _projectPermissoes.FILTRO[this.identificadorRecursoSegurancaFiltro].indexOf("EXPORTACAO") >= 0) {
            this._reqHttpService
                .xhrDownload("/filtro/runner/export", this.retornoParametros["parameters"])
                .subscribe(function (ret) {
                if (ret.res && ret.success) {
                    if (ret.res.byteLength != undefined &&
                        ret.res.byteLength == 0) {
                        _notification.show("Nenhum registro encontrado para ser exportado.");
                    }
                    else {
                        var file = new Blob([ret.res], {
                            type: "application/zip"
                        });
                        saveAs(file, _this.entity + ".zip");
                    }
                }
                else {
                    _notification.show("Erro ao realizar esta operação.");
                }
            }, function (err) {
                _notification.show("Erro ao realizar esta operação.");
            });
        }
        else {
            _notification.show("Sem permissão para exportar este filtro");
        }
    };
    FiltersComponent.prototype.getFiltroTabela = function () {
        var _this = this;
        this._reqHttpService
            .xhrGet("/sabium/api/filtro/aplicacao/" + _projectCodigo + "/tabela/" + this.table)
            .subscribe(function (ret) {
            if (ret.success) {
                if (ret.res && ret.res["data"]) {
                    if (ret.res["data"].hasOwnProperty("codigo")) {
                        _this.identificadorRecursoSegurancaFiltro = "app-" + _projectCodigo + "-filter-" + ret.res.data.codigo;
                    }
                    if (ret.res["data"].length > 0) {
                        ret.res["data"].map(function (item) {
                            if (item.nome.substring(0, 4) == "i18n") {
                                item.nome = _this._translateService.translations[_this._translateService.currentLang].i18n["sabium-framework"][item.nome.replace("i18n.", "")];
                            }
                            else if (item.nome.substring(0, 1) == "#") {
                                if (_projectName) {
                                    item.nome = _this._translateService.translations[_this._translateService.currentLang].i18n[_projectName][item.nome.replace("#", "")];
                                }
                            }
                        });
                        _this.filtroTabela = ret.res["data"];
                        if (_this.filtroTabela.length == 1) {
                            _this.filterModel = _this.filtroTabela[0];
                        }
                    }
                }
            }
        });
        this.reloadSearchSaved();
    };
    FiltersComponent.prototype.reloadSearchSaved = function () {
        var _this = this;
        if (this.searchSaved) {
            this._reqHttpService
                .xhrGet("/sabium/api/pesquisa/aplicacao/" + _projectCodigo + "/versao/" + _projectVersao + "/tabela/" + this.table)
                .subscribe(function (ret) {
                _this.crudLayoutGrid = ret.res;
            });
        }
    };
    FiltersComponent.prototype.getFiltroCodigo = function (valor) {
        var _this = this;
        if (valor === void 0) { valor = null; }
        var codigo = valor ? valor : this.code;
        this._reqHttpService
            .xhrGet("/sabium/api/filtro/codigo/" + codigo + "/aplicacao/" + _projectCodigo + "/corrente")
            .subscribe(function (ret) {
            if (ret.success && ret.res) {
                if (ret["res"].nome.substring(0, 4) == "i18n") {
                    ret["res"].nome = _this._translateService.translations[_this._translateService.currentLang].i18n["sabium-framework"][ret["res"].nome.replace("i18n.", "")];
                }
                else if (ret["res"].nome.substring(0, 1) == "#") {
                    if (_projectName) {
                        ret["res"].nome = _this._translateService.translations[_this._translateService.currentLang].i18n[_projectName][ret["res"].nome.replace("#", "")];
                    }
                }
                _this.filtroTabela = new Array(ret.res);
                _this.filterModel = ret.res;
                _this.selectFilter(ret.res);
                _this.comboDisabled = true;
            }
        });
    };
    FiltersComponent.prototype.retornoParametro = function (retorno) {
        retorno["parameters"]["codigo"] = this._filterCod;
        this.retornoParametros = retorno;
    };
    FiltersComponent.prototype.encontraFilterModel = function (nomeCampo, valor) {
        var retornoComMascara = "";
        var achou = false;
        this.filterModel.saida.forEach(function (item) {
            if (item.nome == nomeCampo) {
                if (item.tipo == "CPF" && valor) {
                    retornoComMascara = valor.replace(/(\d{3})(\d{3})(\d{3})(\d{2})/g, "$1.$2.$3-$4");
                    achou = true;
                }
                else if (item.tipo == "DATA" && valor) {
                    retornoComMascara = funcoes_component_1.FuncoesComponent.formataData(valor);
                    achou = true;
                }
                else if (item.tipo == "DATA_HORA" && valor) {
                    retornoComMascara = funcoes_component_1.FuncoesComponent.formataDataHoraFromTimeStamp(valor);
                    achou = true;
                }
                else if (item.tipo == "DECIMAL" && valor) {
                    retornoComMascara = funcoes_component_1.FuncoesComponent.formataDecimal(valor.toString());
                    achou = true;
                }
                else if (item.tipo == "CNPJ" && valor) {
                    retornoComMascara = valor.replace(/(\d{2})(\d{3})(\d{3})(\d{4})(\d{2})/g, "$1.$2.$3/$4-$5");
                    achou = true;
                }
                else if (item.tipo == "TELEFONE" && valor) {
                    retornoComMascara = funcoes_component_1.FuncoesComponent.formatPhoneNumber(valor);
                    achou = true;
                }
                else if (item.tipo == "CEP" && valor) {
                    retornoComMascara = valor.replace(/(\d{2})(\d{3})(\d{3})/g, "$1.$2-$3");
                    achou = true;
                }
                else if (item.tipo == "MOEDA" && valor) {
                    retornoComMascara = funcoes_component_1.FuncoesComponent.formataDecimal(valor.toString());
                    retornoComMascara = "R$ " + retornoComMascara;
                    achou = true;
                }
                else if (item.tipo == "LOGICO") {
                    /*if(valor.toLowerCase() == "true") {
                                            retornoComMascara = "Sim";
                                            achou = true;
                                        }
                                        else if (valor.toLowerCase() == "false") {
                                            retornoComMascara = "Não";
                                            achou = true;
                                        }*/
                }
            }
        });
        return achou ? retornoComMascara : valor;
    };
    FiltersComponent.prototype.executarFiltro = function () {
        var _this = this;
        this._onFilter.emit(this.retornoParametros["parameters"]);
        this.showHideParameters();
        if (this.grid) {
            var filtroparametros = [];
            if (this.parameterscomponent1) {
                filtroparametros = this.parameterscomponent1.returnParameter;
            }
            else if (this.parameterscomponent2) {
                filtroparametros = this.parameterscomponent2.returnParameter;
            }
            filtroparametros.parametros.map(function (item) {
                delete item.obrigatorio;
            });
            var notification = new notification_component_1.NotificationComponent();
            var alert_1 = new alert_component_1.AlertComponent();
            this._reqHttpService
                .xhrPost("/filtro/runner/", filtroparametros)
                .subscribe(function (ret) {
                _this.setGrid = ret.res.data;
                _this.colunas = [];
                var valor = "";
                var valorMascara = "";
                if (_this.filterModel) {
                    ret.res.data.map(function (retRunner) {
                        var objectKeys = [];
                        objectKeys = Object.keys(retRunner);
                        var auxRet = retRunner;
                        auxRet["valorRetornado"] = {};
                        objectKeys.map(function (nomeCampo) {
                            valor = auxRet[nomeCampo];
                            if (valor) {
                                valorMascara = _this.encontraFilterModel(nomeCampo, valor);
                                auxRet[nomeCampo] = valorMascara;
                                auxRet["valorRetornado"][nomeCampo] = valor;
                            }
                        });
                    });
                    _this.filterModel.saida.map(function (item, index) {
                        _this.colunas.push({
                            caption: _this.translateService.translations[_this.translateService.currentLang].i18n[_projectName][item.rotulo.replace("#", "")],
                            dataField: item.nome,
                            width: item.largura,
                            formItem: {
                                index: index
                            }
                        });
                    });
                }
            }, function (err) {
                if (err.res.status == 500) {
                    alert_1.show("Erro ao pesquisar", "Ok", err.res.statusText, "error");
                }
                else if (err.res.status == 400) {
                    alert_1.show("Dados inválidos", "Ok", err.res.reponse, "error");
                }
                else if (err.res.status == 403) {
                    alert_1.show("Sessão Expirada. Refaça o login", "Ok", err.res.reponse, "error");
                }
                else {
                    alert_1.show("Erro Desconhecido, Contate o suporte", "Ok", err.res.reponse, "error");
                }
            });
        }
    };
    FiltersComponent.prototype.selectSearch = function (search) {
        var _this = this;
        this._search.emit(search);
        // this.showHideParameters();
        this.selectionSearch = search;
        this.filtroTabela.map(function (ret) {
            if (ret.codigo == search.filtroVersao.filtro.codigo) {
                _this.filterModel = ret;
            }
        });
    };
    FiltersComponent.prototype.selectFilter = function (event) {
        var _this = this;
        if (this.selectionSearch) {
            event.entrada.map(function (ret) {
                _this.selectionSearch.parametrosExecucao.map(function (ent) {
                    if (ret.nome == ent.chave) {
                        ret.valor_padrao = ent.valores[0];
                    }
                });
            });
            this.dataSource = event.entrada;
        }
        else {
            this.dataSource = event.entrada;
        }
        this._onSelectFilter.emit(event);
        if (this.onSelectFilter != "") {
            window[this.onSelectFilter](event);
        }
        this.url = event.url;
        this.selectedFilter = true;
        this._filterCod = event.codigo;
    };
    FiltersComponent.prototype.openDetail = function () {
        var _this = this;
        this.filterModel.saida.forEach(function (item) {
            Object.getOwnPropertyNames(_this.selectedRow[0]).forEach(function (val, idx, array) {
                console.log(val + " -> " + _this.selectedRow[0][val]);
                if (item.nome == val) {
                    if (JSON.parse(_this.selectedRow[0][val])) {
                        item.tipo == "TEXTAREA";
                    }
                }
            });
        });
        var configDialog = Object.assign(new material_2.MatDialogConfig(), {
            width: "700px",
            data: {
                filtroSaida: this.filterModel.saida,
                row: this.selectedRow[0].valorRetornado
            }
        });
        var dialogRef = this.dialog.open(dialog_filter_component_1.DialogFilterDetail, configDialog);
    };
    FiltersComponent.prototype.ngOnInit = function () {
        if (this.table != "") {
            this.getFiltroTabela();
        }
    };
    FiltersComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        if (this.btnDetail == "true") {
            this.gridResultCrud.onSelectionChanged.subscribe(function (ret) {
                _this.selectedRow = ret["selectedRowKeys"];
            });
        }
    };
    FiltersComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: "sbm-filter",
                    template: require('./filters.component.html'),

                    styles: [require('./filters.component.css')],
                    host: {
                        "[class]": "columns"
                    }
                },] },
    ];
    /** @nocollapse */
    FiltersComponent.ctorParameters = function () { return [
        { type: req_http_service_1.ReqHttpService, },
        { type: core_2.TranslateService, },
        { type: http_1.Http, },
        { type: material_1.MatDialog, },
        { type: sharedService_1.SharedService, },
    ]; };
    FiltersComponent.propDecorators = {
        "parameterscomponent1": [{ type: core_1.ViewChild, args: ["parameterscomponent1",] },],
        "parameterscomponent2": [{ type: core_1.ViewChild, args: ["parameterscomponent2",] },],
        "gridResultCrud": [{ type: core_1.ViewChild, args: ["gridResultCrud",] },],
        "entity": [{ type: core_1.Input },],
        "table": [{ type: core_1.Input },],
        "securityId": [{ type: core_1.Input, args: ["securityid",] },],
        "code": [{ type: core_1.Input },],
        "buttonExport": [{ type: core_1.Input, args: ["export",] },],
        "onFilter": [{ type: core_1.Input, args: ["onfilter",] },],
        "onSelectFilter": [{ type: core_1.Input, args: ["onselectfilter",] },],
        "searchSaved": [{ type: core_1.Input, args: ["searchsaved",] },],
        "grid": [{ type: core_1.Input, args: ["grid",] },],
        "type": [{ type: core_1.Input, args: ["type",] },],
        "_onFilter": [{ type: core_1.Output },],
        "_search": [{ type: core_1.Output },],
        "_onSelectFilter": [{ type: core_1.Output },],
        "filterModel": [{ type: core_1.Input, args: ["filtermodel",] },],
        "btnDetail": [{ type: core_1.Input, args: ["btndetail",] },],
        "columns": [{ type: core_1.Input },],
    };
    return FiltersComponent;
}());
exports.FiltersComponent = FiltersComponent;
