"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var core_2 = require("@ngx-translate/core");
var req_http_service_1 = require("../../../services/req-http.service");
var series_component_1 = require("../series/series.component");
var devextreme_angular_1 = require("devextreme-angular");
var BarComponent = /** @class */ (function () {
    function BarComponent(_translateService, reqHttp) {
        this._translateService = _translateService;
        this.reqHttp = reqHttp;
        this.dataSource = [];
        this.argumentField = 'arg';
        this.width = '100%';
        this.height = 400;
        this.exporting = true;
        this.texts = true;
        this.indexData = 'data';
        this.onClick = '';
        this.onLegentClick = '';
        this._onClick = new core_1.EventEmitter();
        this._onLegentClick = new core_1.EventEmitter();
        this._legendsOrientation = 'vertical';
        this._type = 'pie';
        this._label = '';
        this._columns = 'col l12 m12 s12';
        sbmGraphBarComponent.push(this);
    }
    Object.defineProperty(BarComponent.prototype, "legendsOrientation", {
        get: function () {
            return this._legendsOrientation;
        },
        set: function (val) {
            if (val == 'horizontal' || val == 'vertical') {
                this._legendsOrientation = val;
            }
            else {
                this._legendsOrientation = 'vertical';
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BarComponent.prototype, "type", {
        get: function () {
            return this._type;
        },
        set: function (val) {
            if (val == 'pie' || val == 'donut') {
                this._type = val;
            }
            else {
                this._type = 'pie';
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BarComponent.prototype, "label", {
        get: function () {
            return this.privateLabel;
        },
        set: function (val) {
            this.privateLabel = val;
            if (val.substring(0, 1) == '#') {
                this._label = this._translateService.translations[this._translateService.currentLang].i18n['sabium-framework'][val.replace('#', '')];
            }
            else if (val.substring(0, 4) == 'i18n') {
                if (_projectName) {
                    this._label = this._translateService.translations[this._translateService.currentLang].i18n[_projectName][val.replace("i18n.", "")];
                }
                else {
                    this._label = val;
                }
            }
            else {
                this._label = val;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BarComponent.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = "col l" + value + " m12 s12";
        },
        enumerable: true,
        configurable: true
    });
    BarComponent.prototype.reqService = function (url) {
        var _this = this;
        if (url != '') {
            this.reqHttp.xhrGet(url).subscribe(function (ret) {
                if (typeof ret.res[_this.indexData] == 'object') {
                    if (ret.res[_this.indexData].length > 0) {
                        _this.dataSource = ret.res[_this.indexData];
                    }
                }
            });
        }
    };
    BarComponent.prototype.pointClickHandler = function ($event) {
        this._onClick.emit($event);
        if (this.onClick != '') {
            window[this.onClick]($event);
        }
    };
    BarComponent.prototype.legendClickHandler = function ($event) {
        this._onLegentClick.emit($event);
        if (this.onLegentClick != '') {
            window[this.onLegentClick]($event);
        }
    };
    BarComponent.prototype.customizeLabel = function (arg) {
        return arg.valueText;
    };
    BarComponent.prototype.render = function () {
        this.bar.instance.render();
    };
    BarComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        $(document).ready(function () {
            _this.bar.instance.render();
            // this.pie.instance.svg()
            // $(this._el.nativeElement).find('.dxc.dxc-chart').attr('width','1300');
            // $(this._el.nativeElement).find('.dxc.dxc-chart').find('rect').attr('width','auto');
        });
    };
    BarComponent.prototype.ngOnInit = function () {
    };
    BarComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'sbm-chart-bar',
                    template: require('./bar.component.html'),

                    host: {
                        '[class]': 'columns'
                    }
                },] },
    ];
    /** @nocollapse */
    BarComponent.ctorParameters = function () { return [
        { type: core_2.TranslateService, },
        { type: req_http_service_1.ReqHttpService, },
    ]; };
    BarComponent.propDecorators = {
        "series": [{ type: core_1.ContentChildren, args: [core_1.forwardRef(function () { return series_component_1.SeriesComponent; }),] },],
        "bar": [{ type: core_1.ViewChild, args: ['bar',] },],
        "dataSource": [{ type: core_1.Input },],
        "argumentField": [{ type: core_1.Input },],
        "width": [{ type: core_1.Input },],
        "height": [{ type: core_1.Input },],
        "exporting": [{ type: core_1.Input },],
        "texts": [{ type: core_1.Input },],
        "indexData": [{ type: core_1.Input },],
        "onClick": [{ type: core_1.Input },],
        "onLegentClick": [{ type: core_1.Input },],
        "_onClick": [{ type: core_1.Output },],
        "_onLegentClick": [{ type: core_1.Output },],
        "legendsOrientation": [{ type: core_1.Input },],
        "type": [{ type: core_1.Input },],
        "label": [{ type: core_1.Input },],
        "columns": [{ type: core_1.Input },],
    };
    return BarComponent;
}());
exports.BarComponent = BarComponent;
