import { ElementRef, EventEmitter, OnInit, QueryList, TemplateRef } from '@angular/core';
import { IComponentDefault } from '../../interfaces/IComponentDefault';
import { AbstractNgModel } from '../../models/abstract.ngmodel';
import { DxDataGridComponent } from 'devextreme-angular';
import 'rxjs/add/operator/toPromise';
import { TranslateService } from '@ngx-translate/core';
import { ReqHttpService } from '../../services/req-http.service';
import { SharedService } from '../../models/sharedService';
import { Http } from '@angular/http';
export declare class SbmGridColumn extends AbstractNgModel implements IComponentDefault, OnInit {
    private _reqHttpService;
    private _sharedService;
    _http: Http;
    private _translateService;
    constructor(_reqHttpService: ReqHttpService, _sharedService: SharedService, _http: Http, _translateService: TranslateService);
    ngOnInit(): void;
    value: string;
    isEntity: boolean;
    entity: string;
    entityDisplay: string;
    dataType: string;
    format: string;
    width: number;
    sortOrder: any;
    height: string;
    area: string;
    alignment: string;
    celltemplate: string;
    internalColumnTemplate: TemplateRef<any>;
}
export declare class GridComponent extends AbstractNgModel implements IComponentDefault, OnInit {
    private _reqHttpService;
    private _sharedService;
    _http: Http;
    private _translateService;
    constructor(_reqHttpService: ReqHttpService, _sharedService: SharedService, _http: Http, _translateService: TranslateService);
    columnsOptions: QueryList<SbmGridColumn>;
    id: string;
    securityId: string;
    height: string;
    columnsGrid: any[];
    __dataSource: any;
    dataSource: any;
    pagination: string;
    select: string;
    mode: string;
    grouping: boolean;
    onSelectData: string;
    _onSelectData: EventEmitter<{}>;
    gridClick: EventEmitter<{}>;
    dataGrid: DxDataGridComponent;
    buttonAll: ElementRef;
    _buttonAll: boolean;
    _dataSource: any;
    _columns: any;
    columns: any;
    randomClass: any;
    source: any;
    pagingEnable: boolean;
    pageIndex: any;
    translations: any;
    dxDataSource: any;
    isNotBlank(value: any): any;
    ngOnInit(): void;
    setDataSource: (_data: any) => void;
    refresh(): void;
    totalColumnGrid($data: any): void;
    onContextMenuPreparing($event: any): void;
    getAll(): void;
    reqService($options: any, getAll?: boolean): any;
    changeGrid($event: any): void;
    selectionData(event: any): void;
    edit(event: any): void;
}
