"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var devextreme_angular_1 = require("devextreme-angular");
var custom_store_1 = require("devextreme/data/custom_store");
require("rxjs/add/operator/toPromise");
var core_2 = require("@ngx-translate/core");
var req_http_service_1 = require("../../services/req-http.service");
var sharedService_1 = require("../../models/sharedService");
var funcoes_component_1 = require("../../models/funcoes.component");
var http_1 = require("@angular/http");
var alert_component_1 = require("../alert/alert.component");
var SbmGridColumn = /** @class */ (function (_super) {
    __extends(SbmGridColumn, _super);
    function SbmGridColumn(_reqHttpService, _sharedService, _http, _translateService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._reqHttpService = _reqHttpService;
        _this._sharedService = _sharedService;
        _this._http = _http;
        _this._translateService = _translateService;
        _this.value = '';
        _this.isEntity = false;
        _this.entity = '';
        _this.entityDisplay = '';
        _this.dataType = '';
        _this.format = '';
        _this.width = null;
        _this.sortOrder = null;
        _this.height = null;
        _this.area = '';
        _this.alignment = 'left';
        _this.celltemplate = null;
        return _this;
    }
    SbmGridColumn.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
    };
    SbmGridColumn.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'sbm-column',
                    template: "\n        <ng-template #internalColumnTemplate let-item=\"item\">\n            <ng-content></ng-content>\n        </ng-template>\n    "
                },] },
    ];
    /** @nocollapse */
    SbmGridColumn.ctorParameters = function () { return [
        { type: req_http_service_1.ReqHttpService, },
        { type: sharedService_1.SharedService, },
        { type: http_1.Http, },
        { type: core_2.TranslateService, },
    ]; };
    SbmGridColumn.propDecorators = {
        "value": [{ type: core_1.Input },],
        "isEntity": [{ type: core_1.Input },],
        "entity": [{ type: core_1.Input },],
        "entityDisplay": [{ type: core_1.Input },],
        "dataType": [{ type: core_1.Input },],
        "format": [{ type: core_1.Input },],
        "width": [{ type: core_1.Input },],
        "sortOrder": [{ type: core_1.Input, args: ['sortorder',] },],
        "height": [{ type: core_1.Input },],
        "area": [{ type: core_1.Input },],
        "alignment": [{ type: core_1.Input },],
        "celltemplate": [{ type: core_1.Input },],
        "internalColumnTemplate": [{ type: core_1.ViewChild, args: ['internalColumnTemplate',] },],
    };
    return SbmGridColumn;
}(abstract_ngmodel_1.AbstractNgModel));
exports.SbmGridColumn = SbmGridColumn;
var GridComponent = /** @class */ (function (_super) {
    __extends(GridComponent, _super);
    function GridComponent(_reqHttpService, _sharedService, _http, _translateService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._reqHttpService = _reqHttpService;
        _this._sharedService = _sharedService;
        _this._http = _http;
        _this._translateService = _translateService;
        _this.id = '';
        _this.securityId = '';
        _this.height = '';
        _this.columnsGrid = [];
        _this.pagination = '5';
        _this.select = 'single';
        _this.mode = 'pagination';
        _this.grouping = false;
        _this.onSelectData = '';
        _this._onSelectData = new core_1.EventEmitter();
        _this.gridClick = new core_1.EventEmitter();
        _this._buttonAll = true;
        _this._columns = 'col l12 m12 s12 input-field crud-form-dynamic';
        _this.pagingEnable = true;
        _this.translations = {
            'pageInfo': null,
            'gridCount': null,
            'textGroup': null,
            'loadGrid': null
        };
        _this.setDataSource = function (_data) {
            _this.dxDataSource = _data;
            _this._buttonAll = false;
        };
        sbmGridComponent.push(_this);
        return _this;
    }
    Object.defineProperty(GridComponent.prototype, "dataSource", {
        get: function () {
            return this.__dataSource;
        },
        set: function (val) {
            this.__dataSource = val;
            this.setDataSource(val);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GridComponent.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = "col l" + value + " s12 m12 input-field crud-form-dynamic";
        },
        enumerable: true,
        configurable: true
    });
    GridComponent.prototype.isNotBlank = function (value) {
        return funcoes_component_1.FuncoesComponent.isNotBlank(value);
    };
    GridComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
        this.randomClass = Math.floor((Math.random() * 1000) + 1);
        if (typeof this.dataSource == 'object') {
            this.dxDataSource = this.dataSource;
            this._buttonAll = false;
        }
        else {
            var me_1 = this;
            this.source = new custom_store_1.default({
                load: function (loadOptions) {
                    return me_1.reqService(loadOptions);
                }
            });
            this.dxDataSource = { store: this.source, searchValue: this.dataSource, requireTotalCount: false };
        }
        this.dataGrid.onInitialized.subscribe(function (e) {
            e.component.refresh();
        });
    };
    GridComponent.prototype.refresh = function () {
        this.dataGrid.instance.refresh();
    };
    GridComponent.prototype.totalColumnGrid = function ($data) {
    };
    GridComponent.prototype.onContextMenuPreparing = function ($event) {
        if ($event.target == 'header') {
        }
        if ($event.target == 'content') {
        }
    };
    GridComponent.prototype.getAll = function () {
        var _this = this;
        var deferred = $.Deferred();
        this._reqHttpService.xhrGet(this.dataSource).subscribe(function (ret) {
            if (ret.success && ret.res.length > 0) {
                deferred.resolve({
                    data: ret.res.data,
                    totalCount: ret.res.size
                });
                _this.dataGrid.dataSource = ret.res.data;
                _this.pagingEnable = false;
                _this.mode = 'infinite';
                $(_this.buttonAll.nativeElement).hide();
                _this.dataGrid.instance.refresh();
            }
            else {
                deferred.reject('Erro ao Carregar os registros');
            }
        });
    };
    GridComponent.prototype.reqService = function ($options, getAll) {
        var _this = this;
        var me = this;
        var deferred = $.Deferred();
        var params = '';
        var url = ($options.searchValue || '');
        var pageInfo = '';
        if (url.toString().indexOf('?') != -1) {
            params += '&';
        }
        else {
            params += '?';
        }
        var prev = ($options.skip + parseInt(me.pagination)) / parseInt(me.pagination);
        params += 'p=' + (prev || 1);
        params += '&l=' + ($options.take || me.pagination);
        if ($options.sort) {
            params += '&sort=' + $options.sort[0].selector;
            if ($options.sort[0].desc) {
                params = params.replace('&sort=', '&sort=-');
            }
        }
        if ($options.searchValue) {
            if ($options.filter) {
                params = '';
                if ($options.sort) {
                    params = '?sort=' + $options.sort[0].selector;
                    if ($options.sort[0].desc) {
                        params = params.replace('?sort=', '?sort=-');
                    }
                }
            }
            this._reqHttpService.xhrGet($options.searchValue + params).subscribe(function (ret) {
                if (ret.success) {
                    if (ret.res.data) {
                        var aux = ret.res.size / parseInt(me.pagination);
                        var auxRound = Math.ceil(aux);
                        pageInfo = 'Página ' + prev.toString() + ' de ' + auxRound.toString() + ' (' + ret.res.size.toString() + ' items)';
                        _this.translations.pageInfo = pageInfo;
                        deferred.resolve({
                            data: ret.res.data,
                            totalCount: ret.res.size
                        });
                    }
                    else {
                        deferred.reject('Nenhum registro encontrado');
                    }
                    $(_this.buttonAll.nativeElement).show();
                }
                else {
                    deferred.reject('Erro ao Carregar os registros');
                }
            }, function (err) {
                var alert = new alert_component_1.AlertComponent();
                alert.show('Erro ao buscar os registros!', 'ok', 'Ocorreu um erro ao buscar os registros desse serviço', 'error');
                deferred.reject('Erro ao Carregar os registros');
            });
        }
        else {
            $(this.buttonAll.nativeElement).hide();
            deferred.resolve({
                data: [],
                totalCount: 0
            });
            return deferred.promise();
        }
        return deferred.promise();
    };
    GridComponent.prototype.changeGrid = function ($event) {
        if (this.pageIndex !== $event.component.pageIndex()) {
            this.pageIndex = $event.component.pageIndex();
            $event.component.selectRowsByIndexes(0);
        }
    };
    GridComponent.prototype.selectionData = function (event) {
        this._onSelectData.emit(event);
        if (this.onSelectData != '') {
            window[this.onSelectData](event);
        }
    };
    GridComponent.prototype.edit = function (event) {
        this.gridClick.emit(event);
    };
    GridComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'sbm-grid',
                    template: require('./grid.component.html'),

                    host: {
                        '[class]': 'columns'
                    }
                },] },
    ];
    /** @nocollapse */
    GridComponent.ctorParameters = function () { return [
        { type: req_http_service_1.ReqHttpService, },
        { type: sharedService_1.SharedService, },
        { type: http_1.Http, },
        { type: core_2.TranslateService, },
    ]; };
    GridComponent.propDecorators = {
        "columnsOptions": [{ type: core_1.ContentChildren, args: [core_1.forwardRef(function () { return SbmGridColumn; }),] },],
        "id": [{ type: core_1.Input },],
        "securityId": [{ type: core_1.Input },],
        "height": [{ type: core_1.Input },],
        "dataSource": [{ type: core_1.Input, args: ['datasource',] },],
        "pagination": [{ type: core_1.Input },],
        "select": [{ type: core_1.Input },],
        "mode": [{ type: core_1.Input },],
        "grouping": [{ type: core_1.Input },],
        "onSelectData": [{ type: core_1.Input, args: ['onselectdata',] },],
        "_onSelectData": [{ type: core_1.Output },],
        "gridClick": [{ type: core_1.Output },],
        "dataGrid": [{ type: core_1.ViewChild, args: ['dataGrid',] },],
        "buttonAll": [{ type: core_1.ViewChild, args: ['buttonAll',] },],
        "columns": [{ type: core_1.Input },],
    };
    return GridComponent;
}(abstract_ngmodel_1.AbstractNgModel));
exports.GridComponent = GridComponent;
