"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var http_1 = require("@angular/http");
require("rxjs/add/operator/map");
var abstract_ngmodel_1 = require("../../../models/abstract.ngmodel");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../../models/sharedService");
var InputCepComponent = /** @class */ (function (_super) {
    __extends(InputCepComponent, _super);
    function InputCepComponent(_http, _el, _sharedService, _translateService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._http = _http;
        _this._el = _el;
        _this._sharedService = _sharedService;
        _this._translateService = _translateService;
        _this.msgError = 'Cep Inválido';
        _this.labelWidth = '';
        _this.inputValid = true;
        _this.validationsMsg = {
            require: null,
            zipNotFound: null,
            zipCodeInvalid: null,
        };
        sbmInputCepComponent.push(_this);
        return _this;
    }
    InputCepComponent.prototype.changeValueEvent = function (event) {
        this.value = $(this.input.nativeElement).cleanVal();
    };
    InputCepComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
    };
    InputCepComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        $(this.input.nativeElement).mask('00.000-000');
        $(this.input.nativeElement).attr('style', this.styleCss);
        this.css += ' sbm-input';
        this.classCss += ' ' + this.css;
        this.changeValue = this.onChangeValue.subscribe(function (ret) {
            if (ret) {
                $(_this.input.nativeElement).mask('00.000-000');
                _this.valueMask = $(_this.input.nativeElement).masked(ret);
            }
            else {
                _this.valueMask = '';
            }
        });
        if (this.documentation != '') {
            $(this._el.nativeElement).addClass('sbm-documentation');
        }
    };
    InputCepComponent.prototype.itemClicado = function () {
        var _this = this;
        var url = 'http://cep.republicavirtual.com.br/web_cep.php?cep=' + this.value + '&formato=json';
        // this.disabled = true;
        this._http.get(url).map(function (res) { return res.json(); }).subscribe(function (retorno) {
            _this._onClick.emit(retorno);
            if (_this.onClick != '') {
                window[_this.onClick](retorno);
            }
            // this.disabled = false;
        });
    };
    InputCepComponent.prototype.blur = function ($event) {
        this._onBlur.emit($event);
        if (this.onBlur != '') {
            window[this.onBlur]($event);
        }
        this.verificaPadding();
    };
    InputCepComponent.prototype.keyup = function ($event) {
        this._onKeyup.emit($event);
        if (this.onKeyup != '') {
            window[this.onKeyup]($event);
        }
        if ($event.target.value == '') {
            this.verificaPadding();
        }
    };
    InputCepComponent.prototype.verificaPadding = function () {
        var aux = 0;
        if (this.component.hasError('cep')) {
            aux++;
        }
        if (this.component.hasError('required')) {
            aux++;
        }
        aux = aux * 10;
        $(this._el.nativeElement).attr('style', 'padding-bottom: ' + aux + 'px;');
    };
    InputCepComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'sbm-input-cep',
                    template: require('./input-cep.component.html'),

                    host: {
                        '[class]': 'classCss'
                    },
                    providers: [
                        abstract_ngmodel_1.MakeProvider(InputCepComponent),
                        { provide: abstract_ngmodel_1.AbstractNgModel, useExisting: core_1.forwardRef(function () { return InputCepComponent; }) }
                    ]
                },] },
    ];
    /** @nocollapse */
    InputCepComponent.ctorParameters = function () { return [
        { type: http_1.Http, },
        { type: core_1.ElementRef, },
        { type: sharedService_1.SharedService, },
        { type: core_2.TranslateService, },
    ]; };
    InputCepComponent.propDecorators = {
        "input": [{ type: core_1.ViewChild, args: ['inputCep',] },],
    };
    return InputCepComponent;
}(abstract_ngmodel_1.AbstractNgModel));
exports.InputCepComponent = InputCepComponent;
