"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../../models/abstract.ngmodel");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../../models/sharedService");
var http_1 = require("@angular/http");
var InputCnpjComponent = /** @class */ (function (_super) {
    __extends(InputCnpjComponent, _super);
    function InputCnpjComponent(_translateService, _http, _el, _sharedService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._translateService = _translateService;
        _this._http = _http;
        _this._el = _el;
        _this._sharedService = _sharedService;
        _this.msgError = 'CNPJ Inválido';
        _this.labelWidth = '';
        _this.inputValid = true;
        sbmInputCnpjComponent.push(_this);
        return _this;
    }
    InputCnpjComponent.prototype.inputChange = function (event) {
        this._onBlur.emit(event);
        if (this.onBlur != '') {
            window[this.onBlur](event);
        }
        this.verificaPadding();
    };
    InputCnpjComponent.prototype.keyup = function ($event) {
        this._onKeyup.emit($event);
        if (this.onKeyup != '') {
            window[this.onKeyup]($event);
        }
        if ($event.target.value == '') {
            this.verificaPadding();
        }
    };
    InputCnpjComponent.prototype.verificaPadding = function () {
        var aux = 0;
        if (this.component.hasError('cnpj')) {
            aux++;
        }
        if (this.component.hasError('required')) {
            aux++;
        }
        aux = aux * 10;
        $(this._el.nativeElement).attr('style', 'padding-bottom: ' + aux + 'px;');
    };
    InputCnpjComponent.prototype.changeValueEvent = function (event) {
        this.value = $(this.input.nativeElement).cleanVal();
    };
    InputCnpjComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
        this.css += ' sbm-input';
        this.classCss += ' ' + this.css;
    };
    InputCnpjComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        $(this.input.nativeElement).mask('00.000.000/0000-00');
        $(this.input.nativeElement).attr('style', this.styleCss);
        if (this.documentation != '') {
            $(this._el.nativeElement).addClass('sbm-documentation');
        }
        this.changeValue = this.onChangeValue.subscribe(function (ret) {
            if (ret) {
                $(_this.input.nativeElement).mask('00.000.000/0000-00');
                _this.valueMask = $(_this.input.nativeElement).masked(ret);
            }
            else {
                _this.valueMask = '';
            }
        });
    };
    InputCnpjComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'sbm-input-cnpj',
                    template: require('./input-cnpj.component.html'),

                    host: {
                        '[class]': 'classCss',
                        '[hidden]': "!exibirComponente"
                    },
                    providers: [
                        abstract_ngmodel_1.MakeProvider(InputCnpjComponent),
                        { provide: abstract_ngmodel_1.AbstractNgModel, useExisting: core_1.forwardRef(function () { return InputCnpjComponent; }) }
                    ]
                },] },
    ];
    /** @nocollapse */
    InputCnpjComponent.ctorParameters = function () { return [
        { type: core_2.TranslateService, },
        { type: http_1.Http, },
        { type: core_1.ElementRef, },
        { type: sharedService_1.SharedService, },
    ]; };
    InputCnpjComponent.propDecorators = {
        "input": [{ type: core_1.ViewChild, args: ['inputCnpj',] },],
    };
    return InputCnpjComponent;
}(abstract_ngmodel_1.AbstractNgModel));
exports.InputCnpjComponent = InputCnpjComponent;
