"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../../models/abstract.ngmodel");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../../models/sharedService");
var http_1 = require("@angular/http");
var InputEmailComponent = /** @class */ (function (_super) {
    __extends(InputEmailComponent, _super);
    function InputEmailComponent(_translateService, _http, _el, _sharedService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._translateService = _translateService;
        _this._http = _http;
        _this._el = _el;
        _this._sharedService = _sharedService;
        _this.msgError = "Campo Incorreto";
        _this.labelWidth = "";
        _this.inputValid = true;
        sbmInputEmailComponent.push(_this);
        _this._translateService.onLangChange.subscribe(function () {
            var retTraducao = _this._sharedService.getTraducao("sabium-framework")[0];
            _this.validationsMsg["email"] = retTraducao["validation.email"];
        });
        return _this;
    }
    InputEmailComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
        this.css = "sbm-input";
        this.classCss += " " + this.css;
    };
    InputEmailComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        $(document).ready(function () {
            $(_this._el.nativeElement)
                .find("input")
                .attr("style", _this.styleCss);
        });
    };
    InputEmailComponent.prototype.blur = function (retorno) {
        this._onBlur.emit(retorno);
        if (this.onBlur != "") {
            window[this.onBlur](retorno);
        }
        this.verificaPadding();
    };
    InputEmailComponent.prototype.keyup = function ($event) {
        this._onKeyup.emit($event);
        if (this.onKeyup != "") {
            window[this.onKeyup]($event);
        }
        if ($event.target.value == "") {
            this.verificaPadding();
        }
    };
    InputEmailComponent.prototype.verificaPadding = function () {
        var aux = 0;
        if (this.component.hasError("email")) {
            aux++;
        }
        if (this.component.hasError("required")) {
            aux++;
        }
        aux = aux * 10;
        $(this._el.nativeElement).attr("style", "padding-bottom: " + aux + "px;");
    };
    InputEmailComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: "sbm-input-email",
                    template: require('./input-email.component.html'),

                    host: {
                        "[class]": "classCss"
                    },
                    providers: [
                        abstract_ngmodel_1.MakeProvider(InputEmailComponent),
                        {
                            provide: abstract_ngmodel_1.AbstractNgModel,
                            useExisting: core_1.forwardRef(function () { return InputEmailComponent; })
                        }
                    ]
                },] },
    ];
    /** @nocollapse */
    InputEmailComponent.ctorParameters = function () { return [
        { type: core_2.TranslateService, },
        { type: http_1.Http, },
        { type: core_1.ElementRef, },
        { type: sharedService_1.SharedService, },
    ]; };
    InputEmailComponent.propDecorators = {
        "input": [{ type: core_1.ViewChild, args: ["inputEmail",] },],
    };
    return InputEmailComponent;
}(abstract_ngmodel_1.AbstractNgModel));
exports.InputEmailComponent = InputEmailComponent;
