"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../../models/abstract.ngmodel");
var core_2 = require("@ngx-translate/core");
var http_1 = require("@angular/http");
var sharedService_1 = require("../../../models/sharedService");
var InputIpComponent = /** @class */ (function (_super) {
    __extends(InputIpComponent, _super);
    function InputIpComponent(_translateService, _http, _sharedService, _el) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._translateService = _translateService;
        _this._http = _http;
        _this._sharedService = _sharedService;
        _this._el = _el;
        _this.mask = "099.099.099.099";
        sbmInputIpComponent.push(_this);
        return _this;
    }
    InputIpComponent.prototype.changeValueEvent = function (event) {
        //this.value = $(this.input.nativeElement).cleanVal();
        this.value = $(this.input.nativeElement).masked();
    };
    InputIpComponent.prototype.viewSetAttr = function () {
        var _this = this;
        //set Style
        $(this.input.nativeElement).attr("style", this.styleCss);
        $(this.input.nativeElement).mask(this.mask, { clearIfNotMatch: true });
        if (this.documentation != "") {
            $(this._el.nativeElement).addClass("sbm-documentation");
        }
        this.changeValue = this.onChangeValue.subscribe(function (ret) {
            $(_this.input.nativeElement).mask(_this.mask, {
                clearIfNotMatch: true
            });
            _this.valueMask = $(_this.input.nativeElement).masked(ret);
        });
    };
    InputIpComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        $(document).ready(function () {
            _this.viewSetAttr();
        });
    };
    InputIpComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
        this.css = "sbm-input";
        this.classCss += " " + this.css;
    };
    InputIpComponent.prototype.blur = function (retorno) {
        this._onBlur.emit(retorno);
        if (this.onBlur != "") {
            window[this.onBlur](retorno);
        }
    };
    InputIpComponent.prototype.keyup = function ($event) {
        this._onKeyup.emit($event);
        if (this.onKeyup != "") {
            window[this.onKeyup]($event);
        }
    };
    InputIpComponent.prototype.limparCampo = function () {
        this.valueMask = "";
    };
    InputIpComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: "sbm-input-ip",
                    template: require('./input-ip.component.html'),

                    host: {
                        "[class]": "classCss"
                    },
                    providers: [
                        abstract_ngmodel_1.MakeProvider(InputIpComponent),
                        {
                            provide: abstract_ngmodel_1.AbstractNgModel,
                            useExisting: core_1.forwardRef(function () { return InputIpComponent; })
                        }
                    ]
                },] },
    ];
    /** @nocollapse */
    InputIpComponent.ctorParameters = function () { return [
        { type: core_2.TranslateService, },
        { type: http_1.Http, },
        { type: sharedService_1.SharedService, },
        { type: core_1.ElementRef, },
    ]; };
    InputIpComponent.propDecorators = {
        "input": [{ type: core_1.ViewChild, args: ["inputIp",] },],
        "mask": [{ type: core_1.Input },],
    };
    return InputIpComponent;
}(abstract_ngmodel_1.AbstractNgModel));
exports.InputIpComponent = InputIpComponent;
