"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../../models/abstract.ngmodel");
var core_2 = require("@ngx-translate/core");
var funcoes_component_1 = require("../../../models/funcoes.component");
var sharedService_1 = require("../../../models/sharedService");
var http_1 = require("@angular/http");
var InputMaskComponent = /** @class */ (function (_super) {
    __extends(InputMaskComponent, _super);
    function InputMaskComponent(_sharedService, _http, _el, _translateService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._sharedService = _sharedService;
        _this._http = _http;
        _this._el = _el;
        _this._translateService = _translateService;
        _this.mask = "";
        _this.inputValid = true;
        _this.msgError = "";
        _this.labelWidth = "";
        _this.validationsMsg = {
            require: null
        };
        sbmInputMaskComponent.push(_this);
        return _this;
    }
    InputMaskComponent.prototype.isNotBlank = function (value) {
        return funcoes_component_1.FuncoesComponent.isNotBlank(value);
    };
    InputMaskComponent.prototype.blur = function (retorno) {
        this._onBlur.emit(retorno);
        if (this.onBlur != "") {
            window[this.onBlur](retorno);
        }
        this.verificaPadding();
    };
    InputMaskComponent.prototype.keyup = function ($event) {
        this._onKeyup.emit($event);
        if (this.onKeyup != "") {
            window[this.onKeyup]($event);
        }
        if ($event.target.value == "") {
            this.verificaPadding();
        }
    };
    InputMaskComponent.prototype.changeValueEvent = function (event) {
        this.value = $(this.input.nativeElement).cleanVal();
    };
    InputMaskComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        $(this.input.nativeElement).mask(this.mask, { clearIfNotMatch: true });
        $(this.input.nativeElement).attr("style", this.styleCss);
        if (this.documentation != "") {
            $(this._el.nativeElement).addClass("sbm-documentation");
        }
        this.changeValue = this.onChangeValue.subscribe(function (ret) {
            if (ret) {
                $(_this.input.nativeElement).mask(_this.mask, {
                    clearIfNotMatch: true
                });
                _this.valueMask = $(_this.input.nativeElement).masked(ret);
                _this.changeValue.unsubscribe();
                $(document).ready(function () {
                    _this.changeValueEvent(_this.valueMask);
                });
            }
            else {
                _this.valueMask = "";
            }
        });
    };
    InputMaskComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
        this.css += " sbm-input";
        this.classCss += " " + this.css;
    };
    InputMaskComponent.prototype.verificaPadding = function () {
        var aux = 0;
        if (this.component.hasError("required")) {
            aux++;
        }
        aux = aux * 10;
        $(this._el.nativeElement).attr("style", "padding-bottom: " + aux + "px;");
    };
    InputMaskComponent.prototype.limparCampo = function () {
        this.valueMask = "";
    };
    InputMaskComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: "sbm-input-mask",
                    template: require('./input-mask.component.html'),

                    host: {
                        "[class]": "classCss"
                    },
                    providers: [
                        abstract_ngmodel_1.MakeProvider(InputMaskComponent),
                        {
                            provide: abstract_ngmodel_1.AbstractNgModel,
                            useExisting: core_1.forwardRef(function () { return InputMaskComponent; })
                        }
                    ]
                },] },
    ];
    /** @nocollapse */
    InputMaskComponent.ctorParameters = function () { return [
        { type: sharedService_1.SharedService, },
        { type: http_1.Http, },
        { type: core_1.ElementRef, },
        { type: core_2.TranslateService, },
    ]; };
    InputMaskComponent.propDecorators = {
        "input": [{ type: core_1.ViewChild, args: ["inputMask",] },],
        "mask": [{ type: core_1.Input },],
    };
    return InputMaskComponent;
}(abstract_ngmodel_1.AbstractNgModel));
exports.InputMaskComponent = InputMaskComponent;
