"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../../models/abstract.ngmodel");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../../models/sharedService");
var http_1 = require("@angular/http");
var funcoes_component_1 = require("../../../models/funcoes.component");
var InputNumberComponent = /** @class */ (function (_super) {
    __extends(InputNumberComponent, _super);
    function InputNumberComponent(_translateService, _http, _el, _sharedService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._translateService = _translateService;
        _this._http = _http;
        _this._el = _el;
        _this._sharedService = _sharedService;
        _this.min = "";
        _this.max = "";
        _this.step = "";
        _this.digitAlign = "right";
        _this.spinButtons = true;
        _this.inputValid = true;
        _this.msgError = "Campo Incorreto";
        _this.dir = "ltr";
        sbmInputNumberComponent.push(_this);
        return _this;
    }
    InputNumberComponent.prototype.keyup = function ($event) {
        this._onKeyup.emit($event);
        var value = $(this.input.nativeElement).val();
        var valueInt = parseInt($event.key);
        if (Number.isNaN(valueInt)) {
            $(this.input.nativeElement).val(value.replace($event.key, ""));
        }
        if (this.onKeyup != "") {
            window[this.onKeyup]($event);
            // sbmExecuteFunctions($event, this._onKeyup);
        }
        if ($event.target.value == "") {
            this.verificaPadding();
        }
    };
    InputNumberComponent.prototype.blur = function ($event) {
        this._onBlur.emit($event);
        var value = $event.target.value;
        if (parseInt(value) < parseInt(this.min)) {
            $(this.input.nativeElement).val(this.min);
            this.value = this.min;
        }
        if (parseInt(value) > parseInt(this.max)) {
            $(this.input.nativeElement).val(this.max);
            this.value = this.max;
        }
        if (this.onBlur != "") {
            window[this.onBlur]($event);
        }
        this.verificaPadding();
    };
    InputNumberComponent.prototype.ngAfterViewInit = function () {
        var me = this;
        $(this.input.nativeElement).attr("style", this.styleCss);
        if (this.digitAlign == "right") {
            $(this.input.nativeElement).css("text-align", "right");
            // this.dir = 'ltr';
        }
        else if (this.digitAlign == "left") {
            $(this.input.nativeElement).css("text-align", "left");
            // this.dir = 'rtl';
        }
        else if (this.digitAlign == "center") {
            $(this.input.nativeElement).css("text-align", "center");
            // this.dir = 'ltr';
        }
        if (this.documentation != "") {
            $(this._el.nativeElement).addClass("sbm-documentation");
        }
    };
    InputNumberComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
        //add Validator step with setValidators
        this.component.control.setValidators(funcoes_component_1.FuncoesComponent.stepValidation(this.input.nativeElement));
        //add Validator step with setValidators
        this.css += " sbm-input";
        this.classCss += " " + this.css;
    };
    InputNumberComponent.prototype.verificaPadding = function () {
        var aux = 0;
        if (this.component.hasError("step")) {
            aux++;
        }
        if (this.component.hasError("required")) {
            aux++;
        }
        aux = aux * 10;
        $(this._el.nativeElement).attr("style", "padding-bottom: " + aux + "px;");
    };
    InputNumberComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: "sbm-input-number",
                    template: require('./input-number.component.html'),

                    host: {
                        "[class]": "classCss"
                    },
                    providers: [
                        abstract_ngmodel_1.MakeProvider(InputNumberComponent),
                        {
                            provide: abstract_ngmodel_1.AbstractNgModel,
                            useExisting: core_1.forwardRef(function () { return InputNumberComponent; })
                        }
                    ]
                },] },
    ];
    /** @nocollapse */
    InputNumberComponent.ctorParameters = function () { return [
        { type: core_2.TranslateService, },
        { type: http_1.Http, },
        { type: core_1.ElementRef, },
        { type: sharedService_1.SharedService, },
    ]; };
    InputNumberComponent.propDecorators = {
        "input": [{ type: core_1.ViewChild, args: ["inputNumber",] },],
        "min": [{ type: core_1.Input },],
        "max": [{ type: core_1.Input },],
        "step": [{ type: core_1.Input },],
        "digitAlign": [{ type: core_1.Input, args: ["digitalign",] },],
        "spinButtons": [{ type: core_1.Input, args: ["spinbuttons",] },],
    };
    return InputNumberComponent;
}(abstract_ngmodel_1.AbstractNgModel));
exports.InputNumberComponent = InputNumberComponent;
