"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../../models/abstract.ngmodel");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../../models/sharedService");
var http_1 = require("@angular/http");
var InputPasswordComponent = /** @class */ (function (_super) {
    __extends(InputPasswordComponent, _super);
    function InputPasswordComponent(_sharedService, _http, _el, _translateService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._sharedService = _sharedService;
        _this._http = _http;
        _this._el = _el;
        _this._translateService = _translateService;
        _this.inputValid = true;
        _this.msgError = "Campo Incorreto";
        _this.labelWidth = "";
        _this.force = 0;
        _this.type = "password";
        _this.validationsMsg = {
            require: null,
            minLength: null,
            maxLength: null
        };
        sbmInputPasswordComponent.push(_this);
        return _this;
    }
    InputPasswordComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
        this.css += " sbm-input";
        this.classCss += " " + this.css;
    };
    InputPasswordComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        $(document).ready(function () {
            $(_this.input.nativeElement).attr("style", _this.styleCss);
        });
        if (this.documentation != "") {
            $(this._el.nativeElement).addClass("sbm-documentation");
        }
        this.onChangeValue.subscribe(function (ret) {
            _this.forcePassword(ret);
        });
    };
    InputPasswordComponent.prototype.forcePassword = function (element) {
        var senha = element;
        this.force = 0;
        if (senha) {
            if (senha.length >= 4 && senha.length <= 7) {
                this.force += 10;
            }
            else if (senha.length > 7) {
                this.force += 25;
                if (senha.match(/[a-z]+/)) {
                    this.force += 10;
                }
                if (senha.match(/[A-Z]+/)) {
                    this.force += 20;
                }
                if (senha.match(/d+/)) {
                    this.force += 20;
                }
                if (senha.match(/W+/)) {
                    this.force += 25;
                }
            }
        }
    };
    InputPasswordComponent.prototype.keyup = function ($event) {
        this.forcePassword($event.target.value);
        this._onKeyup.emit($event);
        if (this.onKeyup != "") {
            window[this.onKeyup]($event);
        }
        if ($event.target.value == "") {
            this.verificaPadding();
        }
    };
    InputPasswordComponent.prototype.blur = function (retorno) {
        this._onBlur.emit(retorno);
        if (this.onBlur != "") {
            window[this.onBlur](retorno);
        }
        this.verificaPadding();
    };
    InputPasswordComponent.prototype.ngOnDestroy = function () { };
    InputPasswordComponent.prototype.verificaPadding = function () {
        var aux = 0;
        if (this.component.hasError("minlength")) {
            aux++;
        }
        if (this.component.hasError("maxlength")) {
            aux++;
        }
        if (this.component.hasError("required")) {
            aux++;
        }
        aux = aux * 10;
        $(this._el.nativeElement).attr("style", "padding-bottom: " + aux + "px;");
    };
    InputPasswordComponent.prototype.showPassword = function () {
        if (this.type == "password") {
            this.type = "text";
        }
        else {
            this.type = "password";
        }
    };
    InputPasswordComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: "sbm-input-password",
                    template: require('./input-password.component.html'),

                    styles: [require('./input-password.component.css')],
                    host: {
                        "[class]": "classCss"
                    },
                    providers: [
                        abstract_ngmodel_1.MakeProvider(InputPasswordComponent),
                        {
                            provide: abstract_ngmodel_1.AbstractNgModel,
                            useExisting: core_1.forwardRef(function () { return InputPasswordComponent; })
                        }
                    ]
                },] },
    ];
    /** @nocollapse */
    InputPasswordComponent.ctorParameters = function () { return [
        { type: sharedService_1.SharedService, },
        { type: http_1.Http, },
        { type: core_1.ElementRef, },
        { type: core_2.TranslateService, },
    ]; };
    InputPasswordComponent.propDecorators = {
        "input": [{ type: core_1.ViewChild, args: ["inputPassword",] },],
    };
    return InputPasswordComponent;
}(abstract_ngmodel_1.AbstractNgModel));
exports.InputPasswordComponent = InputPasswordComponent;
