"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../../models/abstract.ngmodel");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../../models/sharedService");
var http_1 = require("@angular/http");
var InputTelefoneComponent = /** @class */ (function (_super) {
    __extends(InputTelefoneComponent, _super);
    function InputTelefoneComponent(_translateService, _http, _sharedService, _el) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._translateService = _translateService;
        _this._http = _http;
        _this._sharedService = _sharedService;
        _this._el = _el;
        _this.inputValid = true;
        _this.msgError = "Telefone inválido";
        _this.labelWidth = "";
        _this.validationsMsg = {
            require: null,
            minLength: null,
            maxLength: null,
            pattern: null
        };
        sbmInputPhoneComponent.push(_this);
        _this._translateService.onLangChange.subscribe(function () {
            var retTraducao = _this._sharedService.getTraducao("sabium-framework")[0];
            _this.validationsMsg["require"] = retTraducao["validation.notNull"];
            _this.validationsMsg["pattern"] = retTraducao["validation.pattern"];
            _this.msgError = retTraducao["validation.require"];
        });
        return _this;
    }
    InputTelefoneComponent.prototype.blur = function (retorno) {
        this._onBlur.emit(retorno);
        if (this.onBlur != "") {
            window[this.onBlur](retorno);
        }
        this.verificaPadding();
    };
    InputTelefoneComponent.prototype.keyup = function ($event) {
        this._onKeyup.emit($event);
        if (this.onKeyup != "") {
            window[this.onKeyup]($event);
        }
        if ($event.target.value == "") {
            this.verificaPadding();
        }
    };
    InputTelefoneComponent.prototype.changeValueEvent = function (event) {
        this.value = $(this.input.nativeElement).cleanVal();
    };
    InputTelefoneComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
        this.css += " sbm-input";
        this.classCss += " " + this.css;
    };
    InputTelefoneComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        var SPMaskBehavior = function (val) {
            return val.replace(/\D/g, "").length === 11
                ? "(00) 00000-0000"
                : "(00) 0000-00009";
        }, spOptions = {
            onKeyPress: function (val, e, field, options) {
                field.mask(SPMaskBehavior.apply({}, arguments), options);
            }
        };
        $(this.input.nativeElement).mask(SPMaskBehavior, spOptions);
        $(this.input.nativeElement).attr("style", this.styleCss);
        if (this.documentation != "") {
            $(this._el.nativeElement).addClass("sbm-documentation");
        }
        this.changeValue = this.onChangeValue.subscribe(function (ret) {
            if (ret) {
                $(_this.input.nativeElement).mask(SPMaskBehavior, spOptions);
                _this.valueMask = $(_this.input.nativeElement).masked(ret);
            }
            else {
                _this.valueMask = "";
            }
        });
    };
    InputTelefoneComponent.prototype.verificaPadding = function () {
        var aux = 0;
        if (this.component.hasError("phone")) {
            aux++;
        }
        if (this.component.hasError("required")) {
            aux++;
        }
        aux = aux * 10;
        $(this._el.nativeElement).attr("style", "padding-bottom: " + aux + "px;");
    };
    InputTelefoneComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: "sbm-input-telefone",
                    template: require('./input-telefone.component.html'),

                    host: {
                        "[class]": "classCss"
                    },
                    providers: [
                        abstract_ngmodel_1.MakeProvider(InputTelefoneComponent),
                        {
                            provide: abstract_ngmodel_1.AbstractNgModel,
                            useExisting: core_1.forwardRef(function () { return InputTelefoneComponent; })
                        }
                    ]
                },] },
    ];
    /** @nocollapse */
    InputTelefoneComponent.ctorParameters = function () { return [
        { type: core_2.TranslateService, },
        { type: http_1.Http, },
        { type: sharedService_1.SharedService, },
        { type: core_1.ElementRef, },
    ]; };
    InputTelefoneComponent.propDecorators = {
        "input": [{ type: core_1.ViewChild, args: ["inputPhone",] },],
    };
    return InputTelefoneComponent;
}(abstract_ngmodel_1.AbstractNgModel));
exports.InputTelefoneComponent = InputTelefoneComponent;
