"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../../models/abstract.ngmodel");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../../models/sharedService");
var funcoes_component_1 = require("../../../models/funcoes.component");
var http_1 = require("@angular/http");
var InputTextComponent = /** @class */ (function (_super) {
    __extends(InputTextComponent, _super);
    function InputTextComponent(_el, _http, _sharedService, _translateService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._el = _el;
        _this._http = _http;
        _this._sharedService = _sharedService;
        _this._translateService = _translateService;
        _this.digitText = 'Mm';
        _this.maskExp = '';
        _this.inputValid = true;
        _this.msgError = 'Campo Incorreto';
        sbmInputTextComponent.push(_this);
        _this._translateService.onLangChange.subscribe(function () {
            var retTraducao = _this._sharedService.getTraducao('sabium-framework')[0];
            _this.validationsMsg['regExp'] = retTraducao['validation.regExp'].replace('%', _this.maskExp);
        });
        return _this;
    }
    InputTextComponent.prototype.isNotBlank = function (value) {
        return funcoes_component_1.FuncoesComponent.isNotBlank(value);
    };
    InputTextComponent.prototype.regex = function (value) {
        return new RegExp('^' + this.maskExp + '+$', 'g').test(value);
    };
    InputTextComponent.prototype.keyup = function ($event) {
        this._onKeyup.emit($event);
        if (this.onKeyup != '') {
            window[this.onKeyup]($event);
        }
        if ($event.target.value == '') {
            this.verificaPadding();
        }
    };
    InputTextComponent.prototype.blur = function (retorno) {
        this._onBlur.emit(retorno);
        if (this.onBlur != '') {
            window[this.onBlur](retorno);
        }
        this.verificaPadding();
    };
    InputTextComponent.prototype.viewSetAttr = function () {
        var _this = this;
        if (this.maxLength != '') {
            $(this.input.nativeElement).attr('data-length', this.maxLength);
        }
        // set Style
        $(this._el.nativeElement).find('input').attr('style', this.styleCss);
        // emiter value and digitText ('M', 'm')
        this.subscriptionValue = this.onChangeValue.subscribe(function (value) {
            if (value !== undefined) {
                if (_this.digitText == 'M') {
                    _this.value = value.toUpperCase();
                }
                else if (_this.digitText == 'm') {
                    _this.value = value.toLowerCase();
                }
            }
            if (_this.onChange != '') {
                window[_this.onChange](value);
            }
            _this._onChange.emit(value);
        });
    };
    InputTextComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        $(document).ready(function () {
            _this.viewSetAttr();
        });
    };
    InputTextComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
        this.css += ' sbm-input';
        this.classCss += ' ' + this.css;
    };
    InputTextComponent.prototype.ngOnDestroy = function () {
        // this.subscriptionValue.unsubscribe();
        // this.SubscriptionComp.unsubscribe();
    };
    InputTextComponent.prototype.verificaPadding = function () {
        var aux = 0;
        if (this.component.hasError('required')) {
            aux++;
        }
        if (this.component.hasError('regExp')) {
            aux++;
        }
        if (this.component.hasError('minlength')) {
            aux++;
        }
        if (this.component.hasError('maxlength')) {
            aux++;
        }
        aux = aux * 10;
        $(this._el.nativeElement).attr('style', 'padding-bottom: ' + aux + 'px;');
    };
    InputTextComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'sbm-input-text',
                    template: require('./input-text.component.html'),

                    host: {
                        '[class]': 'classCss',
                        '[formControlName]': "formControlName",
                        '[name]': "name"
                    },
                    providers: [
                        abstract_ngmodel_1.MakeProvider(InputTextComponent),
                        { provide: abstract_ngmodel_1.AbstractNgModel, useExisting: core_1.forwardRef(function () { return InputTextComponent; }) }
                    ]
                },] },
    ];
    /** @nocollapse */
    InputTextComponent.ctorParameters = function () { return [
        { type: core_1.ElementRef, },
        { type: http_1.Http, },
        { type: sharedService_1.SharedService, },
        { type: core_2.TranslateService, },
    ]; };
    InputTextComponent.propDecorators = {
        "input": [{ type: core_1.ViewChild, args: ['inputText',] },],
        "digitText": [{ type: core_1.Input, args: ['digittext',] },],
        "maskExp": [{ type: core_1.Input, args: ['maskexp',] },],
    };
    return InputTextComponent;
}(abstract_ngmodel_1.AbstractNgModel));
exports.InputTextComponent = InputTextComponent;
