"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../../models/abstract.ngmodel");
require("rxjs/add/operator/map");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../../models/sharedService");
var http_1 = require("@angular/http");
var MoneyComponent = /** @class */ (function (_super) {
    __extends(MoneyComponent, _super);
    function MoneyComponent(_translateService, _http, _el, _sharedService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._translateService = _translateService;
        _this._http = _http;
        _this._el = _el;
        _this._sharedService = _sharedService;
        _this.prefix = "R$";
        _this.decimal = ",";
        _this.min = "";
        _this.max = "";
        _this.thousands = ".";
        _this.decimalDigits = "2";
        _this.digitAlign = "right";
        _this.onFocus = "";
        _this._onFocus = new core_1.EventEmitter();
        _this._options = {};
        _this._valueChecked = true;
        _this.inputValid = true;
        _this.msgInvalid = false;
        _this.labelWidth = "";
        _this.msgError = "Campo Inválido";
        sbmInputMoneyComponent.push(_this);
        _this._translateService.onLangChange.subscribe(function () {
            var retTraducao = _this._sharedService.getTraducao("sabium-framework")[0];
            _this.validationsMsg["min"] = retTraducao["validation.min"].replace("%", _this.min);
            _this.validationsMsg["max"] = retTraducao["validation.max"].replace("%", _this.max);
            _this.validationsMsg['required'] = retTraducao["validation.required"];
        });
        return _this;
    }
    MoneyComponent.prototype.blur = function ($event) {
        this._onBlur.emit($event);
        if (this.onBlur != "") {
            window[this.onBlur]($event);
        }
        if (this.valueMask.indexOf(",") > -1) {
            var slice = this.valueMask.slice(this.valueMask.indexOf(","), this.valueMask.length);
            if (slice.length == 2) {
                slice = slice.replace(',', '');
                for (var i = 1; i < parseInt(this.decimalDigits); i++) {
                    this.valueMask += '0';
                }
            }
        }
        var value = this.valueMask.replace(",", ""); //$(this.input.nativeElement).cleanVal();
        if (this.valueMask.indexOf(',') <= -1) {
            value += ",";
            for (var i = 0; i < parseInt(this.decimalDigits); i++) {
                value += "0";
            }
        }
        var output = [value.slice(0, value.length - parseInt(this.decimalDigits)), ".", value.slice(value.length - parseInt(this.decimalDigits))].join("");
        if (output !== ".") {
            this.value = isNaN(parseFloat(output)) ? null : parseFloat(output);
        }
        else {
            this.value = null;
        }
        this.valueMask = this.numberToReal(this.value);
    };
    MoneyComponent.prototype.focus = function ($event) {
        this._onFocus.emit($event);
        if (this.onFocus != "") {
            window[this.onFocus]($event);
        }
    };
    MoneyComponent.prototype.click = function ($event) {
        this._onClick.emit($event);
        if (this.onClick != "") {
            window[this.onClick]($event);
        }
    };
    MoneyComponent.prototype.numberToReal = function (numero) {
        if (numero) {
            console.log(numero);
            var numero = numero
                .toFixed(parseInt(this.decimalDigits))
                .split(".");
            numero[0] = numero[0].split(/(?=(?:...)*$)/).join('.');
            return numero.join(',');
        }
        else {
            return null;
        }
    };
    MoneyComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        var mask = "#.##0,";
        for (var index = 0; index < parseInt(this.decimalDigits); index++) {
            mask += "0";
        }
        $(this.input.nativeElement).attr("style", this.styleCss);
        // $(this.input.nativeElement).mask(mask, { reverse: true });
        if (this.readonly) {
            this.disabled = true;
        }
        // if (this.digitAlign == "right") {
        //     $(this.input.nativeElement).css("direction", "rtl");
        // } else if (this.digitAlign == "left") {
        //     $(this.input.nativeElement).css("direction", "ltr");
        // } else if (this.digitAlign == "center") {
        //     $(this.input.nativeElement).css("direction", "ltr");
        // }
        var v = this.onChangeValue.subscribe(function (ret) {
            if (ret) {
                _this.valueMask = _this.numberToReal(Number(ret));
            }
            else {
                _this.valueMask = null;
            }
            if (ret) {
                v.unsubscribe();
            }
        });
    };
    MoneyComponent.prototype.keyup = function ($event) {
        this._onKeyup.emit($event);
        if (this.onKeyup != "") {
            window[this.onKeyup]($event);
        }
    };
    MoneyComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
        this._options = {
            prefix: this.prefix + " ",
            thousands: this.thousands,
            decimal: this.decimal,
            align: this.digitAlign,
            precision: this.decimalDigits
        };
        this.css += " sbm-input";
        this.classCss += " " + this.css;
    };
    MoneyComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: "sbm-money",
                    template: require('./money.component.html'),

                    host: {
                        "[class]": "classCss",
                        "[hidden]": "!exibirComponente"
                    },
                    providers: [
                        abstract_ngmodel_1.MakeProvider(MoneyComponent),
                        {
                            provide: abstract_ngmodel_1.AbstractNgModel,
                            useExisting: core_1.forwardRef(function () { return MoneyComponent; })
                        }
                    ]
                },] },
    ];
    /** @nocollapse */
    MoneyComponent.ctorParameters = function () { return [
        { type: core_2.TranslateService, },
        { type: http_1.Http, },
        { type: core_1.ElementRef, },
        { type: sharedService_1.SharedService, },
    ]; };
    MoneyComponent.propDecorators = {
        "input": [{ type: core_1.ViewChild, args: ["money",] },],
        "prefix": [{ type: core_1.Input },],
        "decimal": [{ type: core_1.Input },],
        "min": [{ type: core_1.Input },],
        "max": [{ type: core_1.Input },],
        "thousands": [{ type: core_1.Input },],
        "decimalDigits": [{ type: core_1.Input, args: ["decimaldigits",] },],
        "digitAlign": [{ type: core_1.Input, args: ["digitalign",] },],
        "onFocus": [{ type: core_1.Input, args: ["onfocus",] },],
        "_onFocus": [{ type: core_1.Output },],
    };
    return MoneyComponent;
}(abstract_ngmodel_1.AbstractNgModel));
exports.MoneyComponent = MoneyComponent;
