"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../../models/abstract.ngmodel");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../../models/sharedService");
var http_1 = require("@angular/http");
var TextareaComponent = /** @class */ (function (_super) {
    __extends(TextareaComponent, _super);
    function TextareaComponent(_el, _translateService, _http, _sharedService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._el = _el;
        _this._translateService = _translateService;
        _this._http = _http;
        _this._sharedService = _sharedService;
        _this.digitText = 'Mm';
        _this.tmLinha = '';
        _this._rows = '';
        _this.inputValid = true;
        _this.msgError = 'Campo Incorreto';
        _this.labelWidth = '';
        sbmTextareaComponent.push(_this);
        return _this;
    }
    Object.defineProperty(TextareaComponent.prototype, "rows", {
        get: function () {
            return this._rows;
        },
        set: function (val) {
            this._rows = val;
            if (parseInt(val) > 0) {
                var tm = parseInt(val) * 21;
                this.styleCss = 'height: ' + tm + 'px !important;';
            }
        },
        enumerable: true,
        configurable: true
    });
    ;
    TextareaComponent.prototype.blur = function ($event) {
        this._onBlur.emit($event);
        if (this.onBlur != '') {
            window[this.onBlur]($event);
        }
    };
    TextareaComponent.prototype.keyup = function ($event) {
        this._onKeyup.emit($event);
        if (this.onKeyup != '') {
            window[this.onKeyup]($event);
        }
    };
    TextareaComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
        this.css += ' sbm-input sbm-textarea';
        this.classCss += ' ' + this.css;
    };
    TextareaComponent.prototype.ngAfterViewInit = function () {
        $(this.textarea.nativeElement).attr('style', this.styleCss);
        if (this.documentation != '') {
            $(this._el.nativeElement).addClass('sbm-documentation');
        }
    };
    TextareaComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'sbm-textarea',
                    template: require('./textarea.component.html'),

                    host: {
                        '[class]': 'classCss'
                    },
                    providers: [
                        abstract_ngmodel_1.MakeProvider(TextareaComponent),
                        { provide: abstract_ngmodel_1.AbstractNgModel, useExisting: core_1.forwardRef(function () { return TextareaComponent; }) }
                    ]
                },] },
    ];
    /** @nocollapse */
    TextareaComponent.ctorParameters = function () { return [
        { type: core_1.ElementRef, },
        { type: core_2.TranslateService, },
        { type: http_1.Http, },
        { type: sharedService_1.SharedService, },
    ]; };
    TextareaComponent.propDecorators = {
        "textarea": [{ type: core_1.ViewChild, args: ['textarea',] },],
        "digitText": [{ type: core_1.Input, args: ['digittext',] },],
        "rows": [{ type: core_1.Input },],
    };
    return TextareaComponent;
}(abstract_ngmodel_1.AbstractNgModel));
exports.TextareaComponent = TextareaComponent;
