import { EventEmitter, OnInit, QueryList, TemplateRef, SimpleChanges, ElementRef, ViewContainerRef } from '@angular/core';
import { IComponentDefault } from '../../interfaces/IComponentDefault';
import { AbstractNgModel } from '../../models/abstract.ngmodel';
import { ReqHttpService } from '../../services/req-http.service';
import { SbmGridColumn } from '../grid/grid.component';
import { SbmMasterDetailForm } from '../master-detail-form/master-detail-form.component';
import { TranslateService } from '@ngx-translate/core';
import { SharedService } from '../../models/sharedService';
import { Http } from '@angular/http';
import { MatDialog, MatDialogRef } from '@angular/material';
import { SbmHttpClientService } from '../../services/sbm-http-client.service';
import { DxDataGridComponent } from 'devextreme-angular';
export declare class MasterDetailComponent extends AbstractNgModel implements OnInit, IComponentDefault {
    private _reqHttpService;
    private _sharedService;
    _http: Http;
    private _translateService;
    dialog: MatDialog;
    private elRef;
    private vcRef;
    private sbmHttpClient;
    constructor(_reqHttpService: ReqHttpService, _sharedService: SharedService, _http: Http, _translateService: TranslateService, dialog: MatDialog, elRef: ElementRef, vcRef: ViewContainerRef, sbmHttpClient: SbmHttpClientService);
    dataColumns: QueryList<SbmGridColumn>;
    sbmMasterDetailForm: any;
    sbmMasterDetailFormView: any;
    form: any;
    grid: DxDataGridComponent;
    fieldset: any;
    parentEntity: any;
    parentEntityId: any;
    formTemplate: TemplateRef<any>;
    id: string;
    securityId: string;
    attribute: string;
    saveServer: boolean;
    urlAction: string;
    entity: string;
    dataSource: any[];
    notnull: boolean;
    private _enableActions;
    enableActions: any;
    _columns: any;
    columns: any;
    isAudityEnabled(): boolean;
    masterDetailTemplate: TemplateRef<SbmMasterDetailForm>;
    showlabel: any;
    textAlign: any;
    formVisible: boolean;
    showBackdrop: boolean;
    gridMasterDetail: boolean;
    formMasterDetail: boolean;
    update: any;
    elementBefore: any;
    inputValid: boolean;
    msgError: string;
    randomClass: number;
    loadedReq: EventEmitter<{}>;
    _valueVerified: boolean;
    generatedEntity: any;
    valueEntity: any;
    value: any;
    newFormMasterDetail: EventEmitter<{}>;
    cancelFormMasterDetail: EventEmitter<{}>;
    validationsMsg: any;
    itemEdit(): void;
    validInput(): void;
    itemRemove($data: any): void;
    cancelForm(): void;
    addDinamicparameter: any;
    itemNew($class: MasterDetailComponent): void;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngAfterViewChecked(change: SimpleChanges): void;
    audit(): void;
}
export declare class DialogMasterDetail {
    dialog: MatDialogRef<DialogMasterDetail>;
    data: any;
    constructor(dialog: MatDialogRef<DialogMasterDetail>, data: any);
    onNoClick(): void;
}
