"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var sharedService_1 = require("../../models/sharedService");
var core_2 = require("@ngx-translate/core");
var http_1 = require("@angular/http");
var SubMenuComponent = /** @class */ (function () {
    function SubMenuComponent() {
        this.id = '';
        this.securityId = '';
        this.value = '';
        this.icon = '';
    }
    SubMenuComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'sbm-submenu',
                    // template: `<div class='sbm-menu-submenu' *ngIf="exibirComponente" [attr.data-value]='value' [attr.data-icon]='icon'><ng-content></ng-content></div>`
                    template: "<ng-content></ng-content>"
                },] },
    ];
    /** @nocollapse */
    SubMenuComponent.ctorParameters = function () { return []; };
    SubMenuComponent.propDecorators = {
        "id": [{ type: core_1.Input },],
        "securityId": [{ type: core_1.Input },],
        "value": [{ type: core_1.Input, args: ['label',] },],
        "icon": [{ type: core_1.Input },],
    };
    return SubMenuComponent;
}());
exports.SubMenuComponent = SubMenuComponent;
var ItemMenuComponent = /** @class */ (function () {
    function ItemMenuComponent() {
        this.id = '';
        this.securityId = '';
        this.label = '';
        this.icon = '';
        this.link = '';
    }
    ItemMenuComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'sbm-item-menu',
                    // template: `<div class='sbm-item-menu' *ngIf="exibirComponente" [attr.data-value]='value' [attr.data-icon]='icon'><ng-content></ng-content></div>`
                    template: "<ng-content></ng-content>",
                    host: {
                        '[attr.label]': 'label'
                    }
                },] },
    ];
    /** @nocollapse */
    ItemMenuComponent.ctorParameters = function () { return []; };
    ItemMenuComponent.propDecorators = {
        "id": [{ type: core_1.Input },],
        "securityId": [{ type: core_1.Input },],
        "label": [{ type: core_1.Input },],
        "icon": [{ type: core_1.Input },],
        "link": [{ type: core_1.Input },],
    };
    return ItemMenuComponent;
}());
exports.ItemMenuComponent = ItemMenuComponent;
var MenuComponent = /** @class */ (function (_super) {
    __extends(MenuComponent, _super);
    function MenuComponent(_sharedService, _translateService, _http) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._sharedService = _sharedService;
        _this._translateService = _translateService;
        _this._http = _http;
        _this.dataSource = [];
        _this.orientation = MenuEnumOrientation[MenuEnumOrientation.horizontal];
        _this.randomClass = 0;
        _this.dataElement = [];
        _this._dataSource = [];
        return _this;
    }
    MenuComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
        this.randomClass = Math.floor((Math.random() * 1000) + 1);
    };
    // recursividade das tag sbm-item-menu
    // recursividade das tag sbm-item-menu
    MenuComponent.prototype.recursiveElement = 
    // recursividade das tag sbm-item-menu
    function (_element) {
        var me = this;
        //if (super.validarMenu(_element.attr('securityId'))) {
        var retVal = {
            id: _element.attr('securityId'),
            title: _element.attr('label'),
            link: _element.attr('link'),
            iconSrc: (_element.attr('icon') || ''),
            items: []
        };
        _element.find('> sbm-item-menu').each(function (indexB, sbmNodeB) {
            if (!retVal.hasOwnProperty('items')) {
                retVal.items = [];
            }
            retVal.items.push(me.recursiveElement($(sbmNodeB)));
        });
        return retVal;
        /*} else {
                    return null;
                }*/
    };
    MenuComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        var me = this;
        var _element = $('.sbm-menu-list-' + this.randomClass).children('sbm-item-menu');
        _element.each(function (_i, node) {
            _this.dataElement.push(me.recursiveElement($(node)));
        });
        if (this.dataSource.length == 0) {
            this._dataSource = this.dataElement;
        }
        else {
            this._dataSource = this.dataSource;
        }
    };
    MenuComponent.prototype.itemClicado = function (itemAtual) {
        if (!(itemAtual.itemData.items.length > 0)) {
            this._onClick.emit(itemAtual.itemData);
        }
    };
    MenuComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'sbm-menu',
                    template: require('./menu.component.html'),
                },] },
    ];
    /** @nocollapse */
    MenuComponent.ctorParameters = function () { return [
        { type: sharedService_1.SharedService, },
        { type: core_2.TranslateService, },
        { type: http_1.Http, },
    ]; };
    MenuComponent.propDecorators = {
        "dataSource": [{ type: core_1.Input, args: ['datasource',] },],
        "orientation": [{ type: core_1.Input },],
    };
    return MenuComponent;
}(abstract_ngmodel_1.AbstractNgModel));
exports.MenuComponent = MenuComponent;
var MenuEnumOrientation;
(function (MenuEnumOrientation) {
    MenuEnumOrientation[MenuEnumOrientation["horizontal"] = 0] = "horizontal";
    MenuEnumOrientation[MenuEnumOrientation["vertical"] = 1] = "vertical";
})(MenuEnumOrientation = exports.MenuEnumOrientation || (exports.MenuEnumOrientation = {}));
