"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var sharedService_1 = require("../../models/sharedService");
var http_1 = require("@angular/http");
var core_2 = require("@ngx-translate/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var ModalComponent = /** @class */ (function (_super) {
    __extends(ModalComponent, _super);
    function ModalComponent(_sharedService, _http, _translateService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._http = _http;
        _this._translateService = _translateService;
        _this.showTitle = true;
        _this.width = '60%';
        _this.height = 'auto';
        _this.position = 'default';
        _this.onClose = '';
        _this._onClose = new core_1.EventEmitter();
        _this._title = '';
        _this.textButton = '';
        _this._layout = 'horizontal';
        return _this;
    }
    ModalComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
    };
    Object.defineProperty(ModalComponent.prototype, "title", {
        get: function () {
            return this._title;
        },
        set: function (val) {
            if (val != '') {
                if (val.substring(0, 4) == 'i18n') {
                    this._title = this.translateService.translations[this.translateService.currentLang].i18n['sabium-framework'][val.replace('i18n.', '')];
                }
                else if (val.substring(0, 1) == '#') {
                    if (_projectName) {
                        this._title = this.translateService.translations[this.translateService.currentLang].i18n[_projectName][val.replace("#", "")];
                    }
                    else {
                        this._title = val;
                    }
                }
                else {
                    this._title = val;
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    ;
    Object.defineProperty(ModalComponent.prototype, "visible", {
        get: function () {
            return this._visible;
        },
        set: function (val) {
            this._visible = val;
            if (val) {
                $(this.popup.nativeElement).modal('open');
            }
            else {
                $(this.popup.nativeElement).modal('close');
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ModalComponent.prototype, "layout", {
        get: function () {
            return this._layout;
        },
        set: function (value) {
            this._layout = value;
            if (value == 'vertical') {
                var nElement = this.popup.nativeElement.children[0].children[0];
                var copyChildren = $.extend(true, {}, nElement.children);
                nElement.innerHTML = "";
                for (var j = 0; j < copyChildren.length; j++) {
                    var linhaRow = document.createElement('div');
                    linhaRow.setAttribute("class", "row");
                    linhaRow.appendChild(copyChildren[j]);
                    nElement.appendChild(linhaRow);
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    ModalComponent.prototype.ngAfterViewInit = function () {
        var me = this;
        $(document).ready(function () {
            var _this = this;
            $(me.popup.nativeElement).modal({
                complete: function () {
                    me._onClose.emit(_this);
                    if (me.onClose != '') {
                        window[_this.onKeyup](me.popup.nativeElement);
                    }
                }
            });
            if (me.visible) {
                $(me.popup.nativeElement).modal('open');
            }
            else {
                $(me.popup.nativeElement).modal('close');
            }
        });
    };
    ModalComponent.prototype.open = function () {
        $(this.popup.nativeElement).modal('open');
    };
    ModalComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'sbm-modal',
                    template: require('./modal.component.html'),
                },] },
    ];
    /** @nocollapse */
    ModalComponent.ctorParameters = function () { return [
        { type: sharedService_1.SharedService, },
        { type: http_1.Http, },
        { type: core_2.TranslateService, },
    ]; };
    ModalComponent.propDecorators = {
        "popup": [{ type: core_1.ViewChild, args: ['popup',] },],
        "showTitle": [{ type: core_1.Input },],
        "width": [{ type: core_1.Input },],
        "height": [{ type: core_1.Input },],
        "position": [{ type: core_1.Input },],
        "onClose": [{ type: core_1.Input, args: ['onclose',] },],
        "_onClose": [{ type: core_1.Output, args: ['onClose',] },],
        "title": [{ type: core_1.Input },],
        "textButton": [{ type: core_1.Input },],
        "visible": [{ type: core_1.Input },],
        "layout": [{ type: core_1.Input },],
    };
    return ModalComponent;
}(abstract_ngmodel_1.AbstractNgModel));
exports.ModalComponent = ModalComponent;
