"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var datebox_component_1 = require("../datebox/datebox.component");
var custom_store_1 = require("devextreme/data/custom_store");
require("rxjs/add/operator/toPromise");
var devextreme_angular_1 = require("devextreme-angular");
var alert_component_1 = require("../alert/alert.component");
var moment = require("moment");
var material_1 = require("@angular/material");
var report_component_1 = require("../report/report.component");
var sharedService_1 = require("../../models/sharedService");
var schedule_process_component_1 = require("../scheduling/schedule-process.component");
var material_2 = require("@angular/material");
var req_http_service_1 = require("../../services/req-http.service");
var notification_component_1 = require("../notification/notification.component");
var MonitorComponent = /** @class */ (function () {
    function MonitorComponent(_reqHttpService, dialog, _sharedService) {
        this._reqHttpService = _reqHttpService;
        this.dialog = dialog;
        this._sharedService = _sharedService;
        this.dbEnumType = datebox_component_1.DateboxEnumType.date;
        /*grid custom*/
        this.columns = [];
        this.pagination = 10;
        this.select = 'single';
        this.gruping = false;
        this.download = true;
        this.process = false;
        this.editarMonitoramento = false;
        this.showInfo = false;
        this.showDelete = false;
        this.openInfo = '';
        this.editar = '';
        /*grid custom*/
        this.selectedItem = [];
        this.monitorUrl = '';
        this.columnProgress = '';
        this.executeMonitorUrl = '';
        this.formInvalid = false;
        this.buttonDisabled = true;
        this.pageInfo = "";
        this.monitorVisible = true;
        this.timeReload = [
            { textTime: 'Somente uma Vez', tempo: 0 },
            { textTime: '5 Segundos', tempo: 5000 },
            { textTime: '10 Segundos', tempo: 10000 },
            { textTime: '20 Segundos', tempo: 20000 },
        ];
        this.datas = {
            dataInicio: null,
            dataFim: null
        };
    }
    MonitorComponent.prototype.ngOnInit = function () {
        var _this = this;
        var me = this;
        setTimeout(function () {
            _this.executeMonitor(_this.datarange.value);
        }, 2000);
        this.columns.map(function (obj) {
            if (obj['dataField'].toLowerCase().indexOf(me.columnProgress.toLowerCase()) > -1) {
                obj['cellTemplate'] = 'progressBar';
            }
        });
        this.source = new custom_store_1.default({
            load: function (loadOptions) {
                var deferred = $.Deferred();
                var params = '';
                var url = (loadOptions.searchValue || '');
                if (url.toString().indexOf('?') != -1) {
                    params += '&';
                }
                else {
                    params += '?';
                }
                // let prev = (loadOptions.skip + me.pagination) / me.pagination;
                // if (prev && loadOptions.take) {
                // params += 'skip=' + (prev || 1);
                var prev = (loadOptions.skip + me.pagination) / me.pagination;
                loadOptions.skip = loadOptions.skip + 10;
                params += 'p=' + (loadOptions.skip.toString().charAt(0) != 0 ? loadOptions.skip.toString().charAt(0) : 1);
                params += '&l=' + (loadOptions.take || me.pagination);
                if (loadOptions.sort) {
                    params += '&sort=-' + loadOptions.sort[0].selector;
                    if (loadOptions.sort[0].desc) {
                        params = params.replace('&sort=-', '&sort=');
                        // params += ' desc';
                    }
                }
                // }else {
                //     if (loadOptions.sort) {
                //         params += 'sort=-' + loadOptions.sort[0].selector;
                //         if (loadOptions.sort[0].desc) {
                //             params = params.replace('sort=-', 'sort=');
                //             // params += ' desc';
                //         }
                //     }
                // }
                if (loadOptions.searchValue) {
                    if (loadOptions.filter) {
                        params = '';
                        if (loadOptions.sort) {
                            params = '?sort=-' + loadOptions.sort[0].selector;
                            if (loadOptions.sort[0].desc) {
                                params = params.replace('?sort=-', '?sort=');
                                // params += ' desc';
                            }
                        }
                    }
                    var xhr_1 = new XMLHttpRequest();
                    xhr_1.open('GET', loadOptions.searchValue + params, true);
                    xhr_1.setRequestHeader('Token', localStorage.getItem('__SBM-SHARED__/token'));
                    xhr_1.onreadystatechange = function () {
                        if (xhr_1.readyState === 4) {
                            if (xhr_1.status === 200) {
                                var result = JSON.parse(xhr_1.responseText);
                                // params = {result.data, totalCount: result.size};
                                if (loadOptions.filter) {
                                    // let filterData = [];
                                    // let filterCount = 0;
                                    // let index;
                                    // for (let i = 0; i < result.data.length; i++) {
                                    //  for (let key in result.data[i]) {
                                    //  if (result.data[i][key] != null) {
                                    //  if (result.data[i][key].toString().indexOf(loadOptions.filter[0][2]) != -1) {
                                    //  if (index != i) {
                                    //  filterData.push(result.data[i]);
                                    //  index = i;
                                    //  filterCount = filterData.length;
                                    //  }
                                    //  }
                                    //  }
                                    //  }
                                    //  }
                                    // deferred.resolve({
                                    //  data: filterData,
                                    //  totalCount: filterCount
                                    //  });
                                    if (result['data']) {
                                        var aux = result.size / me.pagination;
                                        var auxRound = Math.ceil(aux);
                                        me.pageInfo = "Página " + prev.toString() + " de " + auxRound.toString() + " (" + result.size.toString() + " items)";
                                        deferred.resolve({
                                            data: result.data,
                                            totalCount: result.size
                                        });
                                    }
                                    else {
                                        var aux = result.length / me.pagination;
                                        var auxRound = Math.ceil(aux);
                                        me.pageInfo = "Página " + prev.toString() + " de " + auxRound.toString() + " (" + result.length.toString() + " items)";
                                        deferred.resolve({
                                            data: result,
                                            totalCount: result.length
                                        });
                                    }
                                }
                                else {
                                    if (result.size == 0) {
                                        deferred.resolve({
                                            data: [],
                                            totalCount: result.size
                                        });
                                    }
                                    else if (result['data']) {
                                        var aux = result.size / me.pagination;
                                        var auxRound = Math.ceil(aux);
                                        me.pageInfo = "Página " + prev.toString() + " de " + auxRound.toString() + " (" + result.size.toString() + " items)";
                                        deferred.resolve({
                                            data: result.data,
                                            totalCount: result.size
                                        });
                                    }
                                    else {
                                        var aux = result.length / me.pagination;
                                        var auxRound = Math.ceil(aux);
                                        me.pageInfo = "Página " + prev.toString() + " de " + auxRound.toString() + " (" + result.length.toString() + " items)";
                                        deferred.resolve({
                                            data: result,
                                            totalCount: result.length
                                        });
                                    }
                                }
                            }
                            else {
                                if (xhr_1.status == 204) {
                                    deferred.resolve({
                                        data: [],
                                        totalCount: 0
                                    });
                                }
                                else {
                                    deferred.reject('Erro ao Carregar os registros (#' + xhr_1.status + ' ' + xhr_1.statusText + ')');
                                }
                            }
                        }
                    };
                    xhr_1.send();
                    return deferred.promise();
                }
                else {
                    deferred.resolve({
                        data: [],
                        totalCount: 0
                    });
                    return deferred.promise();
                }
            }
        });
    };
    MonitorComponent.prototype.downloadPdf = function (data) {
        var _this = this;
        var alertComponent = new alert_component_1.AlertComponent();
        var notification = new notification_component_1.NotificationComponent();
        alertComponent.show('Download relatório', 'Sim', 'Deseja fazer o download do relatório', 'info', true, 'Cancelar').then(function (ret) {
            if (ret) {
                _this._reqHttpService.xhrGet("/sabium/api/relatorio/execucao/" + data.idExecucao + "/download").subscribe(function (ret) {
                    var dlnk = document.getElementById('dwnldLnk-951753');
                    dlnk['href'] = 'data:application/octet-stream;base64,' + ret.res['relatorio'];
                    dlnk.click();
                    notification.show("Download Concluído");
                }, function (err) {
                    alertComponent.show('Erro ao realizar o download do relatório', 'Ok', 'Execucao de relatorio nao encontrada para download do arquivo', 'error');
                });
            }
        });
    };
    MonitorComponent.prototype.openErrorDialog = function (data) {
        var configDialog = Object.assign(new material_2.MatDialogConfig(), {
            width: 'auto',
            data: {
                stacktrace: data.stacktrace ? data.stacktrace : data.informacoes
            }
        });
        this.dialog.open(DialogError, configDialog);
    };
    MonitorComponent.prototype.openDialog = function (data) {
        //console.log('openDialog', data);
        //let execucaoUnica: boolean = false;
        var agendExecucaoUnica = [];
        var agendSemanal = [];
        var agendMensal = [];
        var agendTemporal = [];
        if (data.periodos && data.periodos.length) {
            data.periodos.map(function (item) {
                var dataIniAux;
                var dataFimAux;
                if (item.dataInicio) {
                    dataIniAux = new Date(item.dataInicio);
                }
                if (item.dataFim) {
                    dataFimAux = new Date(item.dataFim);
                }
                if (!item.dataFim) {
                    // Execução unica
                    var data_1 = new Date(item.dataInicio);
                    var data2 = moment(data_1).format("DD/MM/YYYY");
                    agendExecucaoUnica.push({
                        dataInicio: data2,
                        horario: item.horarioExecucao.hora.toString() + ":" + item.horarioExecucao.minuto.toString() + ":" + item.horarioExecucao.segundo.toString()
                    });
                }
                else if (item.diasSemana) {
                    // Semanal
                    //let dataIni: any = new Date(item.dataInicio);
                    //let dataFim: any = new Date(item.dataFim);
                    agendSemanal.push({
                        dataInicio: moment(dataIniAux).format("DD/MM/YYYY"),
                        dataFim: moment(dataFimAux).format("DD/MM/YYYY"),
                        diasSemana: item.diasSemana.toString(),
                        horario: item.horarioExecucao.hora.toString() + ":" + item.horarioExecucao.minuto.toString() + ":" + item.horarioExecucao.segundo.toString()
                    });
                }
                else if (item.tipoPeriodo) {
                    // Mensal
                    agendMensal.push({
                        dataInicio: moment(dataIniAux).format("DD/MM/YYYY"),
                        dataFim: moment(dataFimAux).format("DD/MM/YYYY"),
                        tipoPeriodo: item.tipoPeriodo,
                        dia: item.dia == 0 ? "" : item.dia.toString(),
                        horario: item.horarioExecucao.hora.toString() + ":" + item.horarioExecucao.minuto.toString() + ":" + item.horarioExecucao.segundo.toString()
                    });
                }
                else if (item.tipoIntervalo) {
                    agendTemporal.push({
                        dataInicio: moment(dataIniAux).format("DD/MM/YYYY"),
                        dataFim: moment(dataFimAux).format("DD/MM/YYYY"),
                        tipoIntervalo: item.tipoIntervalo,
                        intervalo: item.intervalo
                    });
                }
            });
        }
        //let periodosMostrar: any;
        //console.log('agendExecucaoUnica:', agendExecucaoUnica);
        //console.log('agendamento semanais:', agendSemanal);
        var configDialogRef = Object.assign(new material_2.MatDialogConfig(), {
            width: data.periodos ? '700px' : '350px',
            data: {
                process: this.process,
                data: data,
                periodos: data.periodos,
                agendExecucaoUnica: agendExecucaoUnica,
                agendSemanal: agendSemanal,
                agendMensal: agendMensal,
                agendTemporal: agendTemporal
            }
        });
        var dialogRef = this.dialog.open(DialogReportInfoDialog, configDialogRef);
        dialogRef.afterClosed().subscribe(function (result) {
            //dialog close
        });
    };
    MonitorComponent.prototype.limpar = function () {
        clearInterval(this.interval);
    };
    MonitorComponent.prototype.reloadMonitor = function (event) {
        var _this = this;
        clearInterval(this.interval);
        this.buttonDisabled = false;
        if (event.tempo > 0) {
            this.interval = setInterval(function () {
                _this.monitor.instance.refresh();
            }, event.tempo);
        }
    };
    MonitorComponent.prototype.formatDate = function (date) {
        return ['0' + date.getDate().slice(-2),
            ('0' + (date.getMonth() + 1)).slice(-2),
            date.getFullYear()].join('/') + ' 00:00';
    };
    MonitorComponent.prototype.selectionData = function ($event) {
    };
    MonitorComponent.prototype.executeMonitor = function (dates) {
        this.buttonDisabled = false;
        this.executeMonitorUrl = '';
        var d = dates.split(' - ');
        var params = '?';
        params += 'dataInicio=' + moment(d[0]).format("DD/MM/YYYY HH:mm") + '-' + moment(d[1]).format("DD/MM/YYYY HH:mm");
        this.executeMonitorUrl = this.monitorUrl + params;
        this.monitor.instance.refresh();
    };
    MonitorComponent.prototype.valueDivider = function (value) {
        return value / 1000;
    };
    MonitorComponent.prototype.ngDoCheck = function () {
        if (this.datas.dataInicio != null && this.datas.dataFim != null) {
            this.formInvalid = false;
        }
        else {
            this.formInvalid = true;
        }
    };
    MonitorComponent.prototype.ngOnDestroy = function () {
        clearInterval(this.interval);
    };
    MonitorComponent.prototype.clickEdit = function ($event) {
        //console.log('editar agendamento:', $event);
        this.monitorVisible = false;
        this._sharedService.clearLocalStorage(_projectLocalStorage + 'process-local');
        this._sharedService.clearLocalStorage(_projectLocalStorage + 'scheduling-report');
        if (this.editar == "relatorio") {
            this.reportMonitor.getAgendamentoReport($event.id, $event.codigoRelatorio);
        }
        else if (this.editar == "processo") {
            this.processMonitor.getAgendamentoProcess($event.id, $event.codigoProcesso);
        }
        /*
                 this.mostrarReportMonitoramento = true;
                * */
    };
    MonitorComponent.prototype.clickDelete = function ($event) {
        var _this = this;
        var _alert = new alert_component_1.AlertComponent();
        var _notification = new notification_component_1.NotificationComponent();
        _alert.show('Remover', 'Sim', 'Deseja realmente excluir este registro?', 'warning', true, 'Não').then(function (ret) {
            if (ret) {
                _this._reqHttpService.xhrDelete("/sabium/api/agendamento/" + $event.id).subscribe(function (retorno) {
                    if (retorno.success) {
                        _notification.show('Sucesso ao remover o registro!', 2000);
                        //recarrega grid
                        //recarrega grid
                        _this.monitor.instance.refresh();
                    }
                });
            }
        });
    };
    MonitorComponent.prototype.voltarMonitoramento = function () {
        this.monitorVisible = true;
        this._sharedService.clearLocalStorage(_projectLocalStorage + 'scheduling-report');
        this._sharedService.clearLocalStorage(_projectLocalStorage + 'process-local');
    };
    MonitorComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'sbm-monitor',
                    template: require('./monitor.component.html'),

                    styles: [require('./monitor.component.css')],
               },] },
    ];
    /** @nocollapse */
    MonitorComponent.ctorParameters = function () { return [
        { type: req_http_service_1.ReqHttpService, },
        { type: material_1.MatDialog, },
        { type: sharedService_1.SharedService, },
    ]; };
    MonitorComponent.propDecorators = {
        "monitor": [{ type: core_1.ViewChild, args: ['monitor',] },],
        "datarange": [{ type: core_1.ViewChild, args: ['datarange',] },],
        "reportMonitor": [{ type: core_1.ViewChild, args: ['reportMonitor',] },],
        "processMonitor": [{ type: core_1.ViewChild, args: ['processMonitor',] },],
        "columns": [{ type: core_1.Input },],
        "pagination": [{ type: core_1.Input },],
        "select": [{ type: core_1.Input },],
        "gruping": [{ type: core_1.Input },],
        "download": [{ type: core_1.Input },],
        "process": [{ type: core_1.Input },],
        "editarMonitoramento": [{ type: core_1.Input },],
        "showInfo": [{ type: core_1.Input },],
        "showDelete": [{ type: core_1.Input },],
        "openInfo": [{ type: core_1.Input },],
        "editar": [{ type: core_1.Input },],
        "monitorUrl": [{ type: core_1.Input },],
        "columnProgress": [{ type: core_1.Input },],
    };
    return MonitorComponent;
}());
exports.MonitorComponent = MonitorComponent;
var DialogReportInfoDialog = /** @class */ (function () {
    function DialogReportInfoDialog(dialogRef, data) {
        this.dialogRef = dialogRef;
        this.data = data;
    }
    DialogReportInfoDialog.prototype.onNoClick = function () {
        this.dialogRef.close();
    };
    DialogReportInfoDialog.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'dialog-info-report-dialog',
                    template: "\n        <ng-container *ngIf=\"!data.process && !data.periodos\">\n            <mat-list>\n                <mat-list-item> C\u00F3digo: {{data.codigo}} </mat-list-item>\n                <mat-list-item> Nome: {{data.nome}} </mat-list-item>\n                <mat-list-item> Situa\u00E7\u00E3o: {{data?.situacao}} </mat-list-item>\n                <mat-list-item> Vers\u00E3o: {{data?.versao}} </mat-list-item>\n                <mat-list-item> Usu\u00E1rio: {{data?.usuario}} </mat-list-item>\n            </mat-list>\n        </ng-container>\n\n        <ng-container *ngIf=\"data.process\">\n            <mat-list>\n                <mat-list-item> C\u00F3digo: {{data.data.processo.codigo}} </mat-list-item>\n                <mat-list-item> Nome: {{data.data.processo.nome}} </mat-list-item>\n                <mat-list-item> Situa\u00E7\u00E3o: {{data.data?.processo.situacao}} </mat-list-item>\n                <mat-list-item> Classe: {{data.data?.processo.classe}} </mat-list-item>\n                <mat-list-item> Doeumenta\u00E7\u00E3o: {{data.data?.processo.documentacao}} </mat-list-item>\n                <mat-list-item> Percentual: {{data.data?.processo.percentualConclusao}} </mat-list-item>\n                <mat-list-item> Motivo Cancelamento: {{data.data?.processo.motivoCancelamento}} </mat-list-item>\n                <mat-list-item> Usu\u00E1rio: {{data.data?.usuario}} </mat-list-item>\n            </mat-list>\n        </ng-container>\n        <ng-container *ngIf=\"data.periodos\">\n            <h5 class=\"\" style=\"margin-bottom: 22px; margin-top: 0px;\">Hor\u00E1rios do agendamento</h5>\n            <sbm-fieldset label=\"Hor\u00E1rios Semanais\" *ngIf=\"data.agendSemanal.length > 0\">\n                <dx-data-grid [dataSource]='data.agendSemanal'>\n                    <dxi-column caption=\"Data In\u00EDcio\" dataField=\"dataInicio\"></dxi-column>\n                    <dxi-column caption=\"Data Fim\" dataField=\"dataFim\"></dxi-column>\n                    <dxi-column caption=\"Dias da Semana\" dataField=\"diasSemana\"></dxi-column>\n                    <dxi-column caption=\"Hor\u00E1rio\" dataField=\"horario\"></dxi-column>\n                </dx-data-grid>\n            </sbm-fieldset>\n            <sbm-fieldset label=\"Hor\u00E1rios de execu\u00E7\u00E3o \u00FAnica\" *ngIf=\"data.agendExecucaoUnica.length > 0\">\n                <dx-data-grid [dataSource]='data.agendExecucaoUnica'>\n                    <dxi-column caption=\"Data In\u00EDcio\" dataField=\"dataInicio\"></dxi-column>\n                    <dxi-column caption=\"Hor\u00E1rio\" dataField=\"horario\"></dxi-column>\n                </dx-data-grid>\n            </sbm-fieldset>\n            <sbm-fieldset label=\"Hor\u00E1rios Mensais\" *ngIf=\"data.agendMensal.length > 0\">\n                <dx-data-grid [dataSource]='data.agendMensal'>\n                    <dxi-column caption=\"Data In\u00EDcio\" dataField=\"dataInicio\"></dxi-column>\n                    <dxi-column caption=\"Data Fim\" dataField=\"dataFim\"></dxi-column>\n                    <dxi-column caption=\"Tipo de Per\u00EDodo\" dataField=\"tipoPeriodo\"></dxi-column>\n                    <dxi-column caption=\"Dia\" dataField=\"dia\"></dxi-column>\n                    <dxi-column caption=\"Hor\u00E1rio\" dataField=\"horario\"></dxi-column>\n                </dx-data-grid>\n            </sbm-fieldset>\n            <sbm-fieldset label=\"Hor\u00E1rios Temporais\" *ngIf=\"data.agendTemporal.length > 0\">\n                <dx-data-grid [dataSource]=\"data.agendTemporal\">\n                    <dxi-column caption=\"Data In\u00EDcio\" dataType=\"date\" format=\"dd/MM/yyyy\" dataField=\"dataInicio\"></dxi-column>\n                    <dxi-column caption=\"Data Fim\" dataType=\"date\" format=\"dd/MM/yyyy\" dataField=\"dataFim\"></dxi-column>\n                    <dxi-column caption=\"Tipo de intervalo\" dataField=\"tipoIntervalo\"></dxi-column>\n                    <dxi-column caption=\"Intervalo de tempo\" dataField=\"intervalo\"></dxi-column>\n                </dx-data-grid>\n            </sbm-fieldset>\n        </ng-container>\n    ",
                },] },
    ];
    /** @nocollapse */
    DialogReportInfoDialog.ctorParameters = function () { return [
        { type: material_1.MatDialogRef, },
        { type: undefined, decorators: [{ type: core_1.Inject, args: [material_1.MAT_DIALOG_DATA,] },] },
    ]; };
    return DialogReportInfoDialog;
}());
exports.DialogReportInfoDialog = DialogReportInfoDialog;
var DialogError = /** @class */ (function () {
    function DialogError(dialog, data) {
        this.dialog = dialog;
        this.data = data;
    }
    DialogError.prototype.onNoClick = function () {
        this.dialog.close();
    };
    DialogError.prototype.ngAfterViewInit = function () {
        $(this.box.nativeElement).height($(window).height() - 200);
    };
    DialogError.prototype.onResize = function (event) {
        $(this.box.nativeElement).height(event.target.innerHeight - 200);
    };
    DialogError.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'dialog-error',
                    template: "\n        <h4>Log do erro <i class=\"material-icons\" style=\"color: red\">error_outline</i></h4>\n        <div class=\"box-error\" #boxerror>\n            {{data?.stacktrace}}\n        </div>\n    ",
                    styles: ["\n       h4{\n           border-bottom: 1px solid #000;\n           color: #000;\n           text-align: center;\n           padding-bottom: 4px;\n       }\n        \n       i{\n           color: red;\n           vertical-align: middle;\n           font-size: 30px;\n       }\n        \n        .box-error{\n            max-height: 700px;\n            overflow-y: auto;\n        }\n    "]
                },] },
    ];
    /** @nocollapse */
    DialogError.ctorParameters = function () { return [
        { type: material_1.MatDialogRef, },
        { type: undefined, decorators: [{ type: core_1.Inject, args: [material_1.MAT_DIALOG_DATA,] },] },
    ]; };
    DialogError.propDecorators = {
        "box": [{ type: core_1.ViewChild, args: ['boxerror',] },],
        "onResize": [{ type: core_1.HostListener, args: ['window:resize', ['$event'],] },],
    };
    return DialogError;
}());
exports.DialogError = DialogError;
