"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@ngx-translate/core");
var http_1 = require("@angular/http");
var core_2 = require("@angular/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var sharedService_1 = require("../../models/sharedService");
var MultiselectDropdownComponent = /** @class */ (function (_super) {
    __extends(MultiselectDropdownComponent, _super);
    function MultiselectDropdownComponent(_translateService, _http, _sharedService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._translateService = _translateService;
        _this._http = _http;
        _this._sharedService = _sharedService;
        _this.id = '';
        _this.name = '';
        _this.textField = '';
        _this.dataSource = [];
        _this.css = 'sbm-chip';
        _this._attr = '';
        _this._columns = 'input-field col l12 m12 s12 crud-form-dynamic';
        _this.listviewvalue = [];
        _this.randowString = 'sbm-randon-' + (Math.floor((Math.random() * 100000) + 1));
        sbmMultiDropdownComponent.push(_this);
        return _this;
    }
    Object.defineProperty(MultiselectDropdownComponent.prototype, "attribute", {
        get: function () {
            return this._attr;
        },
        set: function (val) {
            this._attr = val;
            if (this.name != '') {
                this.name = val;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MultiselectDropdownComponent.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = "input-field col l" + value + " m12 s12 crud-form-dynamic";
        },
        enumerable: true,
        configurable: true
    });
    MultiselectDropdownComponent.prototype.initMultiselect = function () {
        var _this = this;
        $(this.multiSelectDropdown.nativeElement).on('chip.add', function (e, chip) {
            // this.addValue(chip, e);
        });
        $(this.multiSelectDropdown.nativeElement).on('chip.delete', function (e, chip) {
            // this.deleteItem(chip, e);
        });
        $(this.multiSelectDropdown.nativeElement).material_chip();
        $(this.multiSelectDropdown.nativeElement).find('input').blur(function () {
            // this.blur($(this.multiselect.nativeElement).material_chip('data'), $(this.multiSelectDropdown.nativeElement));
        });
        $(this.multiSelectDropdown.nativeElement).find('input').focus(function (el) {
            // el.stopPropagation(); // Stop event propagation is needed, otherwise may trigger the document body click event handled by plugin.
            WebuiPopovers.show('#el');
        });
        $(this.multiSelectDropdown.nativeElement).find('input').keyup(function () {
            // this.keyup($(this.multiselect.nativeElement));
        });
        $(document).ready(function () {
            $(".dropdown-button-498741233644985673").dropdown({
                stopPropagation: false,
                hover: false,
                // Activate on hover
                constrainWidth: true,
                belowOrigin: true,
                // Displays dropdown below the button
                alignment: 'right' // Displays dropdown with edge aligned to the left of button
            });
            $(_this.multiSelectDropdown.nativeElement).find('input').attr('readonly', true);
            _this.getWidth = $(_this.multiSelectDropdown.nativeElement).outerWidth();
            $(window).resize(function () {
                _this.getWidth = $(_this.multiSelectDropdown.nativeElement).outerWidth();
            });
            WebuiPopovers.create('.sbm-multi-select-dropdown', {
                url: '#' + _this.randowString,
                placement: 'bottom-left',
                width: $(_this.multiSelectDropdown.nativeElement).outerWidth(),
                height: 440,
                animation: 'pop',
                backdrop: false,
                closeable: false,
                arrow: false,
                dismissible: true,
                onHide: function ($element) {
                    var newValue = _this.listviewvalue.reduce(function (a, n) {
                        a.push({ 'tag': n });
                        return a;
                    }, []);
                    $(_this.multiSelectDropdown.nativeElement).material_chip({ data: newValue });
                    $(_this.multiSelectDropdown.nativeElement).find('input').attr('readonly', true);
                    _this.value = _this.listviewvalue;
                },
            });
        });
    };
    MultiselectDropdownComponent.prototype.ngAfterViewInit = function () {
        this.initMultiselect();
    };
    MultiselectDropdownComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
    };
    MultiselectDropdownComponent.decorators = [
        { type: core_2.Component, args: [{
                    selector: 'sbm-multiselect-dropdown',
                    template: require('./multiselect-dropdown.component.html'),

                    host: {
                        '[class]': 'columns'
                    },
                    providers: [abstract_ngmodel_1.MakeProvider(MultiselectDropdownComponent)],
                },] },
    ];
    /** @nocollapse */
    MultiselectDropdownComponent.ctorParameters = function () { return [
        { type: core_1.TranslateService, },
        { type: http_1.Http, },
        { type: sharedService_1.SharedService, },
    ]; };
    MultiselectDropdownComponent.propDecorators = {
        "multiSelectDropdown": [{ type: core_2.ViewChild, args: ['multiselectdropdown',] },],
        "content": [{ type: core_2.ViewChild, args: ['content',] },],
        "id": [{ type: core_2.Input },],
        "name": [{ type: core_2.Input },],
        "textField": [{ type: core_2.Input, args: ['textfield',] },],
        "dataSource": [{ type: core_2.Input, args: ['datasource',] },],
        "css": [{ type: core_2.Input },],
        "attribute": [{ type: core_2.Input },],
        "columns": [{ type: core_2.Input },],
    };
    return MultiselectDropdownComponent;
}(abstract_ngmodel_1.AbstractNgModel));
exports.MultiselectDropdownComponent = MultiselectDropdownComponent;
