"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var req_http_service_1 = require("../../services/req-http.service");
var sharedService_1 = require("../../models/sharedService");
var core_2 = require("@ngx-translate/core");
var ParametersComponent = /** @class */ (function () {
    function ParametersComponent(_reqHttpService, _sharedService, _translateService) {
        var _this = this;
        this._reqHttpService = _reqHttpService;
        this._sharedService = _sharedService;
        this._translateService = _translateService;
        this.showExcluirParam = false;
        this.colunaParametro = 12;
        this.onSave = new core_1.EventEmitter();
        this._onClickInfo = new core_1.EventEmitter();
        this._onClickExcluir = new core_1.EventEmitter();
        this.withShadingOptionsVisible = {};
        this.columns = [
            { dataField: 'rotulo', caption: 'Chave' },
            { dataField: 'tipo', caption: 'Valor', cellTemplate: 'cellTemplate' }
        ];
        this.returnParameter = {
            'parametros': [],
            'codigoApp': _projectCodigo
            // 'versaoApp': _projectVersao
        };
        this.modelParameter = {};
        this.value = '';
        this.parametrosPreenchidosObrigatorio = true;
        this._translateService.onLangChange.subscribe(function (ret) {
            _this.retTraducao = _this._translateService.translations[_this._translateService.currentLang].i18n[_projectName];
        });
    }
    Object.defineProperty(ParametersComponent.prototype, "models", {
        get: function () {
            return this.modelsForm;
        },
        set: function (val) {
            this.modelsForm = val;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ParametersComponent.prototype, "dataSource", {
        get: function () {
            return this._dataSourceSelect;
        },
        set: function (value) {
            if (value) {
                this._dataSourceSelect = value;
                this._dataSource = value;
                this.reloadModel();
            }
        },
        enumerable: true,
        configurable: true
    });
    ParametersComponent.prototype.reloadModel = function () {
        if (this.dataSource !== undefined) {
            for (var _i = 0, _a = this.dataSource; _i < _a.length; _i++) {
                var item = _a[_i];
                if (item.tipo == 'TABELA') {
                    this.modelParameter[item.nome] = [];
                    this.withShadingOptionsVisible[item.nome] = false;
                    item.rotuloTraduzido = this.retTraducao[item.rotulo.replace('#', '')];
                }
                else if (item.tipo == 'BOOLEAN' || item.tipo == 'LOGICO') {
                    this.modelParameter[item.nome] = item.valor_padrao == 'true';
                }
                else {
                    this.modelParameter[item.nome] = item.valor_padrao;
                }
                // this.returnParameter.codigo = this._dataSource.codigo;
            }
        }
    };
    ParametersComponent.prototype.ngOnInit = function () {
        // CrudComponent.emitChangeFilter.subscribe((ret) => {
        //     this.reloadModel();
        // });
        this.reloadModel();
    };
    ParametersComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        $(document).ready(function () {
            _this.blurParametro();
            _this.toggleWithShadingOptions(_this.dataSource);
        });
    };
    ParametersComponent.prototype.ngOnChanges = function () {
        if (this._dataSource) {
            this.returnParameter.parametros = [];
            // this.returnParameter.codigo = this._dataSource.codigo;
            // corrigindo problema quando inicializa componente,
            // mas ao entrar em outra aba não entrava mais no ngAfterViewInit e assim deixava os parametros vazio
            this.blurParametro();
        }
    };
    ParametersComponent.prototype.blurParametro = function (event) {
        if (event === void 0) { event = null; }
        if (this.dataSource !== undefined) {
            this.parametrosPreenchidosObrigatorio = true;
            this.returnParameter.parametros = [];
            for (var _i = 0, _a = this.dataSource; _i < _a.length; _i++) {
                var item = _a[_i];
                var itemModel = {};
                if (item.tipo == 'TABELA') {
                    itemModel = {
                        'nome': item.nome,
                        'obrigatorio': item['obrigatorio'],
                        'valor': (this.modelParameter[item.nome].join())
                    };
                }
                else {
                    itemModel = {
                        'nome': item.nome,
                        'obrigatorio': item['obrigatorio'],
                        'valor': (this.modelParameter[item.nome])
                    };
                    if (item.hasOwnProperty('codigo')) {
                        itemModel['codigo'] = item.codigo;
                    }
                    if (item.obrigatorio && (itemModel.valor == '' || itemModel.valor == null)) {
                        this.parametrosPreenchidosObrigatorio = false;
                    }
                }
                this.returnParameter.parametros.push(itemModel);
            }
            this.onSave.emit({ parameters: this.returnParameter, parametrosPreenchidosObrigatorio: this.parametrosPreenchidosObrigatorio });
            this.models = this.returnParameter;
            this._sharedService.setLocalStorage(_projectLocalStorage, 'parameter-current', this.modelParameter, true);
        }
    };
    ParametersComponent.prototype.openPopover = function (item) {
        WebuiPopovers.show(".sbmTable" + item.nome, {
            url: "#sbmTable" + item.nome,
            placement: 'bottom',
            width: 400,
            animation: 'pop',
            closeable: true,
            async: {
                type: 'GET',
                // ajax request method type, default is GET
                before: function (that, xhr, settings) {
                },
                // executed before ajax request
                success: function (that, data) {
                },
                // executed after successful ajax request
                error: function (that, xhr, data) {
                } // executed after error ajax request
            },
        });
    };
    ParametersComponent.prototype.toggleWithShadingOptions = function (data) {
        var _this = this;
        if (data !== undefined) {
            var _loop_1 = function (item) {
                if (item.tipo == 'TABELA') {
                    this_1._reqHttpService.xhrGet("/" + _projectCodigo + "/api/" + item.entidade).subscribe(function (ret) {
                        _this.dataTable = ret.res.data;
                        if (typeof item.campo == 'string') {
                            item.campo = item.campo.split(',');
                        }
                        localStorage.setItem("SBM_PARAMETERS_TABLE-" + item.nome, JSON.stringify(ret.res.data));
                        WebuiPopovers.create(".sbmTable" + item.nome, {
                            url: "#sbmTable" + item.nome,
                            placement: 'bottom',
                            width: 400,
                            animation: 'pop',
                            backdrop: false,
                            closeable: true,
                            dismissible: true,
                        });
                    });
                    this_1.withShadingOptionsVisible[item.nome] = !this_1.withShadingOptionsVisible[item.nome];
                }
            };
            var this_1 = this;
            for (var _i = 0, data_1 = data; _i < data_1.length; _i++) {
                var item = data_1[_i];
                _loop_1(item);
            }
        }
    };
    ParametersComponent.prototype.cliqueParameters = function (event, nome) {
        this.modelParameter[nome] = event;
        this.onSave.emit(this.returnParameter);
    };
    ParametersComponent.prototype.saveParameters = function (retorno) {
        this.onSave.emit(retorno);
    };
    ParametersComponent.prototype.ngOnDestroy = function () {
        localStorage.removeItem(_projectLocalStorage + 'parameter-current');
    };
    ParametersComponent.prototype.itemClicadoInfo = function ($event) {
        this._onClickInfo.emit($event);
        /*if (this.onClick != '') {
                   window[this.onClick](true);
               }*/
    };
    ParametersComponent.prototype.itemClicadoExcluir = function ($event, nome) {
        this._onClickExcluir.emit({ $event: $event, nome: nome });
    };
    ParametersComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'sbm-parameters',
                    template: require('./parameters.component.html'),
                },] },
    ];
    /** @nocollapse */
    ParametersComponent.ctorParameters = function () { return [
        { type: req_http_service_1.ReqHttpService, },
        { type: sharedService_1.SharedService, },
        { type: core_2.TranslateService, },
    ]; };
    ParametersComponent.propDecorators = {
        "models": [{ type: core_1.Input },],
        "dataSource": [{ type: core_1.Input, args: ['dataSource',] },],
        "showExcluirParam": [{ type: core_1.Input, args: ['showExcluirParam',] },],
        "colunaParametro": [{ type: core_1.Input, args: ['colunaParametro',] },],
        "onSave": [{ type: core_1.Output },],
        "_onClickInfo": [{ type: core_1.Output },],
        "_onClickExcluir": [{ type: core_1.Output },],
    };
    return ParametersComponent;
}());
exports.ParametersComponent = ParametersComponent;
