"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var material_1 = require("@angular/material");
var material_2 = require("@angular/material");
var PdfComponent = /** @class */ (function () {
    function PdfComponent(dialog) {
        this.dialog = dialog;
        this.src = '';
        this.zoom = 1;
        this.rotation = 0;
        this.onComplete = '';
        this._onComplete = new core_1.EventEmitter();
        this._columns = 'col l12 m12 s12 crud-form-dynamic';
        this._data = '';
        this.width = 'auto';
    }
    Object.defineProperty(PdfComponent.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = "l" + value + " m12 s12 crud-form-dynamic";
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PdfComponent.prototype, "data", {
        get: function () {
            return this._data;
        },
        set: function (val) {
            if (val) {
                this._data = {
                    data: atob(val),
                    withCredentials: false
                };
            }
        },
        enumerable: true,
        configurable: true
    });
    PdfComponent.prototype.expand = function () {
        var configDialog = Object.assign(new material_2.MatDialogConfig(), {
            width: this.pdf.element.nativeElement.scrollWidth + 'px',
            data: {
                base64: this.data,
                zoom: this.zoom,
                rotation: this.rotation
            }
        });
        var dialogRef = this.dialog.open(PDFDialogComponent, configDialog);
        dialogRef.afterClosed().subscribe(function (result) {
            /*dialog close*/ 
        });
    };
    PdfComponent.prototype.zoomInOut = function (inOut) {
        if (this.zoom > 0) {
            if (inOut == 'in') {
                this.zoom = this.zoom + 0.5;
            }
            if (inOut == 'out') {
                this.zoom = this.zoom - 0.5;
            }
        }
        else {
            if (inOut == 'in') {
                this.zoom = this.zoom + 0.5;
            }
        }
    };
    PdfComponent.prototype.rotated = function (rotate) {
        var _this = this;
        if (this.rotation >= 0 && this.rotation <= 180) {
            if (rotate == 'rotatex') {
                if (this.rotation < 180) {
                    this.rotation = this.rotation + 90;
                }
            }
            if (rotate == 'rotatey') {
                if (this.rotation > 0) {
                    this.rotation = this.rotation - 90;
                }
            }
        }
        setTimeout(function () {
            _this.width = _this.pdf.element.nativeElement.scrollWidth + 'px';
        });
    };
    PdfComponent.prototype.download = function () {
        var dlnk = document.getElementById('dwnldLnk');
        dlnk['href'] = 'data:application/octet-stream;base64,' + btoa(this.data['data']);
        dlnk.click();
    };
    PdfComponent.prototype.complete = function (data) {
        setTimeout(function () {
            // this.width = this.pdf.element.nativeElement.scrollWidth+'px';
        }, 1000);
        this._onComplete.emit(data);
        if (this.onComplete != '') {
            window[this.onComplete](data);
        }
    };
    PdfComponent.prototype.print = function () {
        window.print();
    };
    PdfComponent.prototype.error = function (err) {
        console.error(err);
    };
    PdfComponent.prototype.ngOnInit = function () {
    };
    PdfComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'sbm-pdf',
                    template: require('./pdf.component.html'),

                    styles: [require('./pdf.component.css')],
               },] },
    ];
    /** @nocollapse */
    PdfComponent.ctorParameters = function () { return [
        { type: material_1.MatDialog, },
    ]; };
    PdfComponent.propDecorators = {
        "pdf": [{ type: core_1.ViewChild, args: ['pdf',] },],
        "src": [{ type: core_1.Input },],
        "zoom": [{ type: core_1.Input },],
        "rotation": [{ type: core_1.Input },],
        "onComplete": [{ type: core_1.Output, args: ['oncomplete',] },],
        "_onComplete": [{ type: core_1.Output },],
        "columns": [{ type: core_1.Input },],
        "data": [{ type: core_1.Input },],
    };
    return PdfComponent;
}());
exports.PdfComponent = PdfComponent;
var PDFDialogComponent = /** @class */ (function () {
    function PDFDialogComponent(dialogRef, data) {
        this.dialogRef = dialogRef;
        this.data = data;
    }
    PDFDialogComponent.prototype.onNoClick = function () {
        this.dialogRef.close();
    };
    PDFDialogComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'sbm-pdf-dialog',
                    template: "\n    <pdf-viewer\n      #pdf\n      *ngIf=\"data!=''\"\n      [src]=\"data.base64\" \n      [rotation]=\"data.rotation\" \n      [zoom]=\"data.zoom\"\n      [show-all]=\"true\"\n      style=\"display: block;\"\n      [original-size]=\"true\"\n    ></pdf-viewer>\n  ",
                },] },
    ];
    /** @nocollapse */
    PDFDialogComponent.ctorParameters = function () { return [
        { type: material_1.MatDialogRef, },
        { type: undefined, decorators: [{ type: core_1.Inject, args: [material_1.MAT_DIALOG_DATA,] },] },
    ]; };
    return PDFDialogComponent;
}());
exports.PDFDialogComponent = PDFDialogComponent;
