"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var parameters_component_1 = require("../parameters/parameters.component");
var req_http_service_1 = require("../../services/req-http.service");
var ProgressComponent = /** @class */ (function () {
    function ProgressComponent(_req) {
        var _this = this;
        this._req = _req;
        this.name = '';
        this.description = '';
        this.assync = false;
        this.pdfBase64 = '';
        this.showExecuteResult = false;
        this.showScheduleResult = false;
        this._req.xhrGet('http://10.10.20.112/pdf.php').subscribe(function (ret) { return _this.pdfBase64 = ret.res['data']; });
    }
    Object.defineProperty(ProgressComponent.prototype, "dataSource", {
        get: function () {
            return this._dataSource;
        },
        set: function (value) {
            var _this = this;
            if (typeof value === 'string') {
                this._req.xhrGet(value).subscribe(function (ret) {
                    if (ret.success) {
                        _this.dataSource = ret.res;
                    }
                }, function (err) {
                    console.error('Ocorreu um erro na chamada do serviço =>', err);
                });
            }
            else {
                this._dataSource = value;
                this.name = value.nome;
                this.description = value.descricao;
                this.assync = value.assincrono;
                // rest retorna errado
                var parametros_1 = [];
                if (value.versao.length > 0) {
                    value.versao[0].parametro.map(function (item) {
                        item['tipo'] = item['tipoParametro'];
                        parametros_1.push(item);
                    });
                }
                //
                this.parameters = parametros_1;
            }
        },
        enumerable: true,
        configurable: true
    });
    ProgressComponent.prototype.ngOnInit = function () {
    };
    ProgressComponent.prototype.executeReport = function () {
        if (this.reportParameters.models !== undefined && this.reportParameters.models.parametros.length > 0 && this.dataSource != null) {
            /*
                        let params = [{
                          codigoRelatorio: this.dataSource.codigo,
                          versaoRelatorio: this.dataSource.versao[0].id,
                          parametros: this.reportParameters.models.parametros
                        }];
                        this._req.xhrPost('/sabium/relatorio/execucao', params).subscribe(ret => {
                          if (ret.success) {
                            this.showExecuteResult = true;
                            if (this.assync) {
            
                            } else {
                            }
                          }
                        }, (err: any) => {
                          console.error('Ocorreu um erro na chamada do serviço =>', err);
                        });*/
            this.showExecuteResult = true;
            this.showScheduleResult = false;
        }
    };
    ProgressComponent.prototype.openSchedule = function () {
        this.showExecuteResult = false;
        this.showScheduleResult = true;
    };
    ProgressComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'sbm-progress',
                    template: require('./progress.component.html'),

                    styles: [require('./progress.component.css')],
               },] },
    ];
    /** @nocollapse */
    ProgressComponent.ctorParameters = function () { return [
        { type: req_http_service_1.ReqHttpService, },
    ]; };
    ProgressComponent.propDecorators = {
        "dataSource": [{ type: core_1.Input },],
        "reportParameters": [{ type: core_1.ViewChild, args: [parameters_component_1.ParametersComponent,] },],
    };
    return ProgressComponent;
}());
exports.ProgressComponent = ProgressComponent;
