"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var datebox_component_1 = require("../datebox/datebox.component");
var grid_component_1 = require("../grid/grid.component");
var RelatoriosComponent = /** @class */ (function () {
    function RelatoriosComponent() {
        this.dbEnumType = datebox_component_1.DateboxEnumType.date;
        this.formInvalid = false;
        this.timeReload = [
            { textTime: 'Somente uma Vez', time: 0 },
            { textTime: '5 Segundos', time: 5000 },
            { textTime: '10 Segundos', time: 10000 },
            { textTime: '20 Segundos', time: 20000 },
        ];
        this.reportUrl = '';
        this.downloadUrl = '';
        this.onSelectItem = new core_1.EventEmitter();
        this.executeReportUrl = '';
    }
    RelatoriosComponent.prototype.ngOnInit = function () {
        this.executeReportUrl = this.reportUrl;
    };
    RelatoriosComponent.prototype.reloadReport = function (event) {
        var _this = this;
        if (event.time > 0) {
            setInterval(function () {
                _this.report.refresh();
            }, event.time);
        }
    };
    RelatoriosComponent.prototype.formatDate = function (date) {
        return [('0' + date.getDate()).slice(-2),
            ('0' + (date.getMonth() + 1)).slice(-2),
            date.getFullYear()].join('/') + ' 00:00';
    };
    RelatoriosComponent.prototype.executeReport = function (dates) {
        this.executeReportUrl = '';
        var d = dates.split(' - ');
        var params = '?';
        params += 'dataInicio=' + d[0] + " 08:00" + '-' + d[1] + " 08:00";
        this.executeReportUrl = this.reportUrl + params;
        this.report.refresh();
    };
    RelatoriosComponent.prototype.downloadReport = function (event) {
        this.onSelectItem.emit(event);
        /*let alertComponent = new AlertComponent();
                 alertComponent.show('Download relatório', 'Sim', 'Deseja fazer o download do relatório', 'info', true, 'Cancelar').then(ret => {
                 if (ret) {
                 let downloadUrl = this.downloadUrl.replace('{1}', event.selectedRowsData[0].id);
        
                 this._reqHttpService.xhrDownload(downloadUrl).subscribe(ret => {
                 let file = new Blob(['\ufeff', ret], {type: 'application/pdf'});
                 saveAs(file, 'relatorio.pdf');
        
                 let fileURL = URL.createObjectURL(file);
                 window.open(fileURL);
                 });
                 }
                 });*/
    };
    RelatoriosComponent.prototype.ngDoCheck = function () {
        // if (this.dates.dataInicio != null && this.dates.dataFim != null) {
        //     this.formInvalid = false;
        // } else {
        //     this.formInvalid = true;
        // }
    };
    RelatoriosComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'sbm-relatorios',
                    template: require('./relatorios.component.html'),

                    styles: [require('./relatorios.component.css')],
               },] },
    ];
    /** @nocollapse */
    RelatoriosComponent.ctorParameters = function () { return []; };
    RelatoriosComponent.propDecorators = {
        "report": [{ type: core_1.ViewChild, args: ['report',] },],
        "_columns": [{ type: core_1.ContentChildren, args: [grid_component_1.SbmGridColumn,] },],
        "columns": [{ type: core_1.Input },],
        "reportUrl": [{ type: core_1.Input },],
        "downloadUrl": [{ type: core_1.Input },],
        "onSelectItem": [{ type: core_1.Output },],
    };
    return RelatoriosComponent;
}());
exports.RelatoriosComponent = RelatoriosComponent;
