"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var notification_component_1 = require("./../notification/notification.component");
var core_1 = require("@angular/core");
var parameters_component_1 = require("../parameters/parameters.component");
var req_http_service_1 = require("../../services/req-http.service");
var sharedService_1 = require("../../models/sharedService");
var alert_component_1 = require("./../alert/alert.component");
var ReportComponent = /** @class */ (function () {
    function ReportComponent(_req, _sharedService) {
        // this._req.xhrGet('http://10.10.20.112/pdf.php').subscribe(ret => this.pdfBase64 = ret.res['data']);
        this._req = _req;
        this._sharedService = _sharedService;
        this.name = '';
        this.description = '';
        this.assync = false;
        this.pdfBase64 = '';
        this.showExecuteResult = false;
        this.showScheduleResult = false;
        this.buttonDisable = false;
        this.codigoApp = '';
        this.versaoApp = '';
        this.reportVisible = true;
    }
    Object.defineProperty(ReportComponent.prototype, "dataSource", {
        get: function () {
            return this._dataSource;
        },
        set: function (value) {
            var _this = this;
            if (typeof value === 'string') {
                this._req.xhrGet(value).subscribe(function (ret) {
                    if (ret.success) {
                        // console.log(JSON.stringify(ret.res));
                        // console.log(JSON.stringify(ret.res));
                        _this.dataSource = ret.res;
                        // rest retorna errado
                        var parametros_1 = [];
                        if (ret.res.parametro && ret.res.parametro.length > 0) {
                            ret.res.parametro.map(function (item) {
                                item['tipo'] = item['tipoParametro'];
                                parametros_1.push(item);
                            });
                        }
                        _this.parameters = parametros_1;
                    }
                }, function (err) {
                    console.error('Ocorreu um erro na chamada do serviço =>', err);
                });
            }
            else if (value) {
                this._dataSource = value;
                this.name = value.nome;
                this.description = value.descricao;
                this.assync = (value.formaExecucao == 'ASSINCRONA');
                // rest retorna errado
                var parametros_2 = [];
                if (value.parametro && value.parametro.length > 0) {
                    value.parametro.map(function (item) {
                        item['tipo'] = item['tipoParametro'];
                        parametros_2.push(item);
                    });
                }
                this.parameters = parametros_2;
                if (this.codAgendamentoToEdit) {
                    this.getAgendamento();
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    ReportComponent.prototype.ngOnInit = function () {
    };
    ReportComponent.prototype.executeReport = function () {
        var _this = this;
        var notification = new notification_component_1.NotificationComponent();
        var alert = new alert_component_1.AlertComponent();
        if (this.dataSource != null) {
            var report = {
                codigo: this.dataSource.codigo,
                versao: this.dataSource.versao,
                execucao: null
            };
            var params_1 = {};
            if (this.reportParameters.models !== undefined && this.reportParameters.models.parametros.length > 0) {
                this.reportParameters.models.parametros.map(function (i) {
                    params_1[i.chave] = i.valor;
                });
            }
            report['parametros'] = params_1;
            report['emailsSucesso'] = [];
            report['emailsFalha'] = [];
            if (this.dataSource.forma_execucao == 'SINCRONA') {
                notification.show('Aguarde Executando o relatório...');
            }
            this._req.xhrPost('/sabium/api/relatorio/executar', report).subscribe(function (ret) {
                if (ret.success) {
                    if (_this.dataSource.forma_execucao == 'SINCRONA') {
                        _this.showExecuteResult = true;
                        _this.pdfBase64 = ret.res['relatorio'];
                    }
                    else {
                        _this.showExecuteResult = true;
                        _this.assync = true;
                    }
                }
            }, function (err) {
                console.error('Ocorreu um erro na chamada do serviço =>', err);
                alert.show('Erro ao executar o relatório', 'Ok', err.res['statusText'], 'error');
            });
            this.showScheduleResult = false;
        }
    };
    ReportComponent.prototype.returnParameters = function (data) {
        data.parameters.parametros.map(function (ret) {
            ret.chave = ret.nome;
            delete ret.nome;
        });
        // data.codigo = this._processSelected.codigo;
        this.process = data;
        this.buttonDisable = !data.parametrosPreenchidosObrigatorio;
    };
    ReportComponent.prototype.openSchedule = function (fromEditar) {
        var _this = this;
        this._sharedService.clearLocalStorage(_projectLocalStorage + 'scheduling-report');
        this.showExecuteResult = false;
        this.showScheduleResult = true;
        var parametros = [];
        // busca id e version do parametro codigo na edição de agendamento de relatorio
        var paramCodigo = {
            chave: 'codigo',
            valor: this._dataSource.codigo
        };
        // busca id e version da versao na edição
        var paramVersao = {
            chave: 'versao',
            valor: this._dataSource.versao
        };
        if (this.objAgendamentoEdit
            && this.objAgendamentoEdit.processos
            && this.objAgendamentoEdit.processos.length
            && this.objAgendamentoEdit.processos[0].parametros) {
            var objcodigo_1;
            var objversao_1;
            this.objAgendamentoEdit.processos[0].parametros.forEach(function (item) {
                if (item.chave == 'codigo') {
                    objcodigo_1 = item;
                }
                else if (item.chave == 'versao') {
                    objversao_1 = item;
                }
            });
            if (objcodigo_1) {
                paramCodigo.id = objcodigo_1.id;
                paramCodigo.version = objcodigo_1.version;
            }
            if (objversao_1) {
                paramVersao.id = objversao_1.id;
                paramVersao.version = objversao_1.version;
            }
        }
        parametros.push(paramCodigo);
        parametros.push(paramVersao);
        if (!this.process && this.parameters) {
            this.parameters.map(function (item) {
                parametros.push({
                    chave: item.nome,
                    valor: ''
                });
            });
        }
        else {
            // pois as vezes o parametro vem alguns outros atributos como obrigatorio
            this.process.parameters.parametros.forEach(function (item) {
                var objparam = {
                    chave: item.chave,
                    valor: item.valor
                };
                // datainicial e datafinal, buscar version e id na alteracao
                if (_this.objAgendamentoEdit
                    && _this.objAgendamentoEdit.processos
                    && _this.objAgendamentoEdit.processos.length
                    && _this.objAgendamentoEdit.processos[0].parametros) {
                    _this.objAgendamentoEdit.processos[0].parametros.forEach(function (itemEdit) {
                        if (item.chave == itemEdit.chave) {
                            objparam.id = itemEdit.id;
                            objparam.version = itemEdit.version;
                        }
                    });
                }
                parametros.push(objparam);
            });
        }
        var processoEnviar = {
            ordemExecucao: 0,
            processo: 0,
            parametros: parametros,
            codigoAplicacao: (this.objAgendamentoEdit ? this.objAgendamentoEdit.aplicacao.codigo : this.codigoApp),
            versaoAplicacao: (this.objAgendamentoEdit ? this.objAgendamentoEdit.aplicacao.versao.versao : this.versaoApp),
            fromEditar: fromEditar,
            objAgendamentoEdit: this.objAgendamentoEdit
        };
        this._sharedService.setLocalStorage(_projectLocalStorage, 'scheduling-report', processoEnviar, true);
    };
    ReportComponent.prototype.clearForm = function () {
        // this.parameters = [];
        this.buttonDisable = false;
        this.showExecuteResult = false;
        this.showScheduleResult = false;
    };
    ReportComponent.prototype.ngOnDestroy = function () {
        this._sharedService.clearLocalStorage(_projectLocalStorage + 'scheduling-report');
    };
    ReportComponent.prototype.getAgendamentoReport = function (agendamento, codReport) {
        this.codAgendamentoToEdit = agendamento;
        this.dataSource = '/sabium/api/relatorio/' + codReport;
    };
    ReportComponent.prototype.getAgendamento = function () {
        var _this = this;
        this._req.xhrGet("/sabium/api/agendamento/" + this.codAgendamentoToEdit).subscribe(function (ret) {
            // console.log('ret get agendamento', ret);
            // console.log(this.process);
            // console.log('ret get agendamento', ret);
            // console.log(this.process);
            _this.objAgendamentoEdit = ret.res;
            var buscaTipo;
            var buscaValor;
            _this.process.parameters.parametros.map(function (item) {
                buscaTipo = _this.parameters.filter(function (item2) {
                    if (item2.nome == item.chave) {
                        return item2;
                    }
                });
                buscaValor = ret.res.processos[0].parametros.filter(function (itemRet) {
                    if (item.chave == itemRet.chave) {
                        return itemRet;
                    }
                });
                if (buscaValor && buscaValor.length && buscaTipo && buscaTipo.length) {
                    item.valor = buscaValor[0].valor;
                    _this.parametersComp.modelParameter[item.chave] = item.valor;
                }
            });
            _this.parametersComp.blurParametro();
            _this.openSchedule(true);
        }, function (err) {
            console.log(err);
        });
    };
    ReportComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'sbm-report',
                    template: require('./report.component.html'),

                    styles: [require('./report.component.css')],
               },] },
    ];
    /** @nocollapse */
    ReportComponent.ctorParameters = function () { return [
        { type: req_http_service_1.ReqHttpService, },
        { type: sharedService_1.SharedService, },
    ]; };
    ReportComponent.propDecorators = {
        "dataSource": [{ type: core_1.Input },],
        "reportParameters": [{ type: core_1.ViewChild, args: [parameters_component_1.ParametersComponent,] },],
        "parametersComp": [{ type: core_1.ViewChild, args: ['parametersComp',] },],
        "codigoApp": [{ type: core_1.Input },],
        "versaoApp": [{ type: core_1.Input },],
        "reportVisible": [{ type: core_1.Input },],
    };
    return ReportComponent;
}());
exports.ReportComponent = ReportComponent;
