"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var notification_component_1 = require("../notification/notification.component");
var ScheduleTimesComponent = /** @class */ (function () {
    function ScheduleTimesComponent() {
        this.saveScheduleButton = false;
        this.dbEnumType = DateboxEnumType.date;
        // select de tipo de horários
        this.colSchedule = [
            { 'id': 1, 'display': 'Mensal' },
            { 'id': 2, 'display': 'Semanal' },
            { 'id': 3, 'display': 'Temporal' },
            { 'id': 4, 'display': 'Uma Vez' },
        ];
        this.radioDaysMonth = [
            { 'id': 0, 'display': 'Primeiro dia do mês' },
            { 'id': 1, 'display': '1' },
            { 'id': 2, 'display': '2' },
            { 'id': 3, 'display': '3' },
            { 'id': 4, 'display': '4' },
            { 'id': 5, 'display': '5' },
            { 'id': 6, 'display': '6' },
            { 'id': 7, 'display': '7' },
            { 'id': 8, 'display': '8' },
            { 'id': 9, 'display': '9' },
            { 'id': 10, 'display': '10' },
            { 'id': 11, 'display': '11' },
            { 'id': 12, 'display': '12' },
            { 'id': 13, 'display': '13' },
            { 'id': 14, 'display': '14' },
            { 'id': 15, 'display': '15' },
            { 'id': 16, 'display': '16' },
            { 'id': 17, 'display': '17' },
            { 'id': 18, 'display': '18' },
            { 'id': 19, 'display': '19' },
            { 'id': 20, 'display': '20' },
            { 'id': 21, 'display': '21' },
            { 'id': 22, 'display': '22' },
            { 'id': 23, 'display': '23' },
            { 'id': 24, 'display': '24' },
            { 'id': 25, 'display': '25' },
            { 'id': 26, 'display': '26' },
            { 'id': 27, 'display': '27' },
            { 'id': 28, 'display': '28' },
            { 'id': 29, 'display': '29' },
            { 'id': 30, 'display': '30' },
            { 'id': 31, 'display': '31' },
            { 'id': -1, 'display': 'Ultimo dia do mês' }
        ];
        // colunas de dias da semana
        this.colDays = [
            { 'id': 1, 'display': 'Segunda-feira', value: 'SEGUNDA' },
            { 'id': 2, 'display': 'Terça-feira', value: 'TERCA' },
            { 'id': 3, 'display': 'Quarta-feira', value: 'QUARTA' },
            { 'id': 4, 'display': 'Quinta-feira', value: 'QUINTA' },
            { 'id': 5, 'display': 'Sexta-feira', value: 'SEXTA' },
            { 'id': 6, 'display': 'Sábado', value: 'SABADO' },
            { 'id': 7, 'display': 'Domingo', value: 'DOMINGO' },
        ];
        this.colTemporal = [
            { 'id': 1, 'display': 'Hora(s)', value: 'HORAS' },
            { 'id': 2, 'display': 'Minuto(s)', value: 'MINUTOS' },
            { 'id': 3, 'display': 'Segundo(s)', value: 'SEGUNDOS' },
        ];
        // objeto a ser retornado com os valores de inclusão de horarios
        this.schedule = {};
        this.diasSemana = [];
        this.data = {
            day: '',
            hours: '',
            minutes: '',
            seconds: '',
            typeTemporal: '',
            timeSchedule: ''
        };
        this.dateInitialEnd = {};
        this.selectedSchedule = 0;
        this.escondeDataFinal = false;
    }
    ScheduleTimesComponent.prototype.ngOnInit = function () {
    };
    ScheduleTimesComponent.prototype.clearForm = function () {
        this.schedule = {};
        this.data = {
            day: '',
            hours: '',
            minutes: '',
            seconds: '',
            typeTemporal: '',
            timeSchedule: ''
        };
        this._dataInicial = '';
        this._dataFinal = '';
        this._repeticao = false;
        this.selectedSchedule = 0;
        this.scheduleMonthly = {};
        this.dateInitialEnd = {};
        this.escondeDataFinal = false;
    };
    ScheduleTimesComponent.prototype.radioSelectDayMonth = function (data) {
        if (data.id == 1) {
            this.scheduleMonthly.firstDay = true;
        }
        else if (data.id == 2) {
            this.scheduleMonthly.lastDay = true;
        }
    };
    ScheduleTimesComponent.prototype.firstDate = function (data) {
        this.dateInitialEnd['dataInicio'] = data[0];
        this.dateInitialEnd['dataFim'] = data[1];
        this.verifDate();
    };
    ScheduleTimesComponent.prototype.lastDate = function (data) {
        this.dateInitialEnd['dataFim'] = data;
        this.verifDate();
    };
    ScheduleTimesComponent.prototype.verifDate = function () {
        if (this.dateInitialEnd['dataInicio'] && this.dateInitialEnd['dataFim']) {
            var init = new Date(this.dateInitialEnd.dataInicio.replace(/\-/g, '\/').replace(/[T|Z]/g, ' '));
            var end = new Date(this.dateInitialEnd.dataFim.replace(/\-/g, '\/').replace(/[T|Z]/g, ' '));
            if (init.getTime() > end.getTime()) {
                var alert_1 = new notification_component_1.NotificationComponent();
                alert_1.show('A data final não pode ser menor que a data inicial');
            }
        }
    };
    ScheduleTimesComponent.prototype.selectTimeSchedule = function (data) {
        this.data['timeSchedule'] = data.display;
    };
    ScheduleTimesComponent.prototype.selectTemporal = function (data) {
        this.data['typeTemporal'] = data.value;
    };
    ScheduleTimesComponent.prototype.selectRepetition = function (data) {
        this.selectedSchedule = data.id;
        this.schedule = {};
        if (data.id == 4) {
            // 'Uma Vez'
            this.escondeDataFinal = true;
        }
        else {
            this.escondeDataFinal = false;
        }
    };
    /*clickDaySchedule(days) {
      this.schedule['diasSemana'] = [];
      for (let item of days) {
        this.schedule.diasSemana.push(item.value);
      }
    }*/
    /*clickDaySchedule(days) {
          this.schedule['diasSemana'] = [];
          for (let item of days) {
            this.schedule.diasSemana.push(item.value);
          }
        }*/
    ScheduleTimesComponent.prototype.sendSchedule = /*clickDaySchedule(days) {
          this.schedule['diasSemana'] = [];
          for (let item of days) {
            this.schedule.diasSemana.push(item.value);
          }
        }*/
    function (data) {
        var obj = {
            data: data,
            type: this.selectedSchedule
        };
        // this.dialog.close(obj);
        ScheduleTimesComponent.onFormSubmit.emit(obj);
        this.clearForm();
    };
    // pega alteração do template
    // pega alteração do template
    ScheduleTimesComponent.prototype.ngAfterContentChecked = 
    // pega alteração do template
    function () {
        this.verifDate();
        if (this.dateInitialEnd.dataInicio && this.dateInitialEnd.dataFim || this.dateInitialEnd.dataInicio && this.selectedSchedule == 4) {
            this.schedule['dataInicio'] = this.dateInitialEnd.dataInicio;
            this.schedule['dataFim'] = this.dateInitialEnd.dataFim;
            // tipo de repetição (1:mensal; 2:semanal; 3:temporal)
            switch (this.selectedSchedule) {
                case 1:
                    if (this.scheduleMonthly !== undefined) {
                        if (typeof this.data.hours != 'string' &&
                            typeof this.data.minutes != 'string' &&
                            typeof this.data.seconds != 'string') {
                            if (this.scheduleMonthly == 0) {
                                this.schedule['tipoPeriodo'] = 'PRIMEIRO_DIA';
                                this.schedule['hora'] = this.data.hours;
                                this.schedule['minuto'] = this.data.minutes;
                                this.schedule['segundo'] = this.data.seconds;
                                this.saveScheduleButton = true;
                            }
                            else if (this.scheduleMonthly == -1) {
                                this.schedule['tipoPeriodo'] = 'ULTIMO_DIA_MES';
                                this.schedule['hora'] = this.data.hours;
                                this.schedule['minuto'] = this.data.minutes;
                                this.schedule['segundo'] = this.data.seconds;
                                this.saveScheduleButton = true;
                            }
                            else {
                                this.schedule['tipoPeriodo'] = 'DIA_FIXO';
                                this.schedule['dia'] = this.scheduleMonthly;
                                this.schedule['hora'] = this.data.hours;
                                this.schedule['minuto'] = this.data.minutes;
                                this.schedule['segundo'] = this.data.seconds;
                                this.saveScheduleButton = true;
                            }
                        }
                        else {
                            this.saveScheduleButton = false;
                        }
                    }
                    break;
                case 2:
                    if (typeof this.data.hours != 'string' &&
                        typeof this.data.minutes != 'string' &&
                        typeof this.data.seconds != 'string') {
                        this.schedule['hora'] = this.data.hours;
                        this.schedule['minuto'] = this.data.minutes;
                        this.schedule['segundo'] = this.data.seconds;
                        this.schedule['diasSemana'] = this.diasSemana;
                        this.saveScheduleButton = true;
                    }
                    else {
                        this.saveScheduleButton = false;
                    }
                    break;
                case 3:
                    if (this.data.timeSchedule != '' &&
                        this.data.typeTemporal != '') {
                        this.schedule['tipoIntervalo'] = this.data.typeTemporal;
                        this.schedule['intervalo'] = this.data.timeSchedule;
                        this.saveScheduleButton = true;
                    }
                    else {
                        this.saveScheduleButton = false;
                    }
                    break;
                case 4:
                    this.schedule = {};
                    if (typeof this.data.hours != 'string' &&
                        typeof this.data.minutes != 'string' &&
                        typeof this.data.seconds != 'string') {
                        this.schedule['hora'] = this.data.hours;
                        this.schedule['minuto'] = this.data.minutes;
                        this.schedule['segundo'] = this.data.seconds;
                        this.schedule['dataInicio'] = this.dateInitialEnd.dataInicio;
                        this.saveScheduleButton = true;
                    }
                    else {
                        this.saveScheduleButton = false;
                    }
                    break;
            }
        }
        else {
            this.saveScheduleButton = false;
        }
    };
    ScheduleTimesComponent.onFormSubmit = new core_1.EventEmitter();
    ScheduleTimesComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'sbm-schedule-times',
                    template: require('./schedule-times.component.html'),

                    styles: [require('./schedule-times.component.css')],
               },] },
    ];
    /** @nocollapse */
    ScheduleTimesComponent.ctorParameters = function () { return []; };
    return ScheduleTimesComponent;
}());
exports.ScheduleTimesComponent = ScheduleTimesComponent;
exports.DateboxConstDisplayFormat = {
    date: 'yyyy/M/d',
    time: 'HH:mm',
    datetime: 'dd/MM/yyyy HH:mm:ss'
};
var DateboxEnumType;
(function (DateboxEnumType) {
    DateboxEnumType[DateboxEnumType["date"] = 0] = "date";
    DateboxEnumType[DateboxEnumType["time"] = 1] = "time";
    DateboxEnumType[DateboxEnumType["datetime"] = 2] = "datetime";
})(DateboxEnumType = exports.DateboxEnumType || (exports.DateboxEnumType = {}));
