"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var schedule_process_component_1 = require("./schedule-process.component");
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var req_http_service_1 = require("../../services/req-http.service");
var tabs_component_1 = require("../tabs/tabs.component");
var tab_component_1 = require("../tabs/tab.component");
var schedule_times_component_1 = require("./schedule-times.component");
var notification_component_1 = require("../notification/notification.component");
var sharedService_1 = require("../../models/sharedService");
var checkbox_component_1 = require("../checkbox/checkbox.component");
var multiselect_component_1 = require("../multiselect/multiselect.component");
var SchedulingComponent = /** @class */ (function () {
    function SchedulingComponent(fb, _http, _sharedService) {
        this.fb = fb;
        this._http = _http;
        this._sharedService = _sharedService;
        this.isReport = false;
        this.showAgendamento = false;
        this.colProcessos = [];
        this.emailsSucesso = [];
        this.emailsFalha = [];
        this.schedulingServer = [
            {
                execucoesUnicas: [],
                periodosMensais: [],
                periodosSemanais: [
                    {
                        dataInicio: '2017-07-31T12:18:37.374Z',
                        dataFim: '2017-09-09T12:18:37.402Z',
                        hora: 12,
                        minuto: 30,
                        segundo: 10,
                        diasSemana: [
                            'TERCA',
                            'QUINTA',
                            'SEXTA'
                        ]
                    }
                ],
                periodosTemporais: [],
                processos: [
                    {
                        codigo: 'PROC1',
                        parametros: [
                            {
                                nome: 'filial',
                                valor: 1,
                                codigo: 'PAR1'
                            },
                            {
                                nome: 'usuario',
                                valor: 1,
                                codigo: 'PAR2'
                            }
                        ],
                        ordemExecucao: 1
                    }
                ],
                codigo: '34354',
                descricao: 'teste',
                usuarioExecucao: 'jose.silva',
                quantidadeTentativasExecucao: 2,
                emailsSucesso: [
                    'teste'
                ],
                emailsFalha: [
                    'teste'
                ]
            }
        ];
        this.processResult = [];
        this.processesValid = false;
        this.timesValid = false;
        this.scheduleValid = false;
        this.schedules = {
            execucoesUnicas: [],
            periodosMensais: [],
            periodosSemanais: [],
            periodosTemporais: [],
            processos: []
        };
        this.ativo = false;
        this.withShadingOptionsVisible = false;
        this.btn_salvar = '';
        this.bloqBotao = false;
        this.form = this.fb.group({
            'descricao': [null, forms_1.Validators.required],
            'quantidadeTentativasExecucao': [null, forms_1.Validators.required],
            'emailsSucesso': [[]],
            'emailsFalha': [[]],
            'ativo': [false],
        });
        this.btn_salvar = 'Salvar agendamento';
    }
    SchedulingComponent.prototype.saveSchedule = function () {
        var _this = this;
        this.scheduleValid = false;
        this.btn_salvar = 'Aguarde';
        this.bloqBotao = true;
        this.schedules.processos = [];
        var processosAgendamento = null;
        if (this._sharedService.getLocalStorage(_projectLocalStorage, 'scheduling-report', true)) {
            processosAgendamento = this._sharedService.getLocalStorage(_projectLocalStorage, 'scheduling-report', true);
        }
        else if (this._sharedService.getLocalStorage(_projectLocalStorage, 'process-local', true)) {
            processosAgendamento = this._sharedService.getLocalStorage(_projectLocalStorage, 'process-local', true);
        }
        if (processosAgendamento.objAgendamentoEdit && processosAgendamento.objAgendamentoEdit.id) {
            this.schedules.id = processosAgendamento.objAgendamentoEdit.id;
        }
        if (processosAgendamento.objAgendamentoEdit && processosAgendamento.objAgendamentoEdit.version) {
            this.schedules.version = processosAgendamento.objAgendamentoEdit.version;
        }
        if (processosAgendamento != null) {
            var obj = {
                ordemExecucao: processosAgendamento.ordemExecucao,
                processo: processosAgendamento.processo,
                parametros: processosAgendamento.parametros
            };
            if (processosAgendamento.objAgendamentoEdit && processosAgendamento.objAgendamentoEdit.processos) {
                obj.id = processosAgendamento.objAgendamentoEdit.processos[0].id;
                obj.version = processosAgendamento.objAgendamentoEdit.processos[0].version;
            }
            this.schedules.codigoAplicacao = processosAgendamento.codigoAplicacao;
            this.schedules.versaoAplicacao = processosAgendamento.versaoAplicacao;
            this.schedules.processos.push(obj);
        }
        // se apagar dá erro ao agendar na segunda vez, por isso não pode apagar
        // this._sharedService.clearLocalStorage(_projectLocalStorage + 'scheduling-report');
        // this._sharedService.clearLocalStorage(_projectLocalStorage + 'process-local');
        var arrayEmailFalha = [];
        var arrayEmailSucesso = [];
        this.form.value.emailsFalha.map(function (item) {
            arrayEmailFalha.push(item);
        });
        this.form.value.emailsSucesso.map(function (item) {
            arrayEmailSucesso.push(item);
        });
        this.form.value.emailsFalha = arrayEmailFalha;
        this.form.value.emailsSucesso = arrayEmailSucesso;
        // this.schedules.version = null;
        var dados = Object.assign(this.schedules, this.form.value);
        this._http.xhrPost(this.isReport ? '/sabium/api/agendamento/relatorio' : '/sabium/api/agendamento', [dados]).subscribe(function (ret) {
            _this.scheduleValid = true;
            if (ret) {
                var notification = new notification_component_1.NotificationComponent();
                notification.show('Agendamento salvo com sucesso.');
                _this.tabs.selectTab(_this.tabAgendamento);
                _this.iniciar();
            }
        }, function (err) {
            var notification = new notification_component_1.NotificationComponent();
            notification.show('Erro ao tentar agendar processo.');
            _this.btn_salvar = 'Salvar agendamento';
            _this.bloqBotao = false;
        });
    };
    SchedulingComponent.prototype.subscribeTimesFormSubmit = function () {
        var _this = this;
        this.timesFormSubmitSubscribe = schedule_times_component_1.ScheduleTimesComponent.onFormSubmit.subscribe(function (v) {
            if (v) {
                switch (v.type) {
                    case 1:
                        _this.schedules['periodosMensais'].push(v.data);
                        break;
                    case 2:
                        _this.schedules['periodosSemanais'].push(v.data);
                        break;
                    case 3:
                        _this.schedules['periodosTemporais'].push(v.data);
                        break;
                    case 4:
                        _this.schedules['execucoesUnicas'].push(v.data);
                        break;
                }
                // localStorage.setItem('__schedulesLocal', JSON.stringify(this.schedules));
                // localStorage.setItem('__schedulesLocal', JSON.stringify(this.schedules));
                _this.timesValid = true;
            }
        });
    };
    SchedulingComponent.prototype.subscribeProcessFormSubmit = function () {
        var _this = this;
        this.processFormSubmitSubscribe = schedule_process_component_1.ScheduleProcessComponent.onFormSubmit.subscribe(function (v) {
            if (v) {
                _this.processResult.push(v);
                _this.orderExecution(_this.processResult);
                // this.schedules.processos.push(result);
                // this.schedules.processos.push(result);
                _this._sharedService.setLocalStorage(_projectLocalStorage, 'process-local', _this.schedules.processos, true);
                _this.processesValid = true;
            }
        });
    };
    SchedulingComponent.prototype.ngAfterViewInit = function () {
        this.subscribeTimesFormSubmit();
        this.subscribeProcessFormSubmit();
        this.buscaAgendamentoEdit();
    };
    SchedulingComponent.prototype.buscaAgendamentoEdit = function () {
        var agendamentoReport = this._sharedService.getLocalStorage(_projectLocalStorage, 'scheduling-report', true);
        var agendamentoProcess = this._sharedService.getLocalStorage(_projectLocalStorage, 'process-local', true);
        // console.log('agendamentoReport:', agendamentoReport);
        // console.log('agendamentoProcess:', agendamentoProcess);
        if (agendamentoReport && agendamentoReport.objAgendamentoEdit && agendamentoReport.fromEditar == true) {
            this.carregaAgendamentoEdit(agendamentoReport.objAgendamentoEdit);
        }
        else if (agendamentoProcess && agendamentoProcess.objAgendamentoEdit && agendamentoProcess.fromEditar == true) {
            this.carregaAgendamentoEdit(agendamentoProcess.objAgendamentoEdit);
        }
    };
    SchedulingComponent.prototype.carregaAgendamentoEdit = function (scheduling) {
        var _this = this;
        this.form.controls['descricao'].setValue(scheduling.descricao);
        this.form.controls['quantidadeTentativasExecucao'].setValue(scheduling.quantidadeTentativasExecucao);
        this.form.controls['emailsSucesso'].setValue(scheduling.emailsSucesso);
        this.form.controls['emailsFalha'].setValue(scheduling.emailsFalha);
        this.form.controls['ativo'].setValue(scheduling.ativo);
        this.ativo = scheduling.ativo;
        this.checkbox.indeterminate = false;
        scheduling.emailsSucesso.forEach(function (item) {
            var obj = {
                input: null,
                value: item
            };
            _this.multiselectsucesso.addObject(obj);
        });
        scheduling.emailsFalha.forEach(function (item) {
            var obj = {
                input: null,
                value: item
            };
            _this.multiselectfalha.addObject(obj);
        });
        // Execução unica
        if (scheduling.execucoesUnicas && scheduling.execucoesUnicas.length) {
            scheduling.execucoesUnicas.forEach(function (item) {
                _this.schedules['execucoesUnicas'].push({
                    dataInicio: new Date(item.dataInicio),
                    hora: item.horarioExecucao.hora,
                    minuto: item.horarioExecucao.minuto,
                    segundo: item.horarioExecucao.segundo,
                    id: item.id,
                    version: item.version
                });
                _this.timesValid = true;
            });
        }
        // Periodos Semanais
        if (scheduling.periodosSemanais && scheduling.periodosSemanais.length) {
            scheduling.periodosSemanais.forEach(function (item) {
                _this.schedules['periodosSemanais'].push({
                    dataFim: new Date(item.dataFim),
                    // new Date(1512612000000)
                    dataInicio: new Date(item.dataInicio),
                    diasSemana: item.diasSemana,
                    hora: item.horarioExecucao.hora,
                    minuto: item.horarioExecucao.minuto,
                    segundo: item.horarioExecucao.segundo,
                    id: item.id,
                    version: item.version
                });
                _this.timesValid = true;
            });
        }
        // Periodos Mensais
        if (scheduling.periodosMensais && scheduling.periodosMensais.length) {
            scheduling.periodosMensais.forEach(function (item) {
                _this.schedules['periodosMensais'].push({
                    dataFim: new Date(item.dataFim),
                    // new Date(1512612000000)
                    dataInicio: new Date(item.dataInicio),
                    hora: item.horarioExecucao.hora,
                    minuto: item.horarioExecucao.minuto,
                    segundo: item.horarioExecucao.segundo,
                    tipoPeriodo: item.tipoPeriodo,
                    id: item.id,
                    version: item.version
                });
                _this.timesValid = true;
            });
        }
        // Periodos temporais
        if (scheduling.periodosTemporais && scheduling.periodosTemporais.length) {
            scheduling.periodosTemporais.forEach(function (item) {
                _this.schedules['periodosTemporais'].push({
                    dataFim: new Date(item.dataFim),
                    // new Date(1512612000000)
                    dataInicio: new Date(item.dataInicio),
                    intervalo: item.intervalo,
                    tipoIntervalo: item.tipoIntervalo,
                    id: item.id,
                    version: item.version
                });
                _this.timesValid = true;
            });
        }
    };
    SchedulingComponent.prototype.orderExecution = function (data) {
        var _this = this;
        this.schedules.processos = [];
        data.map(function (ret, i) {
            var result = {
                processo: ret.processo,
                codigo: ret.codigo,
                parametros: ret.parameters.parametros,
                ordemExecucao: i + 1
            };
            _this.schedules.processos.push(result);
        });
    };
    SchedulingComponent.prototype.changeOrderProcess = function (data, process) {
        var _this = this;
        if (data && process) {
            this.schedules.processos.map(function (v, i) {
                if (v.codigo == process.codigo) {
                    _this.schedules.processos[i].ordemExecucao = parseInt(data);
                }
            });
        }
    };
    SchedulingComponent.prototype.clickActive = function (data) {
        this.ativo = data;
    };
    SchedulingComponent.prototype.toggleWithShadingOptions = function () {
        this.withShadingOptionsVisible = !this.withShadingOptionsVisible;
    };
    SchedulingComponent.prototype.openSchedule = function () {
        if (this.scheduleValid) {
            this.tabs.selectTab(this.tabHorarios);
        }
    };
    /*openProcess() {
      if (this.scheduleValid) {
        this.tabs.selectTab(this.tabProcessos);
      }
    }*/
    /*openProcess() {
          if (this.scheduleValid) {
            this.tabs.selectTab(this.tabProcessos);
          }
        }*/
    SchedulingComponent.prototype.removeProcess = /*openProcess() {
          if (this.scheduleValid) {
            this.tabs.selectTab(this.tabProcessos);
          }
        }*/
    function (data) {
        var _this = this;
        this.schedules.processos.map(function (v, i) {
            if (v.ordemExecucao == data.ordemExecucao) {
                _this.processResult.splice(i, 1);
                _this.schedules.processos.splice(i, 1);
                _this.orderExecution(_this.processResult);
                _this._sharedService.setLocalStorage(_projectLocalStorage, 'process-local', _this.processResult, true);
                if (_this.schedules.processos.length == 0) {
                    _this.processesValid = false;
                }
            }
        });
    };
    SchedulingComponent.prototype.removeSchedulesMounth = function (data) {
        var _this = this;
        this.schedules.periodosMensais.map(function (v, i) {
            if (v.valueOf() == data.valueOf()) {
                _this.schedules.periodosMensais.splice(i, 1);
                // localStorage.setItem('__schedulesLocal', JSON.stringify(this.schedules));
            }
        });
    };
    SchedulingComponent.prototype.removeSchedulesWeek = function (data) {
        var _this = this;
        this.schedules.periodosSemanais.map(function (v, i) {
            if (v.valueOf() == data.valueOf()) {
                _this.schedules.periodosSemanais.splice(i, 1);
                // localStorage.setItem('__schedulesLocal', JSON.stringify(this.schedules));
            }
        });
    };
    SchedulingComponent.prototype.removeSchedulesTemporary = function (data) {
        var _this = this;
        this.schedules.periodosTemporais.map(function (v, i) {
            if (v.valueOf() == data.valueOf()) {
                _this.schedules.periodosTemporais.splice(i, 1);
                // localStorage.setItem('__schedulesLocal', JSON.stringify(this.schedules));
            }
        });
    };
    SchedulingComponent.prototype.removeSchedulesOnly = function (data) {
        var _this = this;
        this.schedules.execucoesUnicas.map(function (v, i) {
            if (v.valueOf() == data.valueOf()) {
                _this.schedules.execucoesUnicas.splice(i, 1);
                // localStorage.setItem('__schedulesLocal', JSON.stringify(this.schedules));
            }
        });
    };
    SchedulingComponent.prototype.ngOnInit = function () {
        this.colProcessos.push(JSON.parse(localStorage.getItem('new-processo')));
    };
    SchedulingComponent.prototype.ngAfterContentChecked = function () {
        if (this.form.value.emailsSucesso && this.form.value.emailsSucesso.length > 0 &&
            this.form.value.emailsFalha && this.form.value.emailsFalha.length > 0 &&
            this.form.value.quantidadeTentativasExecucao != '') {
            this.scheduleValid = true;
        }
        else {
            this.scheduleValid = false;
        }
    };
    SchedulingComponent.prototype.iniciar = function () {
        this.form.reset();
        this.multiselectvalue = '';
        this.multiselectvalue2 = '';
        this.ativo = false;
        this.schedules.execucoesUnicas = [];
        this.schedules.periodosMensais = [];
        this.schedules.periodosSemanais = [];
        this.schedules.periodosTemporais = [];
        this.schedules.processos = [];
        this.btn_salvar = 'Salvar agendamento';
        this.bloqBotao = false;
    };
    SchedulingComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'sbm-scheduling',
                    template: require('./scheduling.component.html'),

                    styles: [require('./scheduling.component.css')],
               },] },
    ];
    /** @nocollapse */
    SchedulingComponent.ctorParameters = function () { return [
        { type: forms_1.FormBuilder, },
        { type: req_http_service_1.ReqHttpService, },
        { type: sharedService_1.SharedService, },
    ]; };
    SchedulingComponent.propDecorators = {
        "isReport": [{ type: core_1.Input, args: ['isreport',] },],
        "showAgendamento": [{ type: core_1.Input },],
        "tabs": [{ type: core_1.ViewChild, args: ['tabs',] },],
        "tabAgendamento": [{ type: core_1.ViewChild, args: ['tabAgendamento',] },],
        "tabProcessos": [{ type: core_1.ViewChild, args: ['tabProcessos',] },],
        "tabHorarios": [{ type: core_1.ViewChild, args: ['tabHorarios',] },],
        "multiselectsucesso": [{ type: core_1.ViewChild, args: ['multiselectsucesso',] },],
        "multiselectfalha": [{ type: core_1.ViewChild, args: ['multiselectfalha',] },],
        "checkbox": [{ type: core_1.ViewChild, args: ['checkbox',] },],
    };
    return SchedulingComponent;
}());
exports.SchedulingComponent = SchedulingComponent;
