"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var layout_1 = require("@angular/cdk/layout");
var material_1 = require("@angular/material");
var tabs_chrome_componente_1 = require("../tabs/tabs-chrome.component/tabs-chrome.componente");
var SidenavComponent = /** @class */ (function () {
    function SidenavComponent(changeDetectorRef, media) {
        this.disableClose = false;
        this.width = "30%";
        this.height = "auto";
        this.tooltip = "Abrir/Fechar";
        this.minHeight = "400px";
        this.btnOpen = true;
        this.mode = "side";
        this.iconBtnClose = "keyboard_arrow_left";
        this._opened = false;
        this.mobileQuery = media.matchMedia("(max-width: 600px)");
        this._mobileQueryListener = function () { return changeDetectorRef.detectChanges(); };
        this.mobileQuery.addListener(this._mobileQueryListener);
    }
    Object.defineProperty(SidenavComponent.prototype, "opened", {
        get: function () {
            return this._opened;
        },
        set: function (val) {
            this._opened = val;
            if (val) {
                this.iconBtnClose = "keyboard_arrow_left";
            }
            else {
                this.iconBtnClose = "keyboard_arrow_right";
            }
        },
        enumerable: true,
        configurable: true
    });
    SidenavComponent.prototype.toggle = function () {
        this.opened = !this.opened;
    };
    SidenavComponent.prototype.open = function () {
        this.opened = true;
    };
    SidenavComponent.prototype.close = function () {
        this.opened = false;
    };
    SidenavComponent.prototype.swipeLeft = function (ev) {
        if (ev.distance >= 40) {
            this.close();
        }
    };
    SidenavComponent.prototype.swipeRight = function (ev) {
        if (ev.distance >= 40) {
            this.open();
        }
    };
    SidenavComponent.prototype.ngOnInit = function () {
        var _this = this;
        tabs_chrome_componente_1.TabsChromeComponent.tabChange.subscribe(function (ret) {
            _this.toggle();
            setTimeout(function () {
                _this.toggle();
            });
        });
    };
    SidenavComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        this.toggle();
        setTimeout(function () {
            _this.toggle();
        });
        // this.sideContainer['start'].openedChange.subscribe((retOpened) => {
        // if(retOpened) {
        //     setTimeout(() => {
        //         this.toggle();
        //     });
        // }
        // })
    };
    SidenavComponent.prototype.ngOnDestroy = function () {
        this.mobileQuery.removeListener(this._mobileQueryListener);
    };
    SidenavComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: "sbm-sidenav",
                    template: require('./sidenav.component.html'),

                    styles: [require('./sidenav.component.css')],
                    host: {
                        "class": "col l12 m12 s12"
                    },
                },] },
    ];
    /** @nocollapse */
    SidenavComponent.ctorParameters = function () { return [
        { type: core_1.ChangeDetectorRef, },
        { type: layout_1.MediaMatcher, },
    ]; };
    SidenavComponent.propDecorators = {
        "sidenav": [{ type: core_1.ViewChild, args: ["sidenav",] },],
        "sidenavContent": [{ type: core_1.ViewChild, args: ["sidenavContent",] },],
        "sideContainer": [{ type: core_1.ViewChild, args: ["sideContainer",] },],
        "disableClose": [{ type: core_1.Input, args: ["disableclose",] },],
        "width": [{ type: core_1.Input },],
        "height": [{ type: core_1.Input },],
        "tooltip": [{ type: core_1.Input },],
        "minHeight": [{ type: core_1.Input, args: ["min-height",] },],
        "btnOpen": [{ type: core_1.Input, args: ["btnopen",] },],
        "mode": [{ type: core_1.Input },],
        "opened": [{ type: core_1.Input },],
    };
    return SidenavComponent;
}());
exports.SidenavComponent = SidenavComponent;
