"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var forms_1 = require("@angular/forms");
var http_1 = require("@angular/http");
var devextreme_angular_1 = require("devextreme-angular");
var sbm_module_1 = require("../../../sbm-module/sbm.module");
var ng2_currency_mask_1 = require("ng2-currency-mask");
var ngx_webstorage_1 = require("ngx-webstorage");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../../models/sharedService");
var TabGenericComponent = /** @class */ (function () {
    function TabGenericComponent(compiler, _http, _vcref, _sharedService) {
        this.compiler = compiler;
        this._http = _http;
        this._vcref = _vcref;
        this._sharedService = _sharedService;
        this.id = '';
        this.hidden = false;
        this.openerId = '';
        this._isPath = false;
        this.ocultarCarregamento = false;
        this.modules = [
            common_1.CommonModule,
            forms_1.FormsModule,
            forms_1.ReactiveFormsModule,
            http_1.HttpModule,
            devextreme_angular_1.DevExtremeModule,
            sbm_module_1.SbmModule.forRoot(),
            ng2_currency_mask_1.CurrencyMaskModule,
            ngx_webstorage_1.Ng2Webstorage.forRoot({ prefix: '__SBM-SHARED__', separator: '/' }),
            core_2.TranslateModule.forRoot()
        ];
        this.compDinamic = [];
        SbmTabGenericComponent.push(this);
        SbmTabsComponent.push(this);
    }
    Object.defineProperty(TabGenericComponent.prototype, "isPath", {
        get: function () {
            return this._isPath;
        },
        set: function (val) {
            this._isPath = val;
        },
        enumerable: true,
        configurable: true
    });
    TabGenericComponent.prototype.createComponentFactorySync = function (compiler, metadata, componentClass) {
        var cmpClass = componentClass || /** @class */ (function () {
            function RuntimeComponent() {
            }
            return RuntimeComponent;
        }());
        var decoratedCmp = core_1.Component(metadata)(cmpClass);
        if (this.compDinamic.indexOf(decoratedCmp) === -1) {
            this.compDinamic.push(decoratedCmp);
            var self_1 = this;
            var TabRuntimeComponentModule = /** @class */ (function () {
                function TabRuntimeComponentModule() {
                }
                TabRuntimeComponentModule.decorators = [
                    { type: core_1.NgModule, args: [{
                                imports: self_1.modules,
                                declarations: self_1.compDinamic,
                                schemas: [core_1.CUSTOM_ELEMENTS_SCHEMA, core_1.NO_ERRORS_SCHEMA]
                            },] },
                ];
                /** @nocollapse */
                TabRuntimeComponentModule.ctorParameters = function () { return []; };
                return TabRuntimeComponentModule;
            }());
            var module_1 = compiler.compileModuleAndAllComponentsSync(TabRuntimeComponentModule);
            return module_1.componentFactories.find(function (f) { return f.componentType === decoratedCmp; });
        }
    };
    TabGenericComponent.prototype.compileTemplate = function (template) {
        var _this = this;
        if (this.isPath) {
            this._http.get(template + "?v=" + new Date().getTime()).subscribe(function (ret) {
                _this.ocultarCarregamento = true;
                _this.compileTemplateHtml(ret._body);
            });
        }
        else {
            this.ocultarCarregamento = true;
            this.compileTemplateHtml(template);
        }
    };
    TabGenericComponent.prototype.compileTemplateHtml = function (template) {
        var jsFilesUrls = [];
        var regex = /src=(["'])(.+\.js)\1/g;
        var matchJsUrls = regex.exec(template);
        while (matchJsUrls !== null) {
            jsFilesUrls.push(matchJsUrls[2]);
            matchJsUrls = regex.exec(template);
        }
        if (jsFilesUrls.length) {
            for (var i in jsFilesUrls) {
                var s = document.createElement('script');
                s.src = jsFilesUrls[i];
                document.getElementsByTagName('head')[0].appendChild(s);
            }
        }
        var metadata = {
            selector: "tab-runtime-app-principal",
            template: template
        };
        var factory = this.createComponentFactorySync(this.compiler, metadata, null);
        if (this.componentRef) {
            this.componentRef.destroy();
            this.componentRef = null;
        }
        this.componentRef = this.container.createComponent(factory);
    };
    TabGenericComponent.prototype.ngOnInit = function () {
    };
    TabGenericComponent.prototype.ngAfterViewInit = function () { };
    TabGenericComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'sbm-tab-generic',
                    template: require('./tab-generic.component.html'),

                    host: {
                        '[id]': 'id',
                        '[hidden]': 'hidden',
                    },
                    styles: [require('./tab-generic.component.css')],
               },] },
    ];
    /** @nocollapse */
    TabGenericComponent.ctorParameters = function () { return [
        { type: core_1.Compiler, },
        { type: http_1.Http, },
        { type: core_1.ViewContainerRef, },
        { type: sharedService_1.SharedService, },
    ]; };
    TabGenericComponent.propDecorators = {
        "tabErrorContainer": [{ type: core_1.ViewChild, args: ['tabErrorContainer', { read: core_1.ViewContainerRef },] },],
        "container": [{ type: core_1.ViewChild, args: ['container', { read: core_1.ViewContainerRef },] },],
    };
    return TabGenericComponent;
}());
exports.TabGenericComponent = TabGenericComponent;
