"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../models/sharedService");
var http_1 = require("@angular/http");
var TabComponent = /** @class */ (function (_super) {
    __extends(TabComponent, _super);
    function TabComponent(_viewContainerRef, _translateService, _http, _sharedService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._viewContainerRef = _viewContainerRef;
        _this._translateService = _translateService;
        _this._http = _http;
        _this._sharedService = _sharedService;
        _this.align = '';
        _this.halign = 'left';
        _this.valign = 'center';
        _this.hidden = false;
        return _this;
    }
    Object.defineProperty(TabComponent.prototype, "btnClose", {
        get: function () {
            return this._btnClose;
        },
        set: function (val) {
            if (val == 'true') {
                this._btnClose = true;
            }
            else {
                this._btnClose = false;
            }
        },
        enumerable: true,
        configurable: true
    });
    TabComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
        this.idGerenarated = abstract_ngmodel_1.AbstractNgModel.makeId();
        this.id = this.idGerenarated;
        SbmTabsComponent.push(this);
    };
    TabComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        $(document).ready(function () {
            if (_this.tabContainerRow !== undefined) {
                $(_this.tabContainerRow.nativeElement).css({
                    textAlign: _this.halign,
                    verticalAlign: (_this.valign == 'center') ? 'middle' : _this.valign,
                });
                var copyChildren = _this.tabContainerRow.nativeElement.children;
                for (var j = 0; j < copyChildren.length; j++) {
                    $(copyChildren[j]).css({
                        float: 'none',
                        display: 'inline-block',
                        fontSize: '15px',
                    });
                    if (_this.layout == 'vertical') {
                        $(copyChildren[j]).css({
                            margin: (_this.halign == 'center') ? '0 auto' : ((_this.halign == 'right') ? '0 0 0 auto' : '0 auto 0 0'),
                            display: 'block',
                        });
                    }
                }
            }
        });
    };
    TabComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'sbm-tab',
                    template: require('./tab.component.html'),

                    host: {
                        '[id]': "randomId",
                        '[hidden]': "!active"
                    },
                    styles: ["\n        .sbm-tab-container {\n            height: auto;\n            width: 100%;\n            display: table;\n            table-layout: fixed;\n        }\n\n        .sbm-tab-container-error-wrapper {\n            display: inline-block;\n            width: 100%;\n        }\n        \n        .sbm-tab-container-row-table {\n            display: table-cell;\n            width: 100%;\n        }        \n    "]
                },] },
    ];
    /** @nocollapse */
    TabComponent.ctorParameters = function () { return [
        { type: core_1.ViewContainerRef, },
        { type: core_2.TranslateService, },
        { type: http_1.Http, },
        { type: sharedService_1.SharedService, },
    ]; };
    TabComponent.propDecorators = {
        "align": [{ type: core_1.Input },],
        "icon": [{ type: core_1.Input },],
        "halign": [{ type: core_1.Input },],
        "valign": [{ type: core_1.Input },],
        "hidden": [{ type: core_1.Input },],
        "btnClose": [{ type: core_1.Input, args: ['btnclose',] },],
        "internalColumnTemplate": [{ type: core_1.ViewChild, args: ['internalColumnTemplate',] },],
        "tabContainer": [{ type: core_1.ViewChild, args: ['tabContainer',] },],
        "tabContainerRow": [{ type: core_1.ViewChild, args: ['tabContainerRow',] },],
        "tabErrorContainer": [{ type: core_1.ViewChild, args: ['tabErrorContainer', { read: core_1.ViewContainerRef },] },],
        "test": [{ type: core_1.ViewChild, args: ['internalColumnTemplate', { read: core_1.ViewContainerRef },] },],
    };
    return TabComponent;
}(abstract_ngmodel_1.AbstractNgModel));
exports.TabComponent = TabComponent;
