"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var sharedService_1 = require("../../models/sharedService");
var core_2 = require("@ngx-translate/core");
var http_1 = require("@angular/http");
var sbm_http_client_service_1 = require("../../services/sbm-http-client.service");
var timeline_container_component_1 = require("./timeline-container/timeline-container.component");
var TimelineComponent = /** @class */ (function (_super) {
    __extends(TimelineComponent, _super);
    function TimelineComponent(_shared, _tranlate, _http, _req) {
        var _this = _super.call(this, _shared, _tranlate, _http) || this;
        _this._req = _req;
        _this.displayTitle = "title";
        _this.displayDesc = "desc";
        _this.displayImg = "img";
        _this.displayEvent = "event";
        _this.height = "auto";
        _this.centered = false;
        return _this;
    }
    Object.defineProperty(TimelineComponent.prototype, "dataSource", {
        get: function () {
            return this._dataSource;
        },
        set: function (val) {
            if (typeof val == "string") {
                this.reqService(val);
            }
            else if (typeof val == "object") {
                this.data = val;
                this._dataSource = val;
            }
        },
        enumerable: true,
        configurable: true
    });
    TimelineComponent.prototype.reqService = function (url) {
        var _this = this;
        this._req.get("/" + _projectCodigo + "/api/" + url).subscribe(function (ret) {
            if (ret &&
                ret[_this.reqIndexKey] &&
                ret[_this.reqIndexKey].length) {
                _this.data = ret[_this.reqIndexKey];
            }
        }, function (err) { });
    };
    TimelineComponent.prototype.clickItem = function (event) {
        this._onClick.emit(event);
        if (this.onClick != "") {
            window[this.onClick](event);
        }
    };
    TimelineComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
    };
    TimelineComponent.prototype.ngAfterViewInit = function () { };
    TimelineComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'sbm-timeline',
                    template: require('./timeline.component.html'),

                    styles: [require('./timeline.component.css')],
                    host: {
                        "[class]": "columns"
                    }
                },] },
    ];
    /** @nocollapse */
    TimelineComponent.ctorParameters = function () { return [
        { type: sharedService_1.SharedService, },
        { type: core_2.TranslateService, },
        { type: http_1.Http, },
        { type: sbm_http_client_service_1.SbmHttpClientService, },
    ]; };
    TimelineComponent.propDecorators = {
        "timelineContainer": [{ type: core_1.ContentChildren, args: [timeline_container_component_1.TimelineContainerComponent,] },],
        "dataSource": [{ type: core_1.Input, args: ["datasource",] },],
        "displayTitle": [{ type: core_1.Input, args: ["displaytitle",] },],
        "displayDesc": [{ type: core_1.Input, args: ["displaydesc",] },],
        "displayImg": [{ type: core_1.Input, args: ["displayimg",] },],
        "displayEvent": [{ type: core_1.Input, args: ["displayevent",] },],
        "height": [{ type: core_1.Input },],
        "centered": [{ type: core_1.Input },],
    };
    return TimelineComponent;
}(abstract_ngmodel_1.AbstractNgModel));
exports.TimelineComponent = TimelineComponent;
