"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var sbm_http_client_service_1 = require("../../services/sbm-http-client.service");
var core_2 = require("@ngx-translate/core");
var http_1 = require("@angular/http");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var sharedService_1 = require("../../models/sharedService");
var devextreme_angular_1 = require("devextreme-angular");
var TreeviewComponent = /** @class */ (function (_super) {
    __extends(TreeviewComponent, _super);
    function TreeviewComponent(_service, _translateService, _http, _sharedService, elementRef) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._service = _service;
        _this._translateService = _translateService;
        _this._http = _http;
        _this._sharedService = _sharedService;
        _this.elementRef = elementRef;
        _this.items = [];
        _this.showCheckboxMode = "none";
        _this.children = "";
        _this.selectedKey = "";
        _this.selectNodesRecursivelly = true;
        _this.disabledKey = "";
        _this.expandedKey = "";
        _this.onSelectNode = "";
        _this.onSelectChange = "";
        _this.onItemRendered = "";
        _this.searchValue = "";
        _this.search = false;
        _this._onSelectNode = new core_1.EventEmitter();
        _this._onSelectChange = new core_1.EventEmitter();
        _this._onItemRendered = new core_1.EventEmitter();
        _this._selection = "single";
        _this._dataSource = [];
        _this.setDataSource = function ($data) {
            _this.dataSource = $data;
        };
        SbmTreeviewComponent.push(_this);
        // força o elemento ter um id
        if (_this.elementRef.nativeElement.id.length == 0) {
            _this.id = abstract_ngmodel_1.AbstractNgModel.makeId();
            _this.elementRef.nativeElement.id = _this.id;
        }
        return _this;
    }
    Object.defineProperty(TreeviewComponent.prototype, "selection", {
        get: function () {
            return this._selection;
        },
        set: function (val) {
            if (val == "single" || val == "multiple") {
                this.showCheckboxMode = "normal";
                this._selection = val;
            }
            else {
                this.showCheckboxMode = "none";
                this._selection = "single";
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreeviewComponent.prototype, "dataSource", {
        get: function () {
            return this._dataSource;
        },
        set: function (val) {
            var _this = this;
            if (typeof val == "string") {
                this.reqService(val);
            }
            else if (typeof val == "object") {
                this.items = [];
                this._dataSource = this.recursiveDataSource(val);
                if (val.hasOwnProperty("length")) {
                    val.map(function (itm) {
                        _this.items.push(_this.createTreeview(itm));
                    });
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    TreeviewComponent.prototype.getDxTreeviewInstance = function (v) {
        return this.dxTreeView.instance;
    };
    TreeviewComponent.prototype.reqService = function (url) {
        var _this = this;
        if (this._dataSource.length == 0) {
            this._service.get(url).subscribe(function (ret) {
                _this.dataSource = ret;
            });
        }
    };
    TreeviewComponent.prototype.recursiveDataSource = function (data) {
        var _this = this;
        if (data.length > 0) {
            data.forEach(function (item) {
                _this._onSelectNode.emit(item);
                if (_this.onSelectNode != "") {
                    window[_this.onSelectNode](item);
                }
                if (item[_this.children]) {
                    _this.recursiveDataSource(item);
                }
            });
        }
        return data;
    };
    TreeviewComponent.prototype.createTreeview = function (data) {
        var _this = this;
        var aux = {
            id: abstract_ngmodel_1.AbstractNgModel.makeId(),
            text: null,
            items: [],
            data: data,
            selected: false,
            expanded: false,
            disabled: false
        };
        var label = "";
        // let itm: any;
        for (var count = 0; count < this.text.length; count++) {
            if (this.text.length > 1) {
                label += data[this.text[count]] + " " + (this.text.length == count + 1 ? "" : this.textSeparator) + " ";
            }
            else {
                label = data[this.text[count]];
            }
        }
        // itm.push(this.createTreeview(item['items']));
        aux["text"] = label;
        aux.selected = data.hasOwnProperty(this.selectedKey)
            ? data[this.selectedKey]
            : false;
        aux.expanded = data.hasOwnProperty(this.expandedKey)
            ? data[this.expandedKey]
            : false;
        aux.disabled = data.hasOwnProperty(this.disabledKey)
            ? data[this.disabledKey]
            : false;
        if (data[this.children]) {
            if (data[this.children].length > 0) {
                data[this.children].map(function (ret) {
                    aux.items.push(_this.createTreeview(ret));
                });
            }
        }
        return aux;
    };
    TreeviewComponent.prototype.selectionChange = function (event) {
        this._onSelectChange.emit(event.itemData["data"]);
        if (this.onSelectChange != "") {
            window[this.onSelectChange](event);
        }
    };
    TreeviewComponent.prototype.itemClicado = function (event) {
        this._onClick.emit(event.itemData["data"]);
        if (this.onClick != "") {
            window[this.onClick](event.itemData["data"]);
        }
    };
    TreeviewComponent.prototype.itemRenderizado = function ($event) {
        this._onItemRendered.emit($event);
        if (this.onItemRendered != "") {
            window[this.onItemRendered]($event);
        }
    };
    TreeviewComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
    };
    TreeviewComponent.prototype.ngOnDestroy = function () {
        var _this = this;
        var index = SbmTreeviewComponent.findIndex(function (tree) { return tree.id === _this.id; });
        if (index >= 0) {
            SbmTreeviewComponent.splice(index, 1);
        }
    };
    TreeviewComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: "sbm-treeview",
                    template: require('./treeview.component.html'),

                    styles: ["\n        .margin-top-60 {\n            margin-top:60px;\n        }\n    "]
                },] },
    ];
    /** @nocollapse */
    TreeviewComponent.ctorParameters = function () { return [
        { type: sbm_http_client_service_1.SbmHttpClientService, },
        { type: core_2.TranslateService, },
        { type: http_1.Http, },
        { type: sharedService_1.SharedService, },
        { type: core_1.ElementRef, },
    ]; };
    TreeviewComponent.propDecorators = {
        "children": [{ type: core_1.Input },],
        "selectedKey": [{ type: core_1.Input, args: ["selectedkey",] },],
        "selectNodesRecursivelly": [{ type: core_1.Input, args: ["selectNodesRecursivelly",] },],
        "disabledKey": [{ type: core_1.Input, args: ["disabledkey",] },],
        "expandedKey": [{ type: core_1.Input, args: ["expandedkey",] },],
        "onSelectNode": [{ type: core_1.Input, args: ["onselectnode",] },],
        "onSelectChange": [{ type: core_1.Input, args: ["onselectchange",] },],
        "onItemRendered": [{ type: core_1.Input, args: ["onitemrendered",] },],
        "searchValue": [{ type: core_1.Input, args: ["searchvalue",] },],
        "search": [{ type: core_1.Input, args: ["search",] },],
        "height": [{ type: core_1.Input, args: ["height",] },],
        "_onSelectNode": [{ type: core_1.Output },],
        "_onSelectChange": [{ type: core_1.Output },],
        "_onItemRendered": [{ type: core_1.Output },],
        "dxTreeView": [{ type: core_1.ViewChild, args: [devextreme_angular_1.DxTreeViewComponent,] },],
        "selection": [{ type: core_1.Input },],
        "dataSource": [{ type: core_1.Input, args: ["datasource",] },],
    };
    return TreeviewComponent;
}(abstract_ngmodel_1.AbstractNgModel));
exports.TreeviewComponent = TreeviewComponent;
