"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var sharedService_1 = require("../../models/sharedService");
var http_1 = require("@angular/http");
var core_2 = require("@ngx-translate/core");
var notification_component_1 = require("../notification/notification.component");
var crud_component_1 = require("../crud/crud.component");
var auto_unsubscribe_1 = require("../../models/auto.unsubscribe");
var funcoes_component_1 = require("../../models/funcoes.component");
var UploadComponent = /** @class */ (function (_super) {
    __extends(UploadComponent, _super);
    function UploadComponent(_sharedService, _http, _translateService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._sharedService = _sharedService;
        _this._http = _http;
        _this._translateService = _translateService;
        _this._multiple = false;
        _this.accept = "*";
        _this.dataType = false;
        _this.inputValid = true;
        _this.msgError = "Campo Incorreto";
        _this.validationsMsg = {
            require: null
        };
        _this.component = {
            valid: true,
            invalidRequire: false
        };
        _this.filesView = [];
        _this.onUpload = new core_1.EventEmitter();
        SbmUploadComponent.push(_this);
        _this._translateService.onLangChange.subscribe(function () {
            var retTraducao = _this._sharedService.getTraducao("sabium-framework")[0];
            _this.validationsMsg["require"] = retTraducao["validations.notNull"];
            _this.validationsMsg["minLength"] =
                retTraducao["validations.minLength"];
            _this.validationsMsg["maxLength"] =
                retTraducao["validations.maxLength"];
            _this.validationsMsg["pattern"] = retTraducao["validations.pattern"];
            _this.msgError = retTraducao["validations.require"];
        });
        return _this;
    }
    UploadComponent_1 = UploadComponent;
    Object.defineProperty(UploadComponent.prototype, "multiple", {
        get: function () {
            return this._multiple;
        },
        set: function (val) {
            if (val == "true") {
                this._multiple = true;
            }
            else {
                this._multiple = false;
            }
        },
        enumerable: true,
        configurable: true
    });
    UploadComponent.prototype.ngOnInit = function () {
        var _this = this;
        _super.prototype.validar.call(this, this.securityId);
        crud_component_1.CrudComponent.resetarUploadFile.subscribe(function () {
            _this.filesView = [];
        });
        this.subscription = this.onChangeValue.subscribe(function (ret) {
            if (ret) {
                if (typeof ret == "object") {
                    if (ret.length > 0) {
                        ret.map(function (item) {
                            var type = item["base64"].match(/data:([^;]+)/);
                            if (type) {
                                _this.filesView.push({
                                    data: {
                                        type: type[1],
                                        name: item["data"]["name"],
                                        size: item["data"]["size"]
                                    },
                                    base64: item["base64"]
                                });
                            }
                        });
                    }
                }
                else if (typeof ret == "string") {
                    var type = ret.match(/data:([^;]+)/);
                    var format = type[1].match(/\/(.+)$/);
                    var noHeader = ret.split("base64,")[1];
                    var fileSize = noHeader.replace(/=/g, "").length * 0.75;
                    if (type) {
                        if (_this.filesView.length == 0)
                            _this.filesView.push({
                                data: {
                                    type: type[1],
                                    name: "upload." + format[1],
                                    size: fileSize
                                },
                                base64: ret
                            });
                    }
                }
            }
        });
    };
    UploadComponent.prototype.formatarSize = function (bytes) {
        if (bytes < 1024) {
            return bytes + " bytes";
        }
        else if (bytes < 1048576) {
            return (bytes / 1024).toFixed(2) + " kb";
        }
        else {
            return (bytes / 1048576).toFixed(2) + " mb";
        }
    };
    UploadComponent.prototype.clearValue = function () {
        this.fileUploader.instance.option("value", "");
        this.inputValid = true;
        this.inputFile.nativeElement.reset();
        $(this.inputFile.nativeElement).html($(this.inputFile.nativeElement).html());
    };
    UploadComponent.prototype.changeFile = function (file) {
        var _this = this;
        var files = event.srcElement["files"];
        if (files.length > 0) {
            $(".btn-upload").addClass("disabled");
            $(".btn-upload span").text("Fazendo upload...");
        }
        else {
            this.value = undefined;
        }
        this.filesView = [];
        var v = [];
        var tipoArq = this.accept.split("/");
        if (this.multiple) {
            var _loop_1 = function (file_1) {
                var reader = new FileReader();
                reader.onload = function (readerEvt) {
                    if (_this.accept == "*" ||
                        (tipoArq &&
                            tipoArq.length > 0 &&
                            file_1 &&
                            file_1.type.indexOf(tipoArq[0]) > -1)) {
                        var binaryString = btoa(readerEvt.target["result"]);
                        var typeFile = void 0;
                        if (!files[0].type) {
                            var extensaoArquivo = funcoes_component_1.FuncoesComponent.retornaExtensao(file_1.name);
                            typeFile = extensaoArquivo;
                        }
                        else {
                            typeFile = files[0].type;
                        }
                        var objValor = {
                            data: {
                                type: typeFile,
                                name: file_1.name,
                                size: file_1.size
                            },
                            base64: "data:" + typeFile + ";base64," + binaryString
                        };
                        // v.push(objValor);
                        v.push(objValor["base64"]);
                        _this.filesView.push(objValor);
                    }
                    else {
                        _this.value = [];
                        event.srcElement["value"] = "";
                        var notification = new notification_component_1.NotificationComponent();
                        notification.show("O Formato do arquivo não pode ser adicionado!");
                    }
                    $(".btn-upload").removeClass("disabled");
                    $(".btn-upload span").text(_this._label);
                };
                reader.readAsBinaryString(file_1);
            };
            for (var _i = 0, files_1 = files; _i < files_1.length; _i++) {
                var file_1 = files_1[_i];
                _loop_1(file_1);
            }
            this.onUpload.emit(files);
            this.value = v;
        }
        else {
            var reader = new FileReader();
            reader.onload = function (readerEvt) {
                if (_this.accept == "*" ||
                    (tipoArq &&
                        tipoArq.length > 0 &&
                        files[0] &&
                        files[0].type.indexOf(tipoArq[0]) > -1)) {
                    var binaryString = btoa(readerEvt.target["result"]);
                    var typeFile = void 0;
                    if (!files[0].type) {
                        var extensaoArquivo = funcoes_component_1.FuncoesComponent.retornaExtensao(files[0].name);
                        typeFile = extensaoArquivo;
                    }
                    else {
                        typeFile = files[0].type;
                    }
                    var objValor = {
                        data: {
                            type: typeFile,
                            name: files[0].name,
                            size: files[0].size
                        },
                        base64: "data:" + typeFile + ";base64," + binaryString
                    };
                    // v.push(objValor);
                    v.push(objValor["base64"]);
                    _this.filesView.push(objValor);
                    _this.value = v[0];
                }
                else {
                    _this.value = "";
                    event.srcElement["value"] = "";
                    var notification = new notification_component_1.NotificationComponent();
                    notification.show("O Formato do arquivo não pode ser adicionado!");
                }
                $(".btn-upload").removeClass("disabled");
                $(".btn-upload span").text(_this._label);
            };
            reader.readAsBinaryString(files[0]);
            this.onUpload.emit(files);
        }
    };
    UploadComponent.prototype.remove = function (fileInput, file) {
        event.srcElement["files"] = [];
        var v = [];
        for (var i = 0; i < this.filesView.length; i++) {
            if (JSON.stringify(this.filesView[i]["base64"]) ==
                JSON.stringify(file["base64"])) {
                this.filesView.splice(i, 1);
            }
        }
        this.filesView.map(function (ret) {
            v.push(ret);
            // v.push(ret['base64']);
        });
        var input = $(this.inputFile.nativeElement);
        input.val("");
        input.replaceWith(input.trigger("reset"));
        this.value = v;
    };
    UploadComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: "sbm-upload",
                    template: require('./upload.component.html'),

                    styles: [require('./upload.component.css')],
                    host: {
                        "[class]": "columns"
                    },
                    providers: [
                        abstract_ngmodel_1.MakeProvider(UploadComponent_1),
                        {
                            provide: abstract_ngmodel_1.AbstractNgModel,
                            useExisting: core_1.forwardRef(function () { return UploadComponent_1; })
                        }
                    ]
                },] },
    ];
    /** @nocollapse */
    UploadComponent.ctorParameters = function () { return [
        { type: sharedService_1.SharedService, },
        { type: http_1.Http, },
        { type: core_2.TranslateService, },
    ]; };
    UploadComponent.propDecorators = {
        "file": [{ type: core_1.ViewChild, args: ["file",] },],
        "input": [{ type: core_1.ViewChild, args: ["input",] },],
        "inputFile": [{ type: core_1.ViewChild, args: ["inputFile",] },],
        "fileUploader": [{ type: core_1.ViewChild, args: ["fileUploader",] },],
        "multiple": [{ type: core_1.Input },],
        "accept": [{ type: core_1.Input },],
        "dataType": [{ type: core_1.Input, args: ["datatype",] },],
        "onUpload": [{ type: core_1.Output },],
    };
    UploadComponent = UploadComponent_1 = __decorate([
        auto_unsubscribe_1.AutoUnsubscribe(),
        __metadata("design:paramtypes", [sharedService_1.SharedService,
            http_1.Http,
            core_2.TranslateService])
    ], UploadComponent);
    return UploadComponent;
    var UploadComponent_1;
}(abstract_ngmodel_1.AbstractNgModel));
exports.UploadComponent = UploadComponent;
