"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var MaxDirective = /** @class */ (function () {
    function MaxDirective(el) {
        this.el = el;
    }
    MaxDirective.prototype.validate = function (c) {
        if (c) {
            var v = c.value;
            if (v) {
                if (isNaN(Number(v))) {
                    v = v.replace(".", "");
                    v = parseFloat(v.replace(",", "."));
                }
            }
            return Number(v) <= Number(parseInt(this.max))
                ? null
                : { maxValue: true };
        }
        else {
            return null;
        }
    };
    MaxDirective.decorators = [
        { type: core_1.Directive, args: [{
                    selector: "[maxValue]",
                    providers: [
                        {
                            provide: forms_1.NG_VALIDATORS,
                            useExisting: core_1.forwardRef(function () { return MaxDirective; }),
                            multi: true
                        }
                    ]
                },] },
    ];
    /** @nocollapse */
    MaxDirective.ctorParameters = function () { return [
        { type: core_1.ElementRef, },
    ]; };
    MaxDirective.propDecorators = {
        "max": [{ type: core_1.Input, args: ["maxValue",] },],
        "decimalDigits": [{ type: core_1.Input, args: ["decimaldigits",] },],
    };
    return MaxDirective;
}());
exports.MaxDirective = MaxDirective;
