"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var MinDirective = /** @class */ (function () {
    function MinDirective(el) {
        this.el = el;
    }
    MinDirective.prototype.validate = function (c) {
        if (c) {
            var v = c.value;
            if (v) {
                if (isNaN(Number(v))) {
                    v = v.replace('.', '');
                    v = parseFloat(v.replace(',', '.'));
                }
            }
            return Number(v) <= Number(this.min) ? { minValue: true } : null;
        }
        else {
            return null;
        }
    };
    MinDirective.decorators = [
        { type: core_1.Directive, args: [{
                    selector: "[minValue]",
                    providers: [
                        {
                            provide: forms_1.NG_VALIDATORS,
                            useExisting: core_1.forwardRef(function () { return MinDirective; }),
                            multi: true
                        }
                    ]
                },] },
    ];
    /** @nocollapse */
    MinDirective.ctorParameters = function () { return [
        { type: core_1.ElementRef, },
    ]; };
    MinDirective.propDecorators = {
        "min": [{ type: core_1.Input, args: ["minValue",] },],
        "decimalDigits": [{ type: core_1.Input, args: ["decimaldigits",] },],
    };
    return MinDirective;
}());
exports.MinDirective = MinDirective;
