"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var TooltipDirective = /** @class */ (function () {
    function TooltipDirective(sbmTooltipAttr, el) {
        this.sbmTooltipAttr = sbmTooltipAttr;
        this.el = el;
        this.sbmTooltip = '';
    }
    TooltipDirective.prototype.ngAfterViewInit = function () {
        var _this = this;
        $(document).ready(function () {
            if (_this.sbmTooltip && _this.sbmTooltip != '') {
                $(_this.el.nativeElement).tooltip({
                    delay: 50,
                    tooltip: _this.sbmTooltip,
                    position: 'bottom',
                    html: true
                });
                var eventoMouseoutTooltipDefault_1 = $._data(_this.el.nativeElement, "events")['mouseout']; // evento do materialize por padrão
                delete $._data(_this.el.nativeElement, "events")['mouseout']; // remoção do evento para não fechar o tooltip
                var me_1 = _this;
                //definição de attr para controlar o tooltip aberto e fechado
                $('.material-tooltip').hover(function (e) {
                    $(this).attr('hover', 1);
                }, function (e) {
                    $(this).attr('hover', 0);
                    eventoMouseoutTooltipDefault_1[0].handler.apply($(me_1.el.nativeElement), eventoMouseoutTooltipDefault_1);
                });
                // ação que verifica se o tooltip deve se manter aberto ou fechado
                $(_this.el.nativeElement)
                    .on('mouseenter', function (e) {
                    $('.material-tooltip:visible').css('pointer-events', 'auto');
                }).on('mouseleave', function (e) {
                    setTimeout(function () {
                        var val = $('.material-tooltip:visible')
                            .filter(function (e, o) { return o.id === $(me_1.el.nativeElement).attr('data-tooltip-id'); })
                            .map(function (i, o) { return $(o).attr('hover'); });
                        if (val[0] == undefined || val[0] == 0) {
                            eventoMouseoutTooltipDefault_1[0].handler.apply($(me_1.el.nativeElement), eventoMouseoutTooltipDefault_1);
                        }
                    }, 250);
                });
            }
        });
    };
    TooltipDirective.prototype.ngOnDestroy = function () {
        if (this.sbmTooltip && this.sbmTooltip != '') {
            $(this.el.nativeElement).tooltip('remove');
        }
    };
    TooltipDirective.decorators = [
        { type: core_1.Directive, args: [{
                    selector: '[sbmTooltip]'
                },] },
    ];
    /** @nocollapse */
    TooltipDirective.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: core_1.Attribute, args: ['sbmTooltip',] },] },
        { type: core_1.ElementRef, },
    ]; };
    TooltipDirective.propDecorators = {
        "sbmTooltip": [{ type: core_1.Input },],
    };
    return TooltipDirective;
}());
exports.TooltipDirective = TooltipDirective;
