"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("rxjs/add/operator/map");
var i18n_1 = require("./i18n");
var AbstractComponent = /** @class */ (function () {
    function AbstractComponent(_router, _sharedService, _translateService, _http) {
        var _this = this;
        var urlStorage = _sharedService.getLocalStorage(_projectLocalStorage, 'url-current', true);
        if (urlStorage) {
            if (urlStorage == _router.url) {
                _sharedService.setLocalStorage(_projectLocalStorage, 'url-current', _router.url, true);
            }
        }
        else {
            _sharedService.setLocalStorage(_projectLocalStorage, 'url-current', _router.url, true);
        }
        this.previousUrl = _sharedService.getLocalStorage(_projectLocalStorage, 'url-current', true);
        this.traducao = new i18n_1.i18n(_translateService, _sharedService);
        this.traducao.projectName = _projectName;
        var idiomaStorage = _sharedService.getIdioma() || 'pt-BR';
        this.getJSON(_http, idiomaStorage).subscribe(function (retTraducao) {
            _this.traducao.reqJSON = retTraducao;
            _this.traducao.iniciarIdioma();
        });
    }
    AbstractComponent.prototype.getJSON = function (_http, idiomaStorage) {
        return _http.get("assets/i18n/" + idiomaStorage + ".json").map(function (res) { return res.json(); });
    };
    return AbstractComponent;
}());
exports.AbstractComponent = AbstractComponent;
