"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var moment = require("moment");
var CryptoJS = require("crypto-js");
var FuncoesComponent = /** @class */ (function () {
    function FuncoesComponent() {
    }
    FuncoesComponent.getDescrypt = function (aux, descriptografar) {
        if (descriptografar === void 0) { descriptografar = false; }
        var retorno = null;
        if (aux) {
            if (descriptografar) {
                if (aux[0] == '"') {
                    aux = aux.substr(1, (aux.length - 2));
                }
                var decrypted = CryptoJS.RC4.decrypt(aux, 'sabium');
                var retData = decrypted.toString(CryptoJS.enc.Utf8);
                try {
                    retorno = JSON.parse(retData);
                }
                catch (e) {
                    retorno = retData;
                }
            }
            else {
                retorno = aux;
            }
        }
        return retorno;
    };
    FuncoesComponent.setDescrypt = function (data, criptografar) {
        if (criptografar === void 0) { criptografar = false; }
        var retorno = (typeof data === "object") ? JSON.stringify(data) : data;
        if (criptografar) {
            var encrypted = CryptoJS.RC4.encrypt(retorno, 'sabium');
            retorno = encrypted.toString();
        }
        if (typeof data === 'object' && !criptografar) {
            retorno = JSON.parse(retorno);
        }
        return retorno;
    };
    FuncoesComponent.isBlank = function (value) {
        if (value === false || value === undefined || value === null || value === '' || value.length === 0) {
            return true;
        }
        return false;
    };
    FuncoesComponent.isNotBlank = function (value) {
        if (this.isBlank(value)) {
            return false;
        }
        else {
            return true;
        }
    };
    FuncoesComponent.testaEmail = function (strEmail) {
        var filtro = /^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;
        if (filtro.test(strEmail)) {
            return true;
        }
        else {
            return false;
        }
    };
    FuncoesComponent.stepValidation = function (el) {
        var ret = function (c) {
            if (c.value != null) {
                if (el.validity.stepMismatch) {
                    return {
                        step: el.validationMessage
                    };
                }
                else {
                    return null;
                }
            }
            return null;
        };
        return ret;
    };
    FuncoesComponent.validarEmail = function (c) {
        if (c.value != null) {
            if (FuncoesComponent.testaEmail(c.value)) {
                return null;
            }
            else {
                return {
                    emailInvalido: true
                };
            }
        }
        return null;
    };
    FuncoesComponent.customValidation = function (item) {
        var ret = function (c) {
            if (item.component.valid) {
                return null;
            }
            else {
                var invalid = {};
                invalid[item.name] = true;
                return invalid;
            }
        };
        return ret;
    };
    //gera uma string randomica
    //gera uma string randomica
    FuncoesComponent.makeId = 
    //gera uma string randomica
    function () {
        var text = "";
        var possibleGenerate = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
        for (var i = 0; i < 14; i++)
            text += possibleGenerate.charAt(Math.floor(Math.random() * possibleGenerate.length));
        return "sbm-" + text;
    };
    FuncoesComponent.testaCPF = function (strCPF) {
        strCPF = strCPF.replace(/[^\d]+/g, '');
        var Soma;
        var Resto;
        Soma = 0;
        if (strCPF === '00000000000') {
            return false;
        }
        for (var i = 1; i <= 9; i++) {
            Soma = Soma + parseInt(strCPF.substring(i - 1, i)) * (11 - i);
        }
        Resto = (Soma * 10) % 11;
        if ((Resto === 10) || (Resto === 11)) {
            Resto = 0;
        }
        if (Resto !== parseInt(strCPF.substring(9, 10))) {
            return false;
        }
        Soma = 0;
        for (var i = 1; i <= 10; i++) {
            Soma = Soma + parseInt(strCPF.substring(i - 1, i)) * (12 - i);
        }
        Resto = (Soma * 10) % 11;
        if ((Resto === 10) || (Resto === 11)) {
            Resto = 0;
        }
        if (Resto !== parseInt(strCPF.substring(10, 11))) {
            return false;
        }
        return true;
    };
    FuncoesComponent.validarCNPJ = function (cnpj) {
        if (cnpj == '' || cnpj == undefined || cnpj == null) {
            return false;
        }
        if (typeof (cnpj) != 'string') {
            cnpj = cnpj.toString();
        }
        cnpj = cnpj.replace(/[^\d]+/g, '');
        if (cnpj === '') {
            return false;
        }
        if (cnpj.length !== 14) {
            return false;
        }
        // Elimina CNPJs invalidos conhecidos
        if (cnpj === '00000000000000' || cnpj === '11111111111111' ||
            cnpj === '22222222222222' || cnpj === '33333333333333' ||
            cnpj === '44444444444444' || cnpj === '55555555555555' ||
            cnpj === '66666666666666' || cnpj === '77777777777777' ||
            cnpj === '88888888888888' || cnpj === '99999999999999') {
            return false;
        }
        // Valida DVs
        var tamanho = cnpj.length - 2;
        var numeros = cnpj.substring(0, tamanho);
        var digitos = cnpj.substring(tamanho);
        var soma = 0;
        var pos = tamanho - 7;
        for (var i = tamanho; i >= 1; i--) {
            soma += numeros.charAt(tamanho - i) * pos--;
            if (pos < 2) {
                pos = 9;
            }
        }
        var resultado = soma % 11 < 2 ? 0 : 11 - soma % 11;
        if (resultado != digitos.charAt(0)) {
            return false;
        }
        tamanho = tamanho + 1;
        numeros = cnpj.substring(0, tamanho);
        soma = 0;
        pos = tamanho - 7;
        for (var i = tamanho; i >= 1; i--) {
            soma += numeros.charAt(tamanho - i) * pos--;
            if (pos < 2) {
                pos = 9;
            }
        }
        resultado = soma % 11 < 2 ? 0 : 11 - soma % 11;
        if (resultado != digitos.charAt(1)) {
            return false;
        }
        return true;
    };
    FuncoesComponent.formataDinheiro = function (valor) {
        var numero = parseFloat(valor).toFixed(2).split('.');
        numero[0] = numero[0].split(/(?=(?:...)*$)/).join('.');
        return numero.join(',');
    };
    FuncoesComponent.formataDecimal = function (valor) {
        var idx = valor.indexOf('.');
        var ret = valor;
        if (idx > -1) {
            var len = valor.substr(idx + 1, valor.length);
            if (len.length == 1) {
                ret = valor + '0';
            }
        }
        else {
            ret = valor + '.00';
        }
        return ret.replace('.', ',');
    };
    FuncoesComponent.formatPhoneNumber = function (s) {
        var s2 = ("" + s).replace(/\D/g, '');
        if (s2.length == 10) {
            // exemplo: (44) 3456-7890
            var m = s2.match(/^(\d{2})(\d{4})(\d{4})$/);
            return (!m) ? null : "(" + m[1] + ") " + m[2] + "-" + m[3];
        }
        else {
            // exemplo: (44) 98456-7890
            var m = s2.match(/^(\d{2})(\d{5})(\d{4})$/);
            return (!m) ? null : "(" + m[1] + ") " + m[2] + "-" + m[3];
        }
    };
    FuncoesComponent.formataData = function (data) {
        var prefixo = data.slice(2, 3);
        if (prefixo == "/") {
            var d = data.slice(0, 2);
            var m = data.slice(3, 5);
            var a = data.slice(6, 10);
            return a + "-" + m + "-" + d;
        }
        else {
            var a = data.slice(0, 4);
            var m = data.slice(5, 7);
            var d = data.slice(8, 10);
            return d + "/" + m + "/" + a;
        }
    };
    FuncoesComponent.formataDataHora = function (data) {
        var prefixo = data.slice(2, 3);
        if (prefixo == "/") {
            var d = data.slice(0, 2);
            var m = data.slice(3, 5);
            var a = data.slice(6, 10);
            var h = data.slice(11, 13);
            var min = data.slice(14, 16);
            var sec = data.slice(17, 19);
            if (sec != "") {
                return a + "-" + m + "-" + d + " " + h + ":" + min + ":" + sec;
            }
            else {
                return a + "-" + m + "-" + d + " " + h + ":" + min;
            }
        }
        else {
            var a = data.slice(0, 4);
            var m = data.slice(5, 7);
            var d = data.slice(8, 10);
            var h = data.slice(11, 13);
            var min = data.slice(14, 16);
            var sec = data.slice(17, 19);
            if (sec != "") {
                return d + "/" + m + "/" + a + " " + h + ":" + min + ":" + sec;
            }
            else {
                return d + "/" + m + "/" + a + " " + h + ":" + min;
            }
        }
    };
    FuncoesComponent.isBase64 = function (str) {
        try {
            return btoa(atob(str)) == str;
        }
        catch (err) {
            return false;
        }
    };
    FuncoesComponent.formatarData = function (timestampAtual) {
        var dt = new Date(timestampAtual);
        var dia = (dt.getDate() < 10) ? "0" + dt.getDate() : dt.getDate();
        var mes = ((dt.getMonth() + 1) < 10) ? "0" + (dt.getMonth() + 1) : (dt.getMonth() + 1);
        var hrs = (dt.getHours() < 10) ? "0" + dt.getHours() : dt.getHours();
        var min = (dt.getMinutes() < 10) ? "0" + dt.getMinutes() : dt.getMinutes();
        return dia + "/" + mes + "/" + dt.getFullYear() + " " + hrs + ":" + min;
    };
    FuncoesComponent.formataDataHoraFromTimeStamp = function (dataInteger) {
        var data = new Date(dataInteger);
        var dataAux = moment(data).format("YYYY-MM-DD HH:mm");
        return this.formataDataHora(dataAux);
    };
    FuncoesComponent.retornaCpfFormatado = function (valor) {
        return valor;
    };
    FuncoesComponent.retornaCnpjFormatado = function (valor) {
        return valor;
    };
    FuncoesComponent.retornaCepFormatado = function (valor) {
        return valor;
    };
    FuncoesComponent.retornaExtensao = function (valor) {
        var stringRevert = valor.split("").reverse().join("");
        var recString = stringRevert.split('.');
        return recString[0].split("").reverse().join("");
    };
    return FuncoesComponent;
}());
exports.FuncoesComponent = FuncoesComponent;
