"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var FilterPipe = /** @class */ (function () {
    function FilterPipe() {
    }
    FilterPipe.prototype.transform = function (items, filter) {
        if (!items || !filter || filter.length < 3) {
            return items;
        }
        return items.filter(function (item) { return item.value.toString().toLowerCase().indexOf(filter.toLowerCase()) !== -1 || item.label.toString().toLowerCase().indexOf(filter.toLowerCase()) !== -1; });
    };
    FilterPipe.decorators = [
        { type: core_1.Pipe, args: [{
                    name: 'sbmFilter'
                },] },
    ];
    /** @nocollapse */
    FilterPipe.ctorParameters = function () { return []; };
    return FilterPipe;
}());
exports.FilterPipe = FilterPipe;
var SelectFilterPipe = /** @class */ (function () {
    function SelectFilterPipe() {
    }
    SelectFilterPipe.prototype.transform = function (items, filter) {
        if (!items || !filter || filter.length < 3) {
            return items;
        }
        return items.filter(function (item) { return item['label'].toString().toLowerCase().indexOf(filter.toLowerCase()) !== -1; });
    };
    SelectFilterPipe.decorators = [
        { type: core_1.Pipe, args: [{
                    name: 'selectFilter'
                },] },
    ];
    /** @nocollapse */
    SelectFilterPipe.ctorParameters = function () { return []; };
    return SelectFilterPipe;
}());
exports.SelectFilterPipe = SelectFilterPipe;
var MultiSelectFilterPipe = /** @class */ (function () {
    function MultiSelectFilterPipe() {
    }
    MultiSelectFilterPipe.prototype.transform = function (items, filter) {
        if (!items || !filter || filter.length < 3) {
            return items;
        }
        return items.filter(function (item) { return item['label'].toString().toLowerCase().indexOf(filter.toLowerCase()) !== -1; });
    };
    MultiSelectFilterPipe.decorators = [
        { type: core_1.Pipe, args: [{
                    name: 'multiselectFilter'
                },] },
    ];
    /** @nocollapse */
    MultiSelectFilterPipe.ctorParameters = function () { return []; };
    return MultiSelectFilterPipe;
}());
exports.MultiSelectFilterPipe = MultiSelectFilterPipe;
var FilterAllPipe = /** @class */ (function () {
    function FilterAllPipe() {
    }
    FilterAllPipe.prototype.transform = function (items, filter) {
        if (!items || !filter || filter.length < 3) {
            return items;
        }
        var ret = [];
        items.map(function (item) {
            var keys = Object.keys(item);
            keys.map(function (key) {
                if (typeof item[key] == 'string') {
                    if (item[key].toString().toLowerCase().indexOf(filter.toLowerCase()) !== -1) {
                        ret.push(item);
                    }
                }
            });
        });
        return ret.filter(function (elem, pos, self) {
            return self.indexOf(elem) == pos;
        });
    };
    FilterAllPipe.decorators = [
        { type: core_1.Pipe, args: [{
                    name: 'sbmFilterAll'
                },] },
    ];
    /** @nocollapse */
    FilterAllPipe.ctorParameters = function () { return []; };
    return FilterAllPipe;
}());
exports.FilterAllPipe = FilterAllPipe;
