"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var platform_browser_1 = require("@angular/platform-browser");
var SafePipe = /** @class */ (function () {
    function SafePipe(_sanitizer) {
        this._sanitizer = _sanitizer;
    }
    SafePipe.prototype.transform = function (value, type) {
        if (type === void 0) { type = 'url'; }
        switch (type) {
            case 'html':
                this.retornoURL = this._sanitizer.bypassSecurityTrustHtml(value);
                break;
            case 'style':
                this.retornoURL = this._sanitizer.bypassSecurityTrustStyle(value);
                break;
            case 'script':
                this.retornoURL = this._sanitizer.bypassSecurityTrustScript(value);
                break;
            case 'url':
                this.retornoURL = this._sanitizer.bypassSecurityTrustUrl(value);
                break;
            case 'resourceUrl':
                this.retornoURL = this._sanitizer.bypassSecurityTrustResourceUrl(value);
                break;
            default:
                throw new Error("Unable to bypass security for invalid type: " + type);
        }
        return this.retornoURL;
    };
    SafePipe.decorators = [
        { type: core_1.Pipe, args: [{ name: 'safe' },] },
    ];
    /** @nocollapse */
    SafePipe.ctorParameters = function () { return [
        { type: platform_browser_1.DomSanitizer, },
    ]; };
    return SafePipe;
}());
exports.SafePipe = SafePipe;
