"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../models/sharedService");
var TranslatePipe = /** @class */ (function () {
    function TranslatePipe(_translateService, _sharedService) {
        this._translateService = _translateService;
        this._sharedService = _sharedService;
    }
    TranslatePipe.prototype.transform = function (campoInformado) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._translateService.onLangChange.subscribe(function () {
                if (campoInformado.indexOf("i18n") > -1) {
                    var retTraducao = _this._sharedService.getTraducao(_projectName)[0];
                    if (_projectName && retTraducao) {
                        resolve(retTraducao[campoInformado.replace("i18n.", "")]);
                    }
                }
                else {
                    var retTraducao = _this._sharedService.getTraducao('sabium-framework')[0];
                    resolve(retTraducao[campoInformado.replace("#", "")]);
                }
            });
        }).then(function (ret) {
            return ret;
        });
    };
    TranslatePipe.decorators = [
        { type: core_1.Pipe, args: [{
                    name: 'translatePipe'
                },] },
    ];
    /** @nocollapse */
    TranslatePipe.ctorParameters = function () { return [
        { type: core_2.TranslateService, },
        { type: sharedService_1.SharedService, },
    ]; };
    return TranslatePipe;
}());
exports.TranslatePipe = TranslatePipe;
