import { ModuleWithProviders } from '@angular/core';
import 'webui-popover/src/jquery.webui-popover.js';
export { SharedService } from "../models/sharedService";
export { ImageComponent } from '../components/image/image.component';
export { LabelComponent } from '../components/label/label.component';
export { FilterAllPipe, FilterPipe, MultiSelectFilterPipe, SelectFilterPipe } from '../pipes/filter.pipe';
export { AbstractComponent } from '../models/abstract.component';
export { TabsChromeComponent } from '../components/tabs/tabs-chrome.component/tabs-chrome.componente';
export { GenericKeyComponent } from '../components/generic-key/generic-key.component';
export { SbmMasterDetailForm } from '../components/master-detail-form/master-detail-form.component';
export { DivComponent } from '../components/div/div.component';
export { AuditComponent } from '../components/audit/audit.component';
export { TabGenericComponent } from '../components/tabs/tab-generic/tab-generic.component';
export { EditorComponent } from '../components/editor/editor.component';
export { InputTextComponent } from '../components/input/input-text/input-text.component';
export { InputCepComponent } from '../components/input/input-cep/input-cep.component';
export { InputCnpjComponent } from '../components/input/input-cnpj/input-cnpj.component';
export { InputCpfComponent } from '../components/input/input-cpf/input-cpf.component';
export { InputEmailComponent } from '../components/input/input-email/input-email.component';
export { InputMaskComponent } from '../components/input/input-mask/input-mask.component';
export { InputNumberComponent } from '../components/input/input-number/input-number.component';
export { InputPasswordComponent } from '../components/input/input-password/input-password.component';
export { InputTelefoneComponent } from '../components/input/input-telefone/input-telefone.component';
export { AccordionComponent } from '../components/accordion/accordion.component';
export { AccordionGroupComponent } from '../components/accordion/accordion-group.component';
export { AlertComponent } from '../components/alert/alert.component';
export { AutocompleteComponent } from '../components/autocomplete/autocomplete.component';
export { BreadcrumbComponent } from '../components/breadcrumb/breadcrumb.component';
export { ButtonComponent } from '../components/button/button.component';
export { ButtonSubmitComponent } from '../components/button-submit/button-submit.component';
export { CheckboxComponent } from '../components/checkbox/checkbox.component';
export { CrudComponent, CrudFormComponent } from '../components/crud/crud.component';
export { DateboxComponent } from '../components/datebox/datebox.component';
export { FieldsetComponent } from '../components/fieldset/fieldset.component';
export { FiltersComponent } from '../components/filters/filters.component';
export { FormComponent } from '../components/form/form.component';
export { GridComponent } from '../components/grid/grid.component';
export { ListViewComponent } from '../components/list-view/list-view.component';
export { MenuComponent, ItemMenuComponent } from '../components/menu/menu.component';
export { ModalComponent } from '../components/modal/modal.component';
export { MasterDetailComponent, DialogMasterDetail } from '../components/master-detail/master-detail.component';
export { DialogError, DialogReportInfoDialog, MonitorComponent } from '../components/monitor/monitor.component';
export { MultiselectComponent } from '../components/multiselect/multiselect.component';
export { NotificationComponent } from '../components/notification/notification.component';
export { ParametersComponent } from '../components/parameters/parameters.component';
export { ProgressbarComponent } from '../components/progressbar/progressbar.component';
export { RadioComponent } from '../components/radio/radio.component';
export { RelatoriosComponent } from '../components/relatorios/relatorios.component';
export { RotatorComponent } from '../components/rotator/rotator.component';
export { SelectComponent } from '../components/select/select.component';
export { TabComponent } from '../components/tabs/tab.component';
export { TabsComponent } from '../components/tabs/tabs.component';
export { TreeviewComponent } from '../components/treeview/treeview.component';
export { TextareaComponent } from '../components/input/textarea/textarea.component';
export { BreadcrumbCrudComponent } from '../components/breadcrumb-crud/breadcrumb-crud.component';
export { MoneyComponent } from '../components/input/money/money.component';
export { PieComponent } from '../components/graps/pie/pie.component';
export { BarComponent } from '../components/graps/bar/bar.component';
export { LineComponent } from '../components/graps/line/line.component';
export { MultiselectDropdownComponent } from '../components/multiselect-dropdown/multiselect-dropdown.component';
export { CalcButtonComponent } from '../components/calc/calc-button.component';
export { MaskTelefonePipe } from '../pipes/mask-telefone.pipe';
export { MaskDirective } from '../diretives/mask.directive';
export { MaxDirective } from '../diretives/max.directive';
export { MinDirective } from '../diretives/min.directive';
export { SchedulingComponent } from '../components/scheduling/scheduling.component';
export { ScheduleTimesComponent } from '../components/scheduling/schedule-times.component';
export { ScheduleProcessComponent } from '../components/scheduling/schedule-process.component';
export { ProgressComponent } from '../components/progress/progress.component';
export { PdfComponent, PDFDialogComponent } from '../components/pdf/pdf.component';
export { InputIpComponent } from '../components/input/input-ip/input-ip.component';
export { DatetimeComponent } from '../components/datetime/datetime.component';
export { DatetimeNativeComponent } from '../components/datetime-native/datetime-native.component';
export { EntityComponent } from '../components/entity/entity.component';
export { PdfViewerComponent } from 'ng2-pdf-viewer';
export { TranslatePipe } from '../pipes/translate-pipe.pipe';
export { SafePipe } from '../pipes/safePipe';
export { PhoneDirective } from '../diretives/phone.directive';
export { CnpjDirective } from '../diretives/cnpj.directive';
export { CpfDirective } from '../diretives/cpf.directive';
export { CepDirective } from '../diretives/cep.directive';
export { TooltipDirective } from '../diretives/tooltip.directive';
export { RegExpDirective } from '../diretives/regexp.directive';
export { DialogAuditDetail } from '../components/crud/dialog-audit/dialog-audit.component';
export { DialogFilterDetail } from '../components/filters/dialog-filter/dialog-filter.component';
export { ReqHttpService } from '../services/req-http.service';
export { TabsErrorService } from '../components/tabs-error/tabs-error.service';
export { SidenavComponent } from '../components/sidenav/sidenav.component';
import { HammerGestureConfig } from '@angular/platform-browser';
export declare class MyHammerConfig extends HammerGestureConfig {
    overrides: any;
}
export declare class SbmModule {
    static forRoot(): ModuleWithProviders;
}
