"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var http_1 = require("@angular/common/http");
var rxjs_1 = require("rxjs");
require("rxjs/add/operator/do");
require("rxjs/add/operator/catch");
var ng2_slim_loading_bar_1 = require("ng2-slim-loading-bar");
var alert_component_1 = require("../components/alert/alert.component");
var InterceptorHttp = /** @class */ (function () {
    function InterceptorHttp(slimLoadingBarService) {
        this.slimLoadingBarService = slimLoadingBarService;
    }
    InterceptorHttp.prototype.intercept = function (req, next) {
        var _this = this;
        this.slimLoadingBarService.start(function () {
            console.log('Loading complete');
        });
        if (!req.headers.has('Content-Type')) {
            req = req.clone({ headers: req.headers.set('Content-Type', 'application/json') });
        }
        if (!req.headers.has('Token')) {
            req = req.clone({ headers: req.headers.set('Token', localStorage.getItem('__SBM-SHARED__/token')) });
        }
        if (localStorage.getItem('__SBM-SHARED__/meu-ip')) {
            req = req.clone({ headers: req.headers.set('IP', localStorage.getItem('__SBM-SHARED__/meu-ip')) });
        }
        if (localStorage.getItem('__SBM-SABIUM-BPM__/wf-task')) {
            req = req.clone({ headers: req.headers.set('wf-task', localStorage.getItem('__SBM-SABIUM-BPM__/wf-task')) });
        }
        return next.handle(req).do(function (event) {
            if (event instanceof http_1.HttpResponse) {
                if (event.headers.get('Token')) {
                    localStorage.setItem('__SBM-SHARED__/token', event.headers.get('Token'));
                }
            }
            _this.slimLoadingBarService.complete();
        }).catch(function (err) {
            if (err instanceof http_1.HttpErrorResponse) {
                if (err.status == 404) {
                    var alert_1 = new alert_component_1.AlertComponent();
                    alert_1.show('Erro, serviço não encontrado', 'ok', err.message, 'error');
                }
                else if (err.status == 403) {
                    var alert_2 = new alert_component_1.AlertComponent();
                    alert_2.show('Sua sessão foi expirada!', 'ok', 'Faça o login novamante para continuar.', 'error');
                }
                else if (err.status == 500) {
                    var alert_3 = new alert_component_1.AlertComponent();
                    var errorJson = JSON.parse(err.error);
                    var textError_1 = "";
                    if (errorJson) {
                        if (errorJson.violations && errorJson.violations.length > 0) {
                            errorJson.violations.forEach(function (itm) {
                                textError_1 += itm.message + '\n';
                            });
                        }
                        else {
                            textError_1 = errorJson.message;
                        }
                    }
                    alert_3.show("Erro ao salvar o registro!", 'OK', textError_1, 'error');
                }
            }
            _this.slimLoadingBarService.complete();
            return rxjs_1.Observable.throw(err);
        });
    };
    InterceptorHttp.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    InterceptorHttp.ctorParameters = function () { return [
        { type: ng2_slim_loading_bar_1.SlimLoadingBarService, },
    ]; };
    return InterceptorHttp;
}());
exports.InterceptorHttp = InterceptorHttp;
