"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var rxjs_1 = require("rxjs");
require("rxjs/Rx");
var router_1 = require("@angular/router");
var sharedService_1 = require("../models/sharedService");
var web_sql_service_1 = require("./web-sql.service");
var funcoes_component_1 = require("../models/funcoes.component");
var ReqHttpService = /** @class */ (function () {
    function ReqHttpService(_router, _sharedService, _webSqlService) {
        this._router = _router;
        this._sharedService = _sharedService;
        this._webSqlService = _webSqlService;
        capturaIP();
    }
    ReqHttpService.prototype.isLoggedIn = function () {
        if (funcoes_component_1.FuncoesComponent.isNotBlank(localStorage.getItem('__SBM-SHARED__/token'))) {
            return true;
        }
        else {
            localStorage.clear();
            // this._webSqlService.clear('sbm-shared');
            this._router.navigate(['/login']);
            return false;
        }
    };
    ReqHttpService.prototype.salvarToken = function (token) {
        if (token) {
            localStorage.setItem('__SBM-SHARED__/token', token);
        }
    };
    ReqHttpService.prototype.xhrGet = function (url, timeout) {
        if (timeout === void 0) { timeout = 30; }
        if (/^\/sabium-gerenciador\/(.+)?/g.test(url)) {
            url = url.replace('/sabium-gerenciador/', '/sabium/');
        }
        else if (url.indexOf('/sabium-framework/') >= 0) {
            url = url.replace('/sabium-framework/', '/sabium/');
        }
        else if (url.indexOf('/sabium-gerenciador-bpm/') >= 0) {
            url = url.replace('/sabium-gerenciador-bpm/', '/sabium-bpm/');
        }
        var me = this;
        return rxjs_1.Observable.create(function (observer) {
            var xhr = new XMLHttpRequest();
            xhr.onreadystatechange = function () {
                if (xhr.readyState === 4) {
                    var codError = xhr.status.toString().slice(0, 1);
                    if (codError === '2') {
                        me.salvarToken(this.getResponseHeader('token') || null);
                        observer.next({
                            'success': true,
                            'res': (xhr.responseText == '') ? [] : JSON.parse(xhr.responseText)
                        });
                        observer.complete();
                    }
                    else {
                        observer.error({ 'success': false, 'res': xhr });
                    }
                }
            };
            xhr.open('GET', url, true);
            xhr.setRequestHeader('Content-Type', 'application/json');
            xhr.setRequestHeader('Token', localStorage.getItem('__SBM-SHARED__/token'));
            xhr.setRequestHeader('IP', localStorage.getItem('__SBM-SHARED__/meu-ip'));
            if (localStorage.getItem('__SBM-SABIUM-BPM__/wf-task')) {
                xhr.setRequestHeader('wf-task', localStorage.getItem('__SBM-SABIUM-BPM__/wf-task'));
            }
            xhr.timeout = 1000 * timeout;
            xhr.ontimeout = function () {
                observer.error({ 'success': false, 'res': xhr });
            };
            xhr.send();
        });
    };
    ReqHttpService.prototype.xhrPost = function (url, params, timeout) {
        if (timeout === void 0) { timeout = 30; }
        if (/^\/sabium-gerenciador\/(.+)?/g.test(url)) {
            url = url.replace('/sabium-gerenciador/', '/sabium/');
        }
        else if (url.indexOf('/sabium-framework/') >= 0) {
            url = url.replace('/sabium-framework/', '/sabium/');
        }
        else if (url.indexOf('/sabium-gerenciador-bpm/') >= 0) {
            url = url.replace('/sabium-gerenciador-bpm/', '/sabium-bpm/');
        }
        var me = this;
        var parameter = null;
        if (params) {
            if (typeof params == 'object') {
                parameter = JSON.stringify(params);
            }
            else {
                parameter = params;
            }
        }
        return rxjs_1.Observable.create(function (observer) {
            var xhr = new XMLHttpRequest();
            xhr.onreadystatechange = function () {
                if (xhr.readyState === 4) {
                    var codError = xhr.status.toString().slice(0, 1);
                    if (codError === '2') {
                        me.salvarToken(this.getResponseHeader('token') || null);
                        observer.next({
                            'success': true,
                            'res': (xhr.responseText == '') ? [] : JSON.parse(xhr.responseText)
                        });
                        observer.complete();
                    }
                    else {
                        observer.error({ 'success': false, 'res': xhr });
                    }
                }
            };
            xhr.open('POST', url, true);
            xhr.setRequestHeader('Content-Type', 'application/json');
            xhr.setRequestHeader('Token', localStorage.getItem('__SBM-SHARED__/token'));
            xhr.setRequestHeader('IP', localStorage.getItem('__SBM-SHARED__/meu-ip'));
            if (localStorage.getItem('__SBM-SABIUM-BPM__/wf-task')) {
                xhr.setRequestHeader('wf-task', localStorage.getItem('__SBM-SABIUM-BPM__/wf-task'));
            }
            xhr.timeout = 1000 * timeout;
            xhr.ontimeout = function () {
                observer.error({ 'success': false, 'res': xhr });
            };
            xhr.send(parameter);
        });
    };
    ReqHttpService.prototype.xhrPut = function (url, params, timeout) {
        if (timeout === void 0) { timeout = 30; }
        if (/^\/sabium-gerenciador\/(.+)?/g.test(url)) {
            url = url.replace('/sabium-gerenciador/', '/sabium/');
        }
        else if (url.indexOf('/sabium-framework/') >= 0) {
            url = url.replace('/sabium-framework/', '/sabium/');
        }
        else if (url.indexOf('/sabium-gerenciador-bpm/') >= 0) {
            url = url.replace('/sabium-gerenciador-bpm/', '/sabium-bpm/');
        }
        var me = this;
        return rxjs_1.Observable.create(function (observer) {
            var xhr = new XMLHttpRequest();
            xhr.onreadystatechange = function () {
                if (xhr.readyState === 4) {
                    var codError = xhr.status.toString().slice(0, 1);
                    if (codError === '2') {
                        me.salvarToken(this.getResponseHeader('token') || null);
                        observer.next({
                            'success': true,
                            'res': (xhr.responseText == '') ? [] : JSON.parse(xhr.responseText)
                        });
                        observer.complete();
                    }
                    else {
                        observer.error({ 'success': false, 'res': xhr });
                    }
                }
            };
            xhr.open('PUT', url, true);
            xhr.setRequestHeader('Content-Type', 'application/json');
            xhr.setRequestHeader('Token', localStorage.getItem('__SBM-SHARED__/token'));
            xhr.setRequestHeader('IP', localStorage.getItem('__SBM-SHARED__/meu-ip'));
            if (localStorage.getItem('__SBM-SABIUM-BPM__/wf-task')) {
                xhr.setRequestHeader('wf-task', localStorage.getItem('__SBM-SABIUM-BPM__/wf-task'));
            }
            xhr.timeout = 1000 * timeout;
            xhr.ontimeout = function () {
                observer.error({ 'success': false, 'res': xhr });
            };
            xhr.send(JSON.stringify(params));
        });
    };
    ReqHttpService.prototype.xhrDelete = function (url, params, timeout) {
        if (timeout === void 0) { timeout = 30; }
        if (/^\/sabium-gerenciador\/(.+)?/g.test(url)) {
            url = url.replace('/sabium-gerenciador/', '/sabium/');
        }
        else if (url.indexOf('/sabium-framework/') >= 0) {
            url = url.replace('/sabium-framework/', '/sabium/');
        }
        else if (url.indexOf('/sabium-gerenciador-bpm/') >= 0) {
            url = url.replace('/sabium-gerenciador-bpm/', '/sabium-bpm/');
        }
        var me = this;
        var parameter = null;
        if (params) {
            if (typeof params == 'object') {
                parameter = JSON.stringify(params);
            }
            else {
                parameter = params;
            }
        }
        return rxjs_1.Observable.create(function (observer) {
            var xhr = new XMLHttpRequest();
            xhr.onreadystatechange = function () {
                if (xhr.readyState === 4) {
                    var codError = xhr.status.toString().slice(0, 1);
                    if (codError === '2') {
                        me.salvarToken(this.getResponseHeader('token') || null);
                        observer.next({
                            'success': true,
                            'res': (xhr.responseText == '') ? [] : JSON.parse(xhr.responseText)
                        });
                        observer.complete();
                    }
                    else {
                        observer.error({ 'success': false, 'res': xhr });
                    }
                }
            };
            xhr.open('DELETE', url, true);
            xhr.setRequestHeader('Content-Type', 'application/json');
            xhr.setRequestHeader('Token', localStorage.getItem('__SBM-SHARED__/token'));
            xhr.setRequestHeader('IP', localStorage.getItem('__SBM-SHARED__/meu-ip'));
            if (localStorage.getItem('__SBM-SABIUM-BPM__/wf-task')) {
                xhr.setRequestHeader('wf-task', localStorage.getItem('__SBM-SABIUM-BPM__/wf-task'));
            }
            xhr.timeout = 1000 * timeout;
            xhr.ontimeout = function () {
                observer.error({ 'success': false, 'res': xhr });
            };
            xhr.send(parameter);
        });
    };
    ReqHttpService.prototype.xhrDownload = function (url, params, timeout) {
        if (timeout === void 0) { timeout = 30; }
        var me = this;
        return rxjs_1.Observable.create(function (observer) {
            var xhr = new XMLHttpRequest();
            xhr.onreadystatechange = function () {
                if (xhr.readyState === 4) {
                    var codError = xhr.status.toString().slice(0, 1);
                    if (codError === '2') {
                        me.salvarToken(this.getResponseHeader('token') || null);
                        var responseText = '';
                        if (xhr.responseType == '' || xhr.responseType == 'text') {
                            responseText = xhr.responseText;
                        }
                        else if (xhr.responseType == 'arraybuffer') {
                            responseText = xhr.response;
                        }
                        observer.next({
                            'success': true,
                            'res': (responseText == '') ? [] : responseText
                        });
                        observer.complete();
                    }
                    else {
                        observer.error({ 'success': false, 'res': xhr });
                    }
                }
            };
            xhr.responseType = 'arraybuffer';
            xhr.open((params ? 'POST' : 'GET'), url, true);
            xhr.setRequestHeader('Content-Type', 'application/json; charset=utf8');
            xhr.setRequestHeader('Token', localStorage.getItem('__SBM-SHARED__/token'));
            xhr.setRequestHeader('IP', localStorage.getItem('__SBM-SHARED__/meu-ip'));
            if (localStorage.getItem('__SBM-SABIUM-BPM__/wf-task')) {
                xhr.setRequestHeader('wf-task', localStorage.getItem('__SBM-SABIUM-BPM__/wf-task'));
            }
            xhr.timeout = 1000 * timeout;
            xhr.ontimeout = function () {
                observer.error({ 'success': false, 'res': xhr });
            };
            xhr.send((params ? JSON.stringify(params) : null));
        });
    };
    ReqHttpService.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    ReqHttpService.ctorParameters = function () { return [
        { type: router_1.Router, },
        { type: sharedService_1.SharedService, },
        { type: web_sql_service_1.WebSqlService, },
    ]; };
    return ReqHttpService;
}());
exports.ReqHttpService = ReqHttpService;
